;***************************************
;*** GreenForce Player *** GF-Player ***
;*** http://GFP.RRSoftware.de **********
;*** (c) 2009 - 2012 RocketRider *******
;***************************************
EnableExplicit

XIncludeFile "GFP_DShow_Header.pbi"
XIncludeFile "GFP_DShow_Helper2.pbi"

Enumeration
  #RENDERER_DEFAULT ; Default renderer for audio and video         
  #RENDERER_VMR9
  #RENDERER_VMR7
  #RENDERER_OLDVIDEO     
  #RENDERER_OVERLAYMIXER
  #RENDERER_DSHOWDEFAULT
  #RENDERER_WAVEOUT   
  #RENDERER_DSOUND
EndEnumeration

Enumeration
  #DVDCONTROL_LEFT
  #DVDCONTROL_RIGHT
  #DVDCONTROL_UP
  #DVDCONTROL_DOWN
  #DVDCONTROL_ACTIVATE
EndEnumeration

Prototype.i __Direct3DCreate9(iVersion.i)
Prototype.i __Direct3DCreate9Ex(iVersion.i,*lpD3D)
Prototype.i ThreadedSeekCallBack()

;===============================================================================
; Own Surface Allocator
;===============================================================================

Structure SVMRSurfaceAllocator9
  VTable.i
  pQueryInterface.i
  pAddRef.i
  pRelease.i
  pInitializeDevice.i
  pTerminateDevice.i
  pGetSurface.i
  pAdviseNotify.i  
  
  m_RefCount.i
  
  m_lpIVMRSurfAllocNotify.IVMRSurfaceAllocatorNotify9
  m_D3D.IDirect3D9Ex
  m_D3DDev.IDirect3DDevice9Ex
  m_D3DWnd.D3DPresent_Parameters
  m_BkWidth.i
  m_BkHeight.i 
  m_hwnd.i
  m_IsD3D9Ex.i  
  m_UseFlipEx.i
  
  *m_Surfaces.long  
  m_NumSurfaces.i
  m_MediaObj.i
  m_hMutex.i
EndStructure

Structure SVMRImagePresenter9
  VTable.i
  
  pQueryInterface.i
  pAddRef.i
  pRelease.i
  pStartPresenting.i
  pStopPresenting.i
  pPresentImage.i
  
  m_RefCount.i
  ;m_D3D.IDirect3D9
  ;m_D3DWnd.D3DPresent_Parameters
  ;m_D3DDev.IDirect3DDevice9
  m_MediaObj.i
  
  *m_Allocator.SVMRSurfaceAllocator9
  m_hMutex.i
EndStructure


;2010-08-02
Structure __MyColoredSpriteVertex
  x.f
  y.f
  z.f
  rhw.f
  Color.l
  tu.f
  tv.f
EndStructure 

Structure __DisplayColoredSprite
  v.__MyColoredSpriteVertex[4]
EndStructure
;
;===============================================================================


Structure DSHOW_MEDIABASE
  pVideoRender.IBaseFilter
  pAudioRender.IBaseFilter
  pGraphBuilder._IGraphBuilder
  pDVDGraphBuilder.IDVDGraphBuilder
  pControl.IMediaControl
  pEvent.IMediaEventEx
  pWindow.IVideoWindow
  pAudio.IBasicAudio
  pVideo.IBasicVideo2
  pSeeking._IMediaSeeking
  pVMR7Window.IVMRWindowlessControl
  pVMR9Window.IVMRWindowlessControl9
  pDVDControl._IDvdControl2
  pDVDInfo._IDvdInfo2
  hWnd.i
  bAspectCalculated.i
  fAspect.f
  bWindowless.i
  iVideoRenderer.i
  iAudioRenderer.i
  bAutoDVDControl.i
  bAllowEraseBackground.i
  bBackgroundErased.i
  ;sVolume.s{#MAX_PATH}
  src.RECT
  dst.RECT
  iSourceWidth.i
  iDestWidth.i
  iSourceHeight.i
  iDestHeight.i
  
  pSample.ISampleGrabber
  *AudioSampleBuffer
  iAudioSampleLength.i
  iAudioSampleChannels.i
  iAudioSampleBitsPerSample.i
  iAudioSampleSamplesPerSec.i
  iAudioSampleLastLength.i
  
  bIsRenderlessVMR9.i
  m_AllocatorImageWidth.i
  m_AllocatorImageHeight.i
  m_AllocatorAspectX.f
  m_AllocatorAspectY.f
  pAllocator.SVMRSurfaceAllocator9
  pImagePresenter.SVMRImagePresenter9
  iUserId.i
  hMutex.i
  
  ;2010-07-23 neu
  pVMR9Mixer.IVMRMixerBitmap9
  pVMR7Mixer.IVMRMixerBitmap 
  
  ;2010-08-02 neu
  OverlayImage.i
  *OverlayTexture.IDirect3DTexture9
  OverlayUseColorKey.i
  OverlayColorKey.i
  OverlaySrcRect.NORMALIZEDRECT
  OverlayDstRect.NORMALIZEDRECT
  OverlayAlpha.f
  OverlayCreated.i
  
  bRenderlessVMR9DrawBorder.i
  iRenderlessVMR9BorderColor.i  
  
  bRenderlessVMR9PresentCalled.i
  
  ;Threaded Seeking
  hThreadSeekMutex.i
  qThreadSeekPosition.q
  iThreadSeekResult.i
  ;Threaded Seeking end
  
  bForceVMR7Overlay.i
  ;bForceVMR7OverlaySuccess.i ;2011-04-08
  
EndStructure


Declare.i DShow_DVDKeyControl(*obj.DSHOW_MEDIABASE, iContorl.i)
Declare.i DShow_DVDMouseControl(*obj.DSHOW_MEDIABASE,x.i, y.i, bActive.i)
Declare.i DShow_ProcessMediaEvent(*obj.DSHOW_MEDIABASE)
Declare.i DShow_GetMediaWidth(*obj.DSHOW_MEDIABASE)
Declare.i DShow_GetMediaHeight(*obj.DSHOW_MEDIABASE)
Declare.i DShow_MediaSeek(*obj.DSHOW_MEDIABASE, qPosition.q)

Procedure.l L(*Pointer, sString.s) ; Convert to unicode
  PokeS(*Pointer, sString, Len(sString), #PB_Unicode)
  ProcedureReturn *Pointer 
EndProcedure 


Global NewList __ValidMediaObjects.i()
Global DSHOW_D3D9DLL, DSHOW_DWMAPIDLL, DSHOW_UseD3D9Ex, DSHOW_OVERLAY_FAILED
;Global DSHOW_ENABLE_RENDERER_TESTING = #False ; 2011-07-28
;Global DSHOW_IS_RENDERER_EQUAL = #False ; 2011-07-28

Macro __MediaDebug(sText)
  ;Debug sText
  WriteLog(sText, #LOGLEVEL_DEBUG)
EndMacro

Macro __MediaError(sText)
  ;Debug sText
  WriteLog(sText, #LOGLEVEL_ERROR)
EndMacro


; Procedure __MediaDebugLow(sText.s)
;  Debug sText
;  ;WriteLog(sText, #LOGLEVEL_DEBUG)
; EndProcedure

; 
; Procedure __FreeD3D9_SVMRImagePresenter9(*p.SVMRImagePresenter9)
;   If *p\m_D3DDev
;     *p\m_D3DDev\Release()
;     *p\m_D3DDev = #Null
;   EndIf
;   
;   If *p\m_D3D
;     *p\m_D3D\Release()
;     *p\m_D3D = #Null
;   EndIf
;     
; ;   If *p\m_D3DDLL
; ;     FreeLibrary_(*p\m_D3DDLL)
; ;     *p\m_D3DDLL = #Null
; ;   EndIf
; EndProcedure

Prototype.i ____DwmIsCompositionEnabled(*ptrEnabled)

Procedure ___IsDWMEnabled()
  Protected DwmIsCompositionEnabled.____DwmIsCompositionEnabled, bDWMEnabled.i = #False
  
  DwmIsCompositionEnabled = GetProcAddress_(DSHOW_DWMAPIDLL, "DwmIsCompositionEnabled")
  If DwmIsCompositionEnabled
    DwmIsCompositionEnabled(@bDWMEnabled)
  EndIf
  ProcedureReturn bDWMEnabled
EndProcedure

Procedure ___CopyAndResizeImageWith32Bits(image, newWidth, newHeight)
  Protected newImage
  If IsImage(image)
    newImage = CreateImage(#PB_Any, newWidth, newHeight, 32)
    If newImage
      StartDrawing(ImageOutput(newImage))
      DrawImage(ImageID(image), 0,0, newWidth, newHeight)
      StopDrawing()
    EndIf
  EndIf
  ProcedureReturn newImage
EndProcedure  

Procedure ___CopyWith32Bits(image)
  Protected newImage
  If IsImage(image)
    
    If ImageDepth(image) = 32
      newImage = CopyImage(image,#PB_Any)
    Else
      newImage = CreateImage(#PB_Any, ImageWidth(image), ImageHeight(image), 32)
      If newImage
        StartDrawing(ImageOutput(newImage))
        DrawImage(ImageID(image), 0,0, ImageWidth(image), ImageHeight(image))
        StopDrawing()
      EndIf
    EndIf
  EndIf
  ProcedureReturn newImage
EndProcedure  

Procedure ___CreateD3D9TextureFromImage(*dev.IDirect3DDevice9, image, UseColorKey, ColorKey, bIsD3D9Ex)
  Protected bOk = #False, color, x,y, newWidth, newHeight, d3drect.D3DLOCKED_RECT, Tex.Idirect3DTexture9, NewTex.Idirect3DTexture9, pitch, *orgSrcPtr.LONG, *srcPtr.LONG, *dstPtr.LONG
  If *dev
    If IsImage(image)
      If ImageDepth(image) = 32
        newWidth = ImageWidth(image)
        newHeight = ImageHeight(image)   
        ;newImage = CreateImage(#PB_Any, newWidth, newHeigh, 32)
        
        ColorKey & $FFFFFF
        
        If bIsD3D9Ex
          *dev\CreateTexture(newWidth, newHeight, 1 , 0, #D3DFMT_A8R8G8B8, #D3DPOOL_SYSTEMMEM, @Tex.IDirect3DTexture9, #Null )
        Else
          *dev\CreateTexture(newWidth, newHeight, 1 , 0, #D3DFMT_A8R8G8B8, #D3DPOOL_MANAGED, @Tex.IDirect3DTexture9, #Null )     
        EndIf
        
        If Tex
          If Tex\LockRect(0, d3drect, #Null, 0) = #S_OK     
            StartDrawing(ImageOutput(image))
            *orgSrcPtr.LONG = DrawingBuffer()
            pitch = DrawingBufferPitch()
            
            For y=0 To newHeight-1
              *srcPtr = *orgSrcPtr + pitch * (newHeight - 1  - y)
              *dstPtr = d3drect\pBits + d3drect\Pitch * y
              If UseColorKey
                For x = 0 To newWidth - 1
                  color = *srcPtr\l
                  ;                 If (color & $FFFFFF = ColorKey)
                  ;                   color = (((color) & 255) << 16) + (color & $00FF00) + ((color >> 16) & 255)
                  ;                 Else
                  ;                   color = (((color) & 255) << 16) + (color & $00FF00) + ((color >> 16) & 255) + $FF000000
                  ;                 EndIf
                  If (color & $FFFFFF = ColorKey)
                    *dstPtr\l = color & $FFFFFF
                  Else
                    *dstPtr\l = color & $FFFFFF + $FF << 24                  
                  EndIf                
                  
                  *srcPtr + SizeOf(LONG)  
                  *dstPtr + SizeOf(LONG)  
                Next
              Else
                CopyMemory(*srcPtr, *dstPtr, newWidth * SizeOf(LONG) )
                ;               For x = 0 To newWidth - 1
                ;                 color = *srcPtr\l
                ;                 
                ;                 color = (color & $FF00FF00) | ((color >> 16) & 255)  | ((color & 255) << 16) 
                ;                 
                ;                 *dstPtr\l = color
                ;                 *srcPtr + SizeOf(LONG)  
                ;                 *dstPtr + SizeOf(LONG)  
                ;               Next              
              EndIf
              
            Next
            StopDrawing()
            
            Tex\UnlockRect(0)
            bOk = #True
          EndIf
        EndIf
      EndIf
    EndIf
  EndIf
  
  If bIsD3D9Ex And bOk
    If Tex
      *dev\CreateTexture(newWidth, newHeight, 1 , 0, #D3DFMT_A8R8G8B8, #D3DPOOL_DEFAULT, @NewTex.IDirect3DTexture9, #Null ) 
      If NewTex
        If *dev\UpdateTexture(Tex, NewTex) <> #S_OK
          bOk = #True  
        EndIf
      EndIf  
      Tex\Release()   
      Tex = #Null
      Tex = NewTex
    EndIf
  EndIf
  
  If Tex And bOk = #False
    Tex\Release()
    Tex = #Null    
  EndIf
  
  ProcedureReturn Tex
EndProcedure

Procedure ___FreeD3D9_SVMRSurfaceAllocator9(*p.SVMRSurfaceAllocator9)
  Protected *base.DSHOW_MEDIABASE
  If *p
    
    ;2010-08-02
    If *p\m_MediaObj
      *base = *p\m_MediaObj
      
      If *base\OverlayImage
        FreeImage(*base\OverlayImage)
        *base\OverlayImage = #Null
      EndIf
      
      If *base\OverlayTexture
        *base\OverlayTexture\Release()
        *base\OverlayTexture = #Null  
      EndIf
    EndIf  
    
    If *p\m_D3DDev
      *p\m_D3DDev\Release()
      *p\m_D3DDev = #Null
    EndIf
    
    If *p\m_D3D
      *p\m_D3D\Release()
      *p\m_D3D = #Null
    EndIf
  EndIf
  ;   If *p\m_D3DDLL
  ;     FreeLibrary_(*p\m_D3DDLL)
  ;     *p\m_D3DDLL = #Null
  ;   EndIf
EndProcedure

Procedure __FreeD3D9_SVMRSurfaceAllocator9(*p.SVMRSurfaceAllocator9)
  __MediaDebug("Try Terminate D3D9 Device")
  ProcedureReturn ___FreeD3D9_SVMRSurfaceAllocator9(*p)
EndProcedure

Procedure __DeleteSurfaces_SVMRSurfaceAllocator9(*p.SVMRSurfaceAllocator9)
  Protected i, *ptr.integer, *Surf.IDirect3DSurface9
  If *p
    If *p\m_Surfaces 
      For i = 0 To *p\m_NumSurfaces-1
        *ptr.integer = *p\m_Surfaces + i * SizeOf(Integer)
        *Surf.IDirect3DSurface9 = *ptr\i
        *ptr\i = #Null
        If *Surf
          *Surf\Release()
        EndIf  
      Next 
      FreeMemory(*p\m_Surfaces)
      *p\m_Surfaces = #Null
    EndIf
  EndIf
EndProcedure

Procedure __GetSizeFromDesktopOfWindow(hWnd, *width.integer, *height.integer) 
  Protected NbDesktops, k,reWnd.rect, reDesk.rect, reTmp.RECT
  NbDesktops = ExamineDesktops()
  For k=0 To NbDesktops-1
    
    If k=0
      *width\i = DesktopWidth(k)
      *height\i = DesktopHeight(k)      
    EndIf  
    
    reDesk\top  = DesktopY(k)
    reDesk\left  = DesktopX(k)
    reDesk\bottom  = DesktopY(k) + DesktopWidth(k)
    reDesk\left  = DesktopX(k) + DesktopHeight(k)
    GetWindowRect_(hWnd, reWnd)
    If IntersectRect_(reTmp, reDesk, reWnd)
      *width\i = DesktopWidth(k)
      *height\i = DesktopHeight(k)
      Break
    EndIf
  Next
EndProcedure

; Procedure __InitD3D9_SVMRImagePresenter9(*p.SVMRImagePresenter9, hWnd.i)
;   Protected bResult = #False, pres.D3DPresent_Parameters , iWidth, iHeight,Direct3DCreate9.__Direct3DCreate9
;   __GetSizeFromDesktopOfWindow(hWnd, @iWidth, @iHeight) 
;    
;   *p\m_BkWidth = iWidth
;   *p\m_BkHeight = iHeight
;   *p\m_D3D = #Null
;   *p\m_D3DDev = #Null 
;   
;   If DSHOW_D3D9DLL <> #Null
; 
;     Direct3DCreate9.__Direct3DCreate9 = GetProcAddress_(DSHOW_D3D9DLL, "Direct3DCreate9")
;     
;     If Direct3DCreate9
;       *p\m_D3D = Direct3DCreate9(#D3D_SDK_VERSION) 
;     EndIf
;     
;     If *p\m_D3D
;       
;       *p\m_hwnd = hWnd
;       *p\m_D3DWnd\Windowed = #True
;       *p\m_D3DWnd\SwapEffect = #D3DSWAPEFFECT_DISCARD
;       *p\m_D3DWnd\BackBufferWidth = iWidth 
;       *p\m_D3DWnd\BackBufferHeight = iHeight
;       *p\m_D3DWnd\EnableAutoDepthStencil = #True ; use a z-buffer, or it will look ugly
;       *p\m_D3DWnd\AutoDepthStencilFormat = #D3DFMT_D16
;       *p\m_D3DWnd\flags = #D3DPRESENTFLAG_LOCKABLE_BACKBUFFER
;       *p\m_D3DWnd\BackBufferFormat = #D3DFMT_X8R8G8B8     
;       CopyMemory(*p\m_D3DWnd, pres, SizeOf(D3DPresent_Parameters))
;            
;       *p\m_D3D\CreateDevice(#D3DADAPTER_DEFAULT, #D3DDEVTYPE_HAL, hWnd, #D3DCREATE_SOFTWARE_VERTEXPROCESSING | #D3DCREATE_MULTITHREADED, pres, @*p\m_D3DDev) 
;       If *p\m_D3DDev = #Null
;          *p\m_D3DWnd\BackBufferFormat = #D3DFMT_R5G6B5    
;          CopyMemory(*p\m_D3DWnd, pres, SizeOf(D3DPresent_Parameters))
;          *p\m_D3D\CreateDevice(#D3DADAPTER_DEFAULT, #D3DDEVTYPE_HAL, hWnd, #D3DCREATE_SOFTWARE_VERTEXPROCESSING | #D3DCREATE_MULTITHREADED, pres, @*p\m_D3DDev)    
;       EndIf
;       If *p\m_D3DDev = #Null
;          *p\m_D3DWnd\BackBufferFormat = #D3DFMT_X1R5G5B5    
;          CopyMemory(*p\m_D3DWnd, pres, SizeOf(D3DPresent_Parameters))
;          *p\m_D3D\CreateDevice(#D3DADAPTER_DEFAULT, #D3DDEVTYPE_HAL, hWnd, #D3DCREATE_SOFTWARE_VERTEXPROCESSING | #D3DCREATE_MULTITHREADED, pres, @*p\m_D3DDev)    
;       EndIf      
;       If *p\m_D3DDev = #Null
;          *p\m_D3DWnd\BackBufferFormat = #D3DFMT_R8G8B8   
;          CopyMemory(*p\m_D3DWnd, pres, SizeOf(D3DPresent_Parameters))
;          *p\m_D3D\CreateDevice(#D3DADAPTER_DEFAULT, #D3DDEVTYPE_HAL, hWnd, #D3DCREATE_SOFTWARE_VERTEXPROCESSING | #D3DCREATE_MULTITHREADED, pres, @*p\m_D3DDev)    
;       EndIf 
;       If *p\m_D3DDev
;         bResult = #True
;       Else
;         *p\m_D3D\Release()
;       EndIf
;             
;     EndIf 
;   EndIf
;   ProcedureReturn bResult
; EndProcedure


Procedure __InitD3D9_SVMRSurfaceAllocator9(*p.SVMRSurfaceAllocator9, hWnd.i)
  Protected bResult = #False, pres.D3DPresent_Parameters , iWidth, iHeight
  Protected Direct3DCreate9.__Direct3DCreate9, Direct3DCreate9Ex.__Direct3DCreate9Ex
  __MediaDebug("Try Initialize D3D9 Device")
  __GetSizeFromDesktopOfWindow(hWnd, @iWidth, @iHeight) 
  
  __MediaDebug("releasing old d3d9 objects...")
  ___FreeD3D9_SVMRSurfaceAllocator9(*p)  
  
  *p\m_BkWidth = iWidth
  *p\m_BkHeight = iHeight
  *p\m_D3D = #Null
  *p\m_D3DDev = #Null 
  If *p\m_hMutex
    LockMutex(*p\m_hMutex)
  EndIf  
  
  If DSHOW_D3D9DLL <> #Null
    
    Direct3DCreate9.__Direct3DCreate9 = GetProcAddress_(DSHOW_D3D9DLL, "Direct3DCreate9")
    Direct3DCreate9Ex.__Direct3DCreate9Ex = GetProcAddress_(DSHOW_D3D9DLL, "Direct3DCreate9Ex")  
    
    
    If DSHOW_UseD3D9Ex And Direct3DCreate9Ex
      
      Direct3DCreate9Ex(#D3D_SDK_VERSION, @*p\m_D3D) 
      
      If *p\m_D3D    
        *p\m_hwnd = hWnd
        *p\m_D3DWnd\Windowed = #True
        ;Cannot be #D3DSWAPEFFECT_DISCARD discard, beacause we want to redraw itin the Callback!!! 
        
        If ___IsDWMEnabled() And (OSVersion() >= #PB_OS_Windows_7);2013-04-03 ((OSVersion() = #PB_OS_Windows_7) Or (OSVersion() = #PB_OS_Windows_Future))        
          *p\m_D3DWnd\SwapEffect = #D3DSWAPEFFECT_FLIPEX;#D3DSWAPEFFECT_DISCARD
          *p\m_D3DWnd\BackBufferCount = 2 ; 2-4 is recommended according to dxsdk
          *p\m_UseFlipEx = #True
        Else
          *p\m_D3DWnd\SwapEffect = #D3DSWAPEFFECT_COPY;#D3DSWAPEFFECT_DISCARD  
          *p\m_UseFlipEx = #False
        EndIf
        
        
        *p\m_D3DWnd\BackBufferWidth = iWidth 
        *p\m_D3DWnd\BackBufferHeight = iHeight
        *p\m_D3DWnd\EnableAutoDepthStencil = #False ;#True ; use a z-buffer, or it will look ugly
        *p\m_D3DWnd\AutoDepthStencilFormat = 0;#D3DFMT_D16
        *p\m_D3DWnd\flags = 0;#D3DPRESENTFLAG_LOCKABLE_BACKBUFFER (does not work with FLIPEX)
        *p\m_D3DWnd\BackBufferFormat = #D3DFMT_X8R8G8B8     
        CopyMemory(*p\m_D3DWnd, pres, SizeOf(D3DPresent_Parameters))
        
        *p\m_D3D\CreateDeviceEx(#D3DADAPTER_DEFAULT, #D3DDEVTYPE_HAL, hWnd, #D3DCREATE_SOFTWARE_VERTEXPROCESSING | #D3DCREATE_MULTITHREADED, pres, #Null, @*p\m_D3DDev) 
        If *p\m_D3DDev = #Null
          *p\m_D3DWnd\BackBufferFormat = #D3DFMT_R5G6B5    
          CopyMemory(*p\m_D3DWnd, pres, SizeOf(D3DPresent_Parameters))
          *p\m_D3D\CreateDeviceEx(#D3DADAPTER_DEFAULT, #D3DDEVTYPE_HAL, hWnd, #D3DCREATE_SOFTWARE_VERTEXPROCESSING | #D3DCREATE_MULTITHREADED, pres, #Null, @*p\m_D3DDev)    
        EndIf
        If *p\m_D3DDev = #Null
          *p\m_D3DWnd\BackBufferFormat = #D3DFMT_X1R5G5B5    
          CopyMemory(*p\m_D3DWnd, pres, SizeOf(D3DPresent_Parameters))
          *p\m_D3D\CreateDeviceEx(#D3DADAPTER_DEFAULT, #D3DDEVTYPE_HAL, hWnd, #D3DCREATE_SOFTWARE_VERTEXPROCESSING | #D3DCREATE_MULTITHREADED, pres, #Null, @*p\m_D3DDev)    
        EndIf      
        If *p\m_D3DDev = #Null
          *p\m_D3DWnd\BackBufferFormat = #D3DFMT_R8G8B8   
          CopyMemory(*p\m_D3DWnd, pres, SizeOf(D3DPresent_Parameters))
          *p\m_D3D\CreateDeviceEx(#D3DADAPTER_DEFAULT, #D3DDEVTYPE_HAL, hWnd, #D3DCREATE_SOFTWARE_VERTEXPROCESSING | #D3DCREATE_MULTITHREADED, pres, #Null, @*p\m_D3DDev)    
        EndIf     
        
        If *p\m_D3DDev
          *p\m_IsD3D9Ex = #True
          bResult = #True
          __MediaDebug("D3D9 Device created")
        Else
          *p\m_D3D\Release()
          *p\m_D3D = #Null ;CHANGE 02-12-2012
        EndIf
      Else
        __MediaDebug("Warn: Cannot create D3D9Ex!")
      EndIf 
      
    EndIf
    
    ;Try create D3D9  if D3D9EX Fails!
    If bResult = #False
      If *p\m_D3D
        *p\m_D3D\Release()
        *p\m_D3D = #Null
      EndIf
      
      If *p\m_D3D = #Null
        If Direct3DCreate9
          *p\m_D3D = Direct3DCreate9(#D3D_SDK_VERSION) 
        EndIf
      EndIf
      
      If *p\m_D3D    
        *p\m_hwnd = hWnd
        *p\m_D3DWnd\Windowed = #True
        ;Cannot be #D3DSWAPEFFECT_DISCARD discard, beacause we want to redraw itin the Callback!!! 
        *p\m_D3DWnd\SwapEffect = #D3DSWAPEFFECT_COPY;#D3DSWAPEFFECT_DISCARD
        *p\m_D3DWnd\BackBufferWidth = iWidth 
        *p\m_D3DWnd\BackBufferHeight = iHeight
        *p\m_D3DWnd\EnableAutoDepthStencil = #False ;#True ; use a z-buffer, or it will look ugly
        *p\m_D3DWnd\AutoDepthStencilFormat = 0;#D3DFMT_D16
        *p\m_D3DWnd\flags = 0;#D3DPRESENTFLAG_LOCKABLE_BACKBUFFER
        *p\m_D3DWnd\BackBufferFormat = #D3DFMT_X8R8G8B8     
        CopyMemory(*p\m_D3DWnd, pres, SizeOf(D3DPresent_Parameters))
        
        *p\m_D3D\CreateDevice(#D3DADAPTER_DEFAULT, #D3DDEVTYPE_HAL, hWnd, #D3DCREATE_SOFTWARE_VERTEXPROCESSING | #D3DCREATE_MULTITHREADED, pres, @*p\m_D3DDev) 
        If *p\m_D3DDev = #Null
          *p\m_D3DWnd\BackBufferFormat = #D3DFMT_R5G6B5    
          CopyMemory(*p\m_D3DWnd, pres, SizeOf(D3DPresent_Parameters))
          *p\m_D3D\CreateDevice(#D3DADAPTER_DEFAULT, #D3DDEVTYPE_HAL, hWnd, #D3DCREATE_SOFTWARE_VERTEXPROCESSING | #D3DCREATE_MULTITHREADED, pres, @*p\m_D3DDev)    
        EndIf
        If *p\m_D3DDev = #Null
          *p\m_D3DWnd\BackBufferFormat = #D3DFMT_X1R5G5B5    
          CopyMemory(*p\m_D3DWnd, pres, SizeOf(D3DPresent_Parameters))
          *p\m_D3D\CreateDevice(#D3DADAPTER_DEFAULT, #D3DDEVTYPE_HAL, hWnd, #D3DCREATE_SOFTWARE_VERTEXPROCESSING | #D3DCREATE_MULTITHREADED, pres, @*p\m_D3DDev)    
        EndIf      
        If *p\m_D3DDev = #Null
          *p\m_D3DWnd\BackBufferFormat = #D3DFMT_R8G8B8   
          CopyMemory(*p\m_D3DWnd, pres, SizeOf(D3DPresent_Parameters))
          *p\m_D3D\CreateDevice(#D3DADAPTER_DEFAULT, #D3DDEVTYPE_HAL, hWnd, #D3DCREATE_SOFTWARE_VERTEXPROCESSING | #D3DCREATE_MULTITHREADED, pres, @*p\m_D3DDev)    
        EndIf 
        
        If *p\m_D3DDev
          *p\m_UseFlipEx = #False
          *p\m_IsD3D9Ex = #False
          bResult = #True
          __MediaDebug("D3D9 Device created")
        Else
          *p\m_D3D\Release()
          *p\m_D3D = #Null ; CHANGE 02-12-2012
        EndIf
      Else
        __MediaError("Error: Cannot create D3D9!")
      EndIf      
    EndIf
    
  EndIf
  
  
  If *p\m_hMutex
    UnlockMutex(*p\m_hMutex)
  EndIf  
  ProcedureReturn bResult
EndProcedure


Procedure __SVMRImagePresenter9_AddRef(*p.SVMRImagePresenter9)
  InterlockedIncrement_(@*p\m_RefCount) ; + 1
  ProcedureReturn *p\m_RefCount 
EndProcedure

Procedure __SVMRImagePresenter9_QueryInterface(*p.SVMRImagePresenter9, GUID.i, lpInterface.i)
  Protected pMem
  StringFromIID_(GUID,@pMem)
  If pMem
    __MediaDebug("SVMRImagePresenter9_QueryInterface "+PeekS(pMem,-1,#PB_Unicode))
    CoTaskMemFree_(pMem)
  EndIf
  ProcedureReturn #E_NOINTERFACE
EndProcedure

Procedure __SVMRImagePresenter9_Release(*p.SVMRImagePresenter9)
  ; ; - 1
  ;   If *p\m_RefCount <= 0
  ;     __FreeD3D9_SVMRImagePresenter9(*p)
  ;   EndIf
  ;  ProcedureReturn *p\m_RefCount 
  ProcedureReturn InterlockedDecrement_(@*p\m_RefCount) ; 2010-08-08
EndProcedure



Procedure __SVMRImagePresenter9_StartPresenting(*p.SVMRImagePresenter9,*dwUserID)
  If *p\m_Allocator
    If *p\m_Allocator\m_D3DDev
      ProcedureReturn #S_OK
    EndIf
  EndIf
  ProcedureReturn #E_FAIL
EndProcedure

Procedure __SVMRImagePresenter9_StopPresenting(*p.SVMRImagePresenter9,*dwUserID)
  ProcedureReturn #S_OK
EndProcedure

; 
; Procedure TEST_RESTORE(*p.SVMRImagePresenter9)
;    Protected *base.DSHOW_MEDIABASE, TimeOut.i,*BackBuffer.IDirect3DSurface9, hMonitor, iResult, iFinalResult, pres.D3DPresent_Parameters, *Allocator.IVMRSurfaceAllocator9
;       *base.DSHOW_MEDIABASE = *p\m_MediaObj
;                __InitD3D9_SVMRImagePresenter9(*p,*p\m_hwnd)
;             hMonitor = *p\m_D3D\GetAdapterMonitor(#D3DADAPTER_DEFAULT );         
;             iResult = *base\pAllocator\m_lpIVMRSurfAllocNotify\ChangeD3DDevice(*p\m_D3DDev, hMonitor) 
;  EndProcedure

Procedure __SVMRImagePresenter9_PresentImage(*p.SVMRImagePresenter9, dwUserID,  *lpPresInfo.VMR9PresentationInfo)
  Protected *base.DSHOW_MEDIABASE = #Null,*BackBuffer.IDirect3DSurface9, iResult, *Allocator.IVMRSurfaceAllocator9
  Protected *D3DDev.IDirect3DDevice9, tmpDst.RECT, desc.D3DSURFACE_DESC,  v.__DisplayColoredSprite, iAlpha
  ;Protected scrRe.RECT, TimeOut.i, iFinalResult, hMonitor, pres.D3DPresent_Parameters
  Protected *srcRectPtr.RECT
  
  ;Used when we should draw the border...
  Protected *dstRectPtr.RECT
  Protected wndRect.RECT, BorderSizeX.f, BorderSizeY.f, VideoWidth.f, VideoHeight.f
  Protected fTmpRectLeft.f, fTmpRectRight.f, fTmpRectTop.f, fTmpRectBottom.f
  Protected fMulX.f, fMulY.f
  
  If *p\m_hMutex
    LockMutex(*p\m_hMutex)
  EndIf  
  
  *D3DDev = #Null
  If *p\m_Allocator
    *D3DDev = *p\m_Allocator\m_D3DDev  
  EndIf
  
  
  If *D3DDev ;= #Null   
    If *lpPresInfo
      
      If *p\m_MediaObj
        *base = *p\m_MediaObj
      Else
        *base = #Null
      EndIf
      
      *base\bRenderlessVMR9PresentCalled = #True ;2012-08-18 indicate that present was called at least once
      ; needed because on Vista Machine VMR 9 Renderless created sucessfully, but rendering occurs windowed
      ; In this case there are redraw bugs if background is not cleared      
      
      If *base
        *base\m_AllocatorAspectX = *lpPresInfo\szAspectRatio\cx
        *base\m_AllocatorAspectY = *lpPresInfo\szAspectRatio\cy
      EndIf
      
      ;   If *p\m_Allocator
      ;     scrRe\right = *p\m_Allocator\m_BkWidth
      ;     scrRe\bottom = *p\m_Allocator\m_BkHeight
      ;   EndIf
      ;   
      ;   If *base
      ;     IntersectRect_(tmpDst, *base\dst, scrRe)
      ;   EndIf
      
      ;  tmpDst\right = *base\m_AllocatorImageWidth
      ;  tmpDst\bottom = *base\m_AllocatorImageHeight
      iResult = *D3DDev\TestCooperativeLevel()
      
      ;Resitting device must be done in DShow_ProcessEvents(), because  PresentImage wil not be called again, if the device is lost, but cannot be resetted yet
      
      
      ;   Debug "result is "+Hex(iResult)
      ;   
      ;   If iResult=#D3DERR_DRIVERINTERNALERROR: __MediaDebugLow("SVMRImagePresenter9_PresentImage fails with error code D3DERR_DRIVERINTERNALERROR"):ProcedureReturn #D3DERR_DRIVERINTERNALERROR:EndIf
      ;         
      ;   If iResult=#D3DERR_DEVICELOST
      ;     TimeOut=GetTickCount_()
      ;     Repeat
      ;       Sleep_(1)
      ;       iResult=*p\m_D3DDev\TestCooperativeLevel()
      ;     Until iResult=#D3DERR_DRIVERINTERNALERROR Or iResult=#D3DERR_DEVICENOTRESET Or iResult = #D3D_OK Or GetTickCount_() - TimeOut > 25600
      ;     
      ;     ;Device still lost...   
      ;     If iResult=#D3DERR_DEVICELOST:__MediaDebugLow("SVMRImagePresenter9_PresentImage device still lost"):ProcedureReturn #D3DERR_DEVICELOST:EndIf  
      ;     If iResult=#D3DERR_DRIVERINTERNALERROR: __MediaDebugLow("SVMRImagePresenter9_PresentImage fails with error code D3DERR_DRIVERINTERNALERROR"):ProcedureReturn #D3DERR_DRIVERINTERNALERROR:EndIf
      ;                  
      ;   EndIf
      ;     
      ;   If iResult=#D3DERR_DEVICENOTRESET ;Restore Device
      ;     
      ;     *base.DSHOW_MEDIABASE = *p\m_MediaObj
      ;     If *base
      ;       
      ;       If *base\pAllocator
      ;         __DeleteSurfaces_SVMRSurfaceAllocator9(*base\pAllocator)
      ;         
      ;         CopyMemory(*p\m_D3dWnd, pres, SizeOf(D3DPresent_Parameters))
      ;         iResult = *p\m_D3DDev\Reset(pres)
      ;         If iResult =#S_OK
      ;           hMonitor = *p\m_D3D\GetAdapterMonitor(#D3DADAPTER_DEFAULT );         
      ;           iResult = *base\pAllocator\m_lpIVMRSurfAllocNotify\ChangeD3DDevice(*p\m_D3DDev, hMonitor)
      ;           If iResult <> #S_OK
      ;              __MediaDebugLow("SVMRImagePresenter9_PresentImage ChangeD3DDevice failed with code "+Hex(iResult))           
      ;           EndIf
      ;           
      ;         Else
      ;           __MediaDebugLow("SVMRImagePresenter9_PresentImage reset failed with code "+Hex(iResult))
      ;         EndIf     
      ;       Else
      ;         __MediaDebugLow("SVMRImagePresenter9_PresentImage pAllocator is null")     
      ;       EndIf
      ;     Else
      ;          __MediaDebugLow("SVMRImagePresenter9_PresentImage DSHOW_MEDIABASE is null")          
      ;     EndIf
      ;   EndIf
      
      ; If iResult=#D3DERR_DEVICELOST
      ;         *base.DSHOW_MEDIABASE = *p\m_MediaObj
      ;   iResult = *base\pAllocator\m_lpIVMRSurfAllocNotify\ChangeD3DDevice(#Null, hMonitor) 
      ; EndIf
      
      
      ;If *p\m_D3DDev\TestCooperativeLevel()=#D3DERR_DEVICENOTRESET
      
      
      ;    If iResult=#S_OK 
      ;       *base.DSHOW_MEDIABASE = *p\m_MediaObj
      ;       If *base
      ;         
      ;         If *base\pAllocator
      ;             __DeleteSurfaces_SVMRSurfaceAllocator9(*base\pAllocator)
      ;             ;__FreeD3D9_SVMRSurfaceAllocator9(*p)
      ;              __InitD3D9_SVMRImagePresenter9(*p,*p\m_hwnd)
      ;             hMonitor = *p\m_D3D\GetAdapterMonitor(#D3DADAPTER_DEFAULT );         
      ;             iResult = *base\pAllocator\m_lpIVMRSurfAllocNotify\ChangeD3DDevice(*p\m_D3DDev, hMonitor)          
      ;         Else
      ;           __MediaDebugLow("SVMRImagePresenter9_PresentImage pAllocator is null")     
      ;         EndIf
      ;       Else
      ;            __MediaDebugLow("SVMRImagePresenter9_PresentImage DSHOW_MEDIABASE is null")          
      ;       EndIf
      ;   ;  EndIf
      ;   EndIf
      
      If *base
        
        If *base\OverlayImage And *base\OverlayTexture = #Null And *base\OverlayCreated = #False
          *base\OverlayTexture = ___CreateD3d9TextureFromImage(*D3DDev, *base\OverlayImage, *base\OverlayUseColorKey, *base\OverlayColorKey, *base\pAllocator\m_IsD3D9Ex)   
          *base\OverlayCreated = #True ; prevents that we try it more than once (speed reason!)
        EndIf
        
        *srcRectPtr = *base\src
        If *srcRectPtr
          If *srcRectPtr\right <= 0 Or *srcRectPtr\bottom <= 0
            *srcRectPtr = #Null
          EndIf  
        EndIf
        
      Else
        *srcRectPtr = #Null
      EndIf
      
      
      If iResult = #S_OK ;Only draw if device is ready
        *D3DDev\GetBackBuffer(0,0,#D3DBACKBUFFER_TYPE_MONO,@*BackBuffer.IDirect3DSurface9)
        If *BackBuffer
          
          
          *BackBuffer\GetDesc(desc.D3DSURFACE_DESC)      
          
          *dstRectPtr = #Null
          If *base
            
            *D3DDev\Clear(0,#Null,#D3DCLEAR_TARGET, *base\iRenderlessVMR9BorderColor, 0.0, 0)           
            
            If *base\bRenderlessVMR9DrawBorder
              GetWindowRect_(*base\hWnd, wndRect)
              VideoWidth = (*base\dst\right - *base\dst\left)
              VideoHeight = (*base\dst\bottom - *base\dst\top)
              BorderSizeX = ((wndRect\right - wndRect\left) - VideoWidth)/2
              BorderSizeY = ((wndRect\bottom - wndRect\top) - VideoHeight)/2    
              
              
              fTmpRectLeft.f = BorderSizeX
              fTmpRectTop.f = BorderSizeY
              fTmpRectRight.f = BorderSizeX + VideoWidth
              fTmpRectBottom.f = BorderSizeY + VideoHeight 
              
              fMulX.f =  (desc\Width ) / (2 * BorderSizeX + VideoWidth)
              fMulY.f =  (desc\Height ) / (2 * BorderSizeY + VideoHeight)
              
              fTmpRectLeft * fMulX
              fTmpRectRight * fMulX
              
              fTmpRectTop * fMulY
              fTmpRectBottom * fMulY
              
              tmpDst\left = fTmpRectLeft
              tmpDst\top = fTmpRectTop
              tmpDst\right = fTmpRectRight    
              tmpDst\bottom = fTmpRectBottom
              
              ; some sanity checks!
              If tmpDst\left < 0:tmpDst\left = 0:EndIf
              If tmpDst\left > desc\Width:tmpDst\left = desc\Width:EndIf  
              If tmpDst\right < 0:tmpDst\right = 0:EndIf
              If tmpDst\right > desc\Width:tmpDst\right = desc\Width:EndIf        
              
              If tmpDst\top < 0:tmpDst\top = 0:EndIf
              If tmpDst\top > desc\Height:tmpDst\top = desc\Height:EndIf  
              If tmpDst\bottom< 0:tmpDst\bottom = 0:EndIf
              If tmpDst\bottom > desc\Height:tmpDst\bottom = desc\Height:EndIf
              
              
              *dstRectPtr = @tmpDst
            EndIf
          EndIf
          
          
          If *D3DDev\StretchRect( *lpPresInfo\lpSurf, #Null, *BackBuffer, *dstRectPtr, #D3DTEXF_LINEAR) <> #S_OK
            If *D3DDev\StretchRect( *lpPresInfo\lpSurf, *srcRectPtr, *BackBuffer, *dstRectPtr, #D3DTEXF_POINT) <> #S_OK
              If *D3DDev\StretchRect( *lpPresInfo\lpSurf, *srcRectPtr, *BackBuffer, *dstRectPtr, #D3DTEXF_NONE) <> # S_OK
                If *D3DDev\StretchRect( *lpPresInfo\lpSurf, #Null, *BackBuffer, *dstRectPtr, #D3DTEXF_NONE) ; Possibly wrong soruce rectangle
                  *D3DDev\StretchRect( *lpPresInfo\lpSurf, #Null, *BackBuffer, #Null, #D3DTEXF_NONE) ; last try... (looks not very good!)
                EndIf
              EndIf
            EndIf  
          EndIf  
          
          
          *BackBuffer\Release()  
          
          If *base
            If *base\OverlayTexture
              
              v.__DisplayColoredSprite
              
              iAlpha = *base\OverlayAlpha * 255
              If iAlpha > 255:iAlpha = 255:EndIf
              If iAlpha < 0 :iAlpha = 0:EndIf
              iAlpha = $FFFFFF + iAlpha << 24
              
              
              If *base\bRenderlessVMR9DrawBorder
                
                v\v[0]\tu = *base\OverlaySrcRect\left
                v\v[0]\tv = *base\OverlaySrcRect\top
                v\v[0]\Color = iAlpha
                v\v[0]\x = tmpDst\left + *base\OverlayDstRect\left * (desc\Width - tmpDst\left * 2); to be compatible with dshow... 
                v\v[0]\y = tmpDst\top  + *base\OverlayDstRect\top * (desc\Height - tmpDst\top * 2)
                v\v[0]\rhw = 1.0
                
                v\v[1]\tu = *base\OverlaySrcRect\right
                v\v[1]\tv = *base\OverlaySrcRect\top
                v\v[1]\Color = iAlpha
                v\v[1]\x = tmpDst\left + *base\OverlayDstRect\right * (desc\Width - tmpDst\left * 2)
                v\v[1]\y = tmpDst\top  + *base\OverlayDstRect\top * (desc\Height - tmpDst\top * 2)
                v\v[1]\rhw = 1.0
                
                v\v[2]\tu = *base\OverlaySrcRect\left
                v\v[2]\tv = *base\OverlaySrcRect\bottom
                v\v[2]\Color = iAlpha      
                v\v[2]\x = tmpDst\left + *base\OverlayDstRect\left * (desc\Width - tmpDst\left * 2)
                v\v[2]\y = tmpDst\top  + *base\OverlayDstRect\bottom * (desc\Height - tmpDst\top * 2)
                v\v[2]\rhw = 1.0
                
                v\v[3]\tu = *base\OverlaySrcRect\right
                v\v[3]\tv = *base\OverlaySrcRect\bottom
                v\v[3]\Color = iAlpha       
                v\v[3]\x = tmpDst\left + *base\OverlayDstRect\right * (desc\Width - tmpDst\left * 2)
                v\v[3]\y = tmpDst\top  + *base\OverlayDstRect\bottom * (desc\Height - tmpDst\top * 2)
                v\v[3]\rhw = 1.0                        
                
              Else
                
                
                v\v[0]\tu = *base\OverlaySrcRect\left
                v\v[0]\tv = *base\OverlaySrcRect\top
                v\v[0]\Color = iAlpha
                v\v[0]\x = *base\OverlayDstRect\left * desc\Width ; to be compatible with dshow... 
                v\v[0]\y = *base\OverlayDstRect\top * desc\Height
                v\v[0]\rhw = 1.0
                
                v\v[1]\tu = *base\OverlaySrcRect\right
                v\v[1]\tv = *base\OverlaySrcRect\top
                v\v[1]\Color = iAlpha
                v\v[1]\x = *base\OverlayDstRect\right * desc\Width
                v\v[1]\y = *base\OverlayDstRect\top * desc\Height
                v\v[1]\rhw = 1.0
                
                v\v[2]\tu = *base\OverlaySrcRect\left
                v\v[2]\tv = *base\OverlaySrcRect\bottom
                v\v[2]\Color = iAlpha      
                v\v[2]\x = *base\OverlayDstRect\left * desc\Width
                v\v[2]\y = *base\OverlayDstRect\bottom * desc\Height
                v\v[2]\rhw = 1.0
                
                v\v[3]\tu = *base\OverlaySrcRect\right
                v\v[3]\tv = *base\OverlaySrcRect\bottom
                v\v[3]\Color = iAlpha       
                v\v[3]\x = *base\OverlayDstRect\right * desc\Width
                v\v[3]\y = *base\OverlayDstRect\bottom * desc\Height
                v\v[3]\rhw = 1.0            
                
              EndIf  
              
              
              *D3DDev\BeginScene()
              *D3DDev\SetRenderState(#D3DRS_ALPHABLENDENABLE,#True)
              *D3DDev\SetRenderState(#D3DRS_SRCBLEND,#D3DBLEND_SRCALPHA)
              *D3DDev\SetRenderState(#D3DRS_DESTBLEND, #D3DBLEND_INVSRCALPHA)
              *D3DDev\SetFVF(#D3DFVF_TEX1|#D3DFVF_DIFFUSE|#D3DFVF_XYZRHW)
              
              *D3DDev\SetTextureStageState(0,#D3DTSS_COLOROP,#D3DTOP_MODULATE)
              *D3DDev\SetTextureStageState(0,#D3DTSS_ALPHAOP,#D3DTOP_MODULATE)
              
              *D3DDev\SetTexture(0, *base\OverlayTexture)
              *D3DDev\DrawPrimitiveUP(#D3DPT_TRIANGLESTRIP, 2, v, SizeOf(__DisplayColoredSprite) / 4)
              *D3DDev\EndScene()  
            EndIf
          EndIf
          
          If *base
            ;    iResult = *D3DDev\Present(*base\src,*base\dst,#Null,#Null)
            
            
            ;->***************************************************************************************
            ;begin test
            ;               #GET_MODULE_HANDLE_EX_FLAG_FROM_ADDRESS = 4
            ;               OpenLibrary(1,"Kernel32.dll")
            ;               Protected out,*ptr,A$
            ;               *ptr = PeekL(PeekL(*D3DDev) + OffsetOf(IDirect3DDevice9\AddRef()))
            ;               CallFunction(1,"GetModuleHandleExA",#GET_MODULE_HANDLE_EX_FLAG_FROM_ADDRESS,*ptr, @out)        
            ;               A$=Space(256)
            ;               GetModuleFileName_(out, A$,256)          
            ;               Debug "A "+A$
            ;               
            ;               *ptr = PeekL(PeekL(*D3DDev) + OffsetOf(IDirect3DDevice9\Release()))
            ;               CallFunction(1,"GetModuleHandleExA",#GET_MODULE_HANDLE_EX_FLAG_FROM_ADDRESS,*ptr, @out)        
            ;               A$=Space(256)
            ;               GetModuleFileName_(out, A$,256)          
            ;               Debug "R "+A$
            ;               
            ;               *ptr = PeekL(PeekL(*D3DDev) + OffsetOf(IDirect3DDevice9\Present()))
            ;               CallFunction(1,"GetModuleHandleExA",#GET_MODULE_HANDLE_EX_FLAG_FROM_ADDRESS,*ptr, @out)        
            ;               A$=Space(256)
            ;               GetModuleFileName_(out, A$,256)          
            ;               Debug "P "+A$
            ;               
            ;               *ptr = PeekL(PeekL(*D3DDev) + OffsetOf(IDirect3DDevice9\Reset()))
            ;               CallFunction(1,"GetModuleHandleExA",#GET_MODULE_HANDLE_EX_FLAG_FROM_ADDRESS,*ptr, @out)        
            ;               A$=Space(256)
            ;               GetModuleFileName_(out, A$,256)          
            ;               Debug "RE "+A$
            
            ;end test
            
            
            
            If *base\bRenderlessVMR9DrawBorder
              ;iResult muss ignoriert werden, da bei wmv-Dateien, wenn Fenster auf minimale gre resized wird, ein errorcode zurckgegeben wird
              *D3DDev\Present(#Null, #Null, #Null, #Null)      
              iResult = #S_OK  
            Else
              ;iResult muss ignoriert werden, da bei wmv-Dateien, wenn Fenster auf minimale gre resized wird, ein errorcode zurckgegeben wird
              *D3DDev\Present(#Null,*base\dst,#Null,#Null) 
              iResult = #S_OK  
            EndIf  
            
          Else
            ;iResult muss ignoriert werden, da bei wmv-Dateien, wenn Fenster auf minimale gre resized wird, ein errorcode zurckgegeben wird
            *D3DDev\Present(#Null, #Null, #Null, #Null)    
            iResult = #S_OK  
          EndIf
          
          
        Else
          __MediaDebug("Warn: SVMRImagePresenter9_PresentImage getting BackBuffer failed")   
        EndIf
      EndIf
      
    Else  
      iResult = #E_POINTER
    EndIf  
    
  Else
    __MediaDebug("SVMRImagePresenter9_PresentImage cannot continue, device already/still released")    
    iResult = #E_FAIL  
  EndIf
  
  If *p\m_hMutex
    UnlockMutex(*p\m_hMutex)
  EndIf  
  ProcedureReturn iResult
EndProcedure


Procedure __InitObject_SVMRImagePresenter9(*p.SVMRImagePresenter9)
  *p\VTable = *p + OffsetOf(SVMRImagePresenter9\pQueryInterface)
  *p\m_RefCount = 1
  *p\pAddRef = @__SVMRImagePresenter9_AddRef()
  *p\pQueryInterface = @__SVMRImagePresenter9_QueryInterface()
  *p\pRelease = @__SVMRImagePresenter9_Release()
  
  *p\pPresentImage = @__SVMRImagePresenter9_PresentImage()
  *p\pStartPresenting = @__SVMRImagePresenter9_StartPresenting()
  *p\pStopPresenting = @__SVMRImagePresenter9_StopPresenting()
  
  ProcedureReturn *p
EndProcedure


Procedure __SVMRSurfaceAllocator9_AddRef(*p.SVMRSurfaceAllocator9)
  ProcedureReturn InterlockedIncrement_(@*p\m_RefCount) ; +1 2010-08-09
EndProcedure

Procedure __SVMRSurfaceAllocator9_QueryInterface(*p.SVMRSurfaceAllocator9, GUID.i, *lpInterface.integer)
  Protected pMem, *base.DSHOW_MEDIABASE, iResult = #E_NOINTERFACE
  StringFromIID_(GUID, @pMem)
  If pMem
    __MediaDebug("SVMRSurfaceAllocator9_QueryInterface "+PeekS(pMem,-1,#PB_Unicode))
    CoTaskMemFree_(pMem)
  EndIf
  
  ;2010-08-07
  If *p\m_hMutex
    LockMutex(*p\m_hMutex)
  EndIf  
  
  If *lpInterface
    *lpInterface\i = #Null
    
    If CompareMemory(GUID,@IID_IVMRImagePresenter9,SizeOf(GUID)) 
      __MediaDebug("Asking for IVMRImagePresenter9")
      *base = *p\m_MediaObj
      If *base
        If *base\pImagePresenter    
          *lpInterface\i = *base\pImagePresenter
          __SVMRImagePresenter9_AddRef(*base\pImagePresenter)
          iResult = #S_OK        
        EndIf   
      EndIf
    EndIf
    
    If CompareMemory(GUID,@IID_IVMRSurfaceAllocator9,SizeOf(GUID))       
      __MediaDebug("Asking for IVMRSurfaceAllocator9")     
      If *p
        *lpInterface\i =  *p
        __SVMRSurfaceAllocator9_AddRef(*p)
        iResult = #S_OK         
      EndIf    
    EndIf
    
    If CompareMemory(GUID,@IID_IUnknown,SizeOf(GUID)) 
      __MediaDebug("Asking for IID_IUnknown")
      If *p
        *lpInterface\i = *p     
        __SVMRSurfaceAllocator9_AddRef(*p)
        iResult =  #S_OK
      EndIf 
    EndIf
    
  Else
    iResult = #E_INVALIDARG
  EndIf
  
  ;2010-08-07
  If *p\m_hMutex
    UnlockMutex(*p\m_hMutex)
  EndIf    
  
  ;If comparememory(GUID,@IID_IVMRWindowlessControl9,SizeOf(GUID)) 
  ; Debug "Asking for IID_IVMRWindowlessControl9" 
  ; 
  ;     PokeL(lpInterface,*hMedia\pVMR9Window)
  ;     ProcedureReturn #S_OK
  ;EndIf 
  
  ProcedureReturn iResult ; 2010-08-17
EndProcedure



Procedure __SVMRSurfaceAllocator9_Release(*p.SVMRSurfaceAllocator9)
  Protected i.i,*Surf.IDirect3DSurface9, *ptr.integer, iRefCount = 0
  
  If *p
    
    ;2010-08-07
    If *p\m_hMutex
      LockMutex(*p\m_hMutex)
    EndIf  
    
    iRefCount = InterlockedDecrement_(@*p\m_RefCount) ;  - 1
    If *p\m_RefCount<= 0  
      If *p\m_lpIVMRSurfAllocNotify
        
        ;Does not work...
        ;           If *p\m_lpIVMRSurfAllocNotify\ChangeD3DDevice(#Null, #Null)       
        ;             Debug "ERROR 11111"
        ;           EndIf          
        
        ;Object seems to be released already 
        ;2011-02-27
        ;Debug "reset device"
        ;*p\m_lpIVMRSurfAllocNotify\SetD3DDevice(#Null, #Null)
        
        
        *p\m_lpIVMRSurfAllocNotify\Release()
        *p\m_lpIVMRSurfAllocNotify = #Null
      EndIf  
      __DeleteSurfaces_SVMRSurfaceAllocator9(*p)
      __FreeD3D9_SVMRSurfaceAllocator9(*p)
    EndIf
    
    ;2010-08-07
    If *p\m_hMutex
      UnlockMutex(*p\m_hMutex)
    EndIf  
    
    ProcedureReturn iRefCount ; 2010-08-08 ;*p\m_RefCount 
  EndIf
EndProcedure

Procedure __SVMRSurfaceAllocator9_InitializeDevice(*p.SVMRSurfaceAllocator9, *dwUserID, *lpAllocInfo.VMR9AllocationInfo, *lpNumBuffers.long)
  Protected iResult = #E_FAIL, *base.DSHOW_MEDIABASE, tmpx.d, tmpy.f
  
  __MediaDebug("call __SVMRSurfaceAllocator9_InitializeDevice")
  If *lpAllocInfo And *lpNumBuffers 
    
    ;   *lpAllocInfo\dwWidth = 1024
    ;   *lpAllocInfo\dwHeight = 768  
    ;   *lpAllocInfo\szNativeSize\cx = 1024
    ;   *lpAllocInfo\szNativeSize\cy = 768
    
    *base.DSHOW_MEDIABASE = *p\m_MediaObj
    If *base
      *base\m_AllocatorImageWidth = *lpAllocInfo\dwWidth
      *base\m_AllocatorImageHeight = *lpAllocInfo\dwHeight
    EndIf
    
    ;*lpAllocInfo\dwFlags = #VMR9AllocFlag_OffscreenSurface;#VMR9AllocFlag_TextureSurface   ;2012-08-18 is this needed?
    
    __DeleteSurfaces_SVMRSurfaceAllocator9(*p)
    
    *p\m_Surfaces = AllocateMemory(*lpNumBuffers\l*SizeOf(Integer))
    If *p\m_Surfaces
      iResult = *p\m_lpIVMRSurfAllocNotify\AllocateSurfaceHelper(*lpAllocInfo, *lpNumBuffers, *p\m_Surfaces);  
      *p\m_NumSurfaces  = *lpNumBuffers\l  
    Else
      iResult = #E_FAIL
    EndIf
    
  Else
    iResult = #E_POINTER  
  EndIf
  
  ProcedureReturn iResult  
EndProcedure

Procedure __SVMRSurfaceAllocator9_TerminateDevice(*p.SVMRSurfaceAllocator9, *dwUserID)
  
  If *p\m_hMutex
    LockMutex(*p\m_hMutex)
  EndIf  
  __MediaDebug("call __SVMRSurfaceAllocator9_TerminateDevice")
  
  __DeleteSurfaces_SVMRSurfaceAllocator9(*p) 
  ;__FreeD3D9_SVMRSurfaceAllocator9(*p)
  
  If *p\m_hMutex
    UnlockMutex(*p\m_hMutex)
  EndIf  
  ProcedureReturn #S_OK
EndProcedure

Procedure __SVMRSurfaceAllocator9_GetSurface(*p.SVMRSurfaceAllocator9, *dwUserID, SurfaceIndex,SurfaceFlags,  *lplpSurface.IDirect3DSurface9)
  Protected *Surf.IDirect3DSurface9, *ptr.Integer, iResult = #E_FAIL 
  
  ;2010-08-07 Mutex
  If *p\m_hMutex
    LockMutex(*p\m_hMutex)
  EndIf  
  
  If( *lplpSurface = #Null )
    iResult = #E_POINTER;
  Else  
    
    If (SurfaceIndex >= *p\m_NumSurfaces ) Or *p\m_Surfaces = #Null
      iResult = #E_FAIL;
    Else
      
      *ptr.integer = *p\m_Surfaces + SurfaceIndex * SizeOf(Integer)
      *Surf.IDirect3DSurface9 = *ptr\i
      
      If *Surf
        *Surf\AddRef()
        *ptr = *lplpSurface
        *ptr\i = *Surf
        iResult = #S_OK
      EndIf
    EndIf
  EndIf
  
  If *p\m_hMutex
    UnlockMutex(*p\m_hMutex)
  EndIf    
  ProcedureReturn iResult
EndProcedure

Procedure __SVMRSurfaceAllocator9_AdviseNotify(*p.SVMRSurfaceAllocator9,*lpIVMRSurfAllocNotify.IVMRSurfaceAllocatorNotify9 )
  Protected hMonitor, iResult = #E_FAIL
  If *lpIVMRSurfAllocNotify
    
    
    ;2010-08-07 Mutex
    If *p\m_hMutex
      LockMutex(*p\m_hMutex)
    EndIf     
    
    If *p\m_D3D 
      
      *p\m_lpIVMRSurfAllocNotify = *lpIVMRSurfAllocNotify
      hMonitor = *p\m_D3D\GetAdapterMonitor( #D3DADAPTER_DEFAULT )      
      iResult = *p\m_lpIVMRSurfAllocNotify\SetD3DDevice( *p\m_D3DDev, hMonitor)    
    Else
      iResult = #E_FAIL
    EndIf
    
    If *p\m_hMutex
      UnlockMutex(*p\m_hMutex)
    EndIf     
    
  Else
    iResult = #E_POINTER  
  EndIf
  
  ProcedureReturn iResult
EndProcedure

Procedure __InitObject_SVMRSurfaceAllocator9(*p.SVMRSurfaceAllocator9)
  *p\VTable = *p + OffsetOf(SVMRSurfaceAllocator9\pQueryInterface)
  *p\m_RefCount = 1
  *p\pAddRef = @__SVMRSurfaceAllocator9_AddRef()
  *p\pQueryInterface = @__SVMRSurfaceAllocator9_QueryInterface()
  *p\pRelease = @__SVMRSurfaceAllocator9_Release()
  
  *p\pInitializeDevice  = @__SVMRSurfaceAllocator9_InitializeDevice()
  *p\pTerminateDevice = @__SVMRSurfaceAllocator9_TerminateDevice()
  *p\pGetSurface = @__SVMRSurfaceAllocator9_GetSurface()
  *p\pAdviseNotify = @__SVMRSurfaceAllocator9_AdviseNotify()
  
  ProcedureReturn *p
EndProcedure


Procedure __SetAllocatorPresenter( *filter.IBaseFilter, hWnd.i, *obj.DSHOW_MEDIABASE, iUserID.i)
  Protected hr.i, lpIVMRSurfAllocNotify.IVMRSurfaceAllocatorNotify9,*allocator.IVMRSurfaceAllocator9, *ImgPresenter.IVMRSurfaceAllocator9
  Protected bOk = #False
  hr = *filter\QueryInterface(@IID_IVMRSurfaceAllocatorNotify9, @lpIVMRSurfAllocNotify);
  
  If hr = #S_OK
    ; create our surface allocator
    *allocator.IVMRSurfaceAllocator9 = __InitObject_SVMRSurfaceAllocator9(*obj\pAllocator)  
    *ImgPresenter.IVMRSurfaceAllocator9 = __InitObject_SVMRImagePresenter9(*obj\pImagePresenter)
    
    If __InitD3D9_SVMRSurfaceAllocator9(*allocator, hWnd)
      *obj\pAllocator\m_MediaObj = *obj
      *obj\pImagePresenter\m_MediaObj = *obj
      *obj\pImagePresenter\m_Allocator = *allocator
      *obj\pAllocator\m_hMutex = *obj\hMutex
      *obj\pImagePresenter\m_hMutex = *obj\hMutex        
      ;         *obj\pAllocator\m_D3DDev = *obj\pImagePresenter\m_D3DDev
      ;         *obj\pAllocator\m_D3D = *obj\pImagePresenter\m_D3D        
      ;         *obj\pAllocator\m_D3DDev\AddRef()
      ;         *obj\pAllocator\m_D3D\AddRef()
      
      ; let the allocator And the notify know about each other
      hr = lpIVMRSurfAllocNotify\AdviseSurfaceAllocator( iUserID, *obj\pAllocator)
      If hr = #S_OK
        hr = *allocator\AdviseNotify(lpIVMRSurfAllocNotify)
        If hr = #S_OK
          bOk = #True
        Else
          __MediaError("AdviseNotify failed with error code:"+Hex(hr))
        EndIf
      Else
        __MediaError("AdviseSurfaceAllocator failed with error code:"+Hex(hr))          
      EndIf  
    Else
      hr = #E_FAIL  
      __MediaError("__InitD3D9_SVMRSurfaceAllocator9 failed")
    EndIf
  Else
    __MediaError("QueryInterface failed in __SetAllocatorPresenter with error code:"+Hex(hr))        
  EndIf
  
  If bOk = #False
    If *allocator
      __FreeD3D9_SVMRSurfaceAllocator9(*allocator)  
      *obj\pAllocator\m_lpIVMRSurfAllocNotify = #Null        
    EndIf
    If lpIVMRSurfAllocNotify
      lpIVMRSurfAllocNotify\Release()
      lpIVMRSurfAllocNotify = #Null
    EndIf
  EndIf    
  
  ProcedureReturn hr
EndProcedure

;===============================================================================

; #DWMWA_FLIP3D_POLICY = 8
; #DWMWA_FORCE_ICONIC_REPRESENTATION = 7
; 
; #DWM_EC_DISABLECOMPOSITION = 0
; #DWM_EC_ENABLECOMPOSITION = 1
; 
; Prototype.i __DwmIsCompositionEnabled(*ptrEnabled)
; Prototype.i __DwmEnableComposition(enable.i)  
; Prototype.i __DwmSetWindowAttribute(hwnd.i ,dwAttribute.i ,pvAttribute.i ,iSize.i)
; 
; Structure GLOBAL_DWMDShow
;   DWMModule.i
;   DwmIsCompositionEnabled.__DwmIsCompositionEnabled
;   DwmEnableComposition.__DwmEnableComposition
;   DwmSetWindowAttribute.__DwmSetWindowAttribute
; EndStructure
; 
; Global g_DWMDShow.GLOBAL_DWMDShow
; 
; Procedure __DWM_IsEnabled()
;   Protected bDWMEnabled.i
;   bDWMEnabled.i = #False
;   If g_DWMDShow\DwmIsCompositionEnabled
;     g_DWMDShow\DwmIsCompositionEnabled(@bDWMEnabled)
;   EndIf
;   ProcedureReturn bDWMEnabled
; EndProcedure
; 
; Procedure __DWM_Enable(enable.i)
;   Protected iResult.i
;   iResult = #E_FAIL 
;   If g_DWMDShow\DwmEnableComposition
;     iResult = g_DWMDShow\DwmEnableComposition(enable)
;   EndIf
;   ProcedureReturn iResult
; EndProcedure
; 
; Procedure __DWM_Init()
;   If g_DWMDShow\DWMModule = #Null
;     g_DWMDShow\DWMModule = LoadLibrary_("dwmapi.dll")
;     If g_DWMDShow\DWMModule
;       g_DWMDShow\DwmIsCompositionEnabled = GetProcAddress_(g_DWMDShow\DWMModule, "DwmIsCompositionEnabled")
;       g_DWMDShow\DwmEnableComposition = GetProcAddress_(g_DWMDShow\DWMModule, "DwmEnableComposition")
;       g_DWMDShow\DwmSetWindowAttribute = GetProcAddress_(g_DWMDShow\DWMModule, "DwmSetWindowAttribute")
;     EndIf
;   EndIf
; EndProcedure
; 
; Procedure __DWM_Free()
;   If g_DWMDShow\DWMModule
;     FreeLibrary_(g_DWMDShow\DWMModule)
;     g_DWMDShow\DwmIsCompositionEnabled = #Null
;     g_DWMDShow\DwmEnableComposition = #Null
;     g_DWMDShow\DwmSetWindowAttribute = #Null
;   EndIf
; EndProcedure
; 

Procedure __IsValidMediaObject(*obj)
  Protected bResult.i = #False
  ForEach __ValidMediaObjects()
    If __ValidMediaObjects()  = *obj
      bResult = #True
    EndIf
  Next
  ProcedureReturn bResult
EndProcedure

Procedure __AddMediaObject(*obj)
  AddElement(__ValidMediaObjects())
  __ValidMediaObjects() = *obj
EndProcedure

Procedure __FreeMediaObject(*obj)
  Protected bResult.i = #False
  ForEach __ValidMediaObjects()
    If __ValidMediaObjects()  = *obj
      DeleteElement(__ValidMediaObjects())
    EndIf
  Next
  ProcedureReturn #True
EndProcedure

Procedure DShow_InitMedia(bUseD3D9Ex = #True)
  Protected iResult.i
  DSHOW_UseD3D9Ex = bUseD3D9Ex
  iResult = CoInitializeEx_(0,#COINIT_APARTMENTTHREADED)
  If iResult = #S_OK Or iResult = #S_FALSE
    ;__DWM_Init()
    DSHOW_D3D9DLL = LoadLibrary_("d3d9.dll")
    If DSHOW_D3D9DLL = #Null
      __MediaDebug("Warn: Cannot load d3d9.dll")  
    EndIf
    
    DSHOW_DWMAPIDLL = LoadLibrary_("dwmapi.dll")
    If DSHOW_DWMAPIDLL = #Null
      __MediaDebug("Warn: Cannot load dwmapi.dll")  
    EndIf
    
    ProcedureReturn #True
  Else
    __MediaError("Error: DSHOW Initaisation FAILED!")
    ProcedureReturn #False
  EndIf
EndProcedure

Procedure DShow_EndMedia()
  ;__DWM_Free()
  If DSHOW_D3D9DLL
    FreeLibrary_(DSHOW_D3D9DLL)  
  EndIf
  
  If DSHOW_DWMAPIDLL
    FreeLibrary_(DSHOW_DWMAPIDLL)  
  EndIf  
  CoUninitialize_()
EndProcedure

Procedure __Release(*obj.IUnknown)
  If *obj
    *obj\Release()
  EndIf
EndProcedure

Procedure __CreateMediaObject(bDVD.i)
  Protected iSuccess.i = #S_OK, *obj.DSHOW_MEDIABASE = #Null
  *obj = AllocateMemory(SizeOf(DSHOW_MEDIABASE))
  If *obj
    *obj\iUserId  = *obj ; K.A zu was die UserID gut ist... Wahrscheinlich UserData...
    *obj\hMutex = CreateMutex()
    
    If bDVD    
      iSuccess = CoCreateInstance_(@CLSID_IDvdGraphBuilder, #Null, #CLSCTX_INPROC_SERVER, @IID_IDVDGraphBuilder, @*obj\pDVDGraphBuilder) 
      If iSuccess = #S_OK
        iSuccess = *obj\pDVDGraphBuilder\GetFiltergraph(@*obj\pGraphBuilder)
      EndIf
    Else
      iSuccess = CoCreateInstance_(@CLSID_FilterGraph, #Null, #CLSCTX_INPROC_SERVER, @IID_IGraphBuilder, @*obj\pGraphBuilder)
    EndIf
    
    If iSuccess = #S_OK 
      iSuccess = *obj\pGraphBuilder\QueryInterface(@IID_IMediaControl, @*obj\pControl)
      If iSuccess = #S_OK
        iSuccess = *obj\pGraphBuilder\QueryInterface(@IID_IMediaEventEx, @*obj\pEvent)
      EndIf
      If iSuccess = #S_OK
        iSuccess = *obj\pGraphBuilder\QueryInterface(@IID_IVideoWindow, @*obj\pWindow)   
      EndIf
      If iSuccess = #S_OK
        iSuccess = *obj\pGraphBuilder\QueryInterface(@IID_IBasicAudio, @*obj\pAudio)
      EndIf
      If iSuccess = #S_OK
        iSuccess = *obj\pGraphBuilder\QueryInterface(@IID_IBasicVideo2, @*obj\pVideo)
      EndIf
      If iSuccess = #S_OK
        iSuccess = *obj\pGraphBuilder\QueryInterface(@IID_IMediaSeeking, @*obj\pSeeking)
      EndIf      
      If iSuccess = #S_OK
        __AddMediaObject(*obj)
        ProcedureReturn *obj
      Else
        __MediaError("Error: Query of needed interfaces failed")
      EndIf   
    Else  
      __MediaError("Error: creating of GraphBuilder object failed")
    EndIf
    
    __Release(*obj\pSeeking)
    __Release(*obj\pVideo)
    __Release(*obj\pAudio)
    __Release(*obj\pWindow)
    __Release(*obj\pControl)
    __Release(*obj\pEvent)
    __Release(*obj\pGraphBuilder)
    __Release(*obj\pDVDGraphBuilder)
    FreeMemory(*obj)
  Else
    __MediaError("Error: failed to allocate memory")
  EndIf 
EndProcedure
; 
; Procedure __SetRenderingModeVMR7(pVideoRender.IBaseFilter, hWndParent.i, iMode.i, bNoWarnings.i = #False, *oldRenderingMode.long = #Null, bJustEnableMixing.i = #False)
;   Protected pFltrConf, pWndCtrl, iOldMode
;   Protected pVMRConf.IVMRFilterConfig, pWc.IVMRWindowlessControl
;   Protected bResult.i = #False, iResultSetNumberOfStreams.i
;   
;   pFltrConf = @IID_IVMRFilterConfig
;   pWndCtrl = @IID_IVMRWindowlessControl
;   
;   If pVideoRender
;     If pVideoRender\QueryInterface(pFltrConf, @pVMRConf) = #S_OK
;       
;       If bJustEnableMixing = #False
;         If *oldRenderingMode
;           pVMRConf\GetRenderingMode(@iOldMode)
;           __MediaDebug("old rendering mode for VMR7 is " + Str(iOldMode))
;           *oldRenderingMode\l = iOldMode
;         EndIf 
;         If pVMRConf\SetRenderingMode(iMode) = #S_OK          
;           Select iMode
;           Case #VMRMODE_WINDOWED
;           ; do nothing  
;           bResult = #True
;           Case #VMRMODE_WINDOWLESS
;             ;pVMRConf\SetRenderingPrefs(1) ; do not render borders
;             If pVideoRender\QueryInterface(pWndCtrl, @pWc) = #S_OK 
;               If hWndParent      
;                 ;With this windowless is not working correctly...                 
;                 pWc\SetVideoClippingWindow(hWndParent)
;               EndIf
;               pWc\Release()
;               bResult = #True       
;             EndIf
;           EndSelect
;         EndIf
;       EndIf
;       
;       ;2010-08-04 Necessary for SetAlphaBitmap
;       If iMode <> #VMRMODE_RENDERLESS
;         iResultSetNumberOfStreams = pVMRConf\SetNumberOfStreams(1)
;         If iResultSetNumberOfStreams <> #S_OK
;           __MediaError("Error SetNumberOfStreams(1) failed with errorcode "+Hex(iResultSetNumberOfStreams))
;         EndIf  
;         
;         If bJustEnableMixing = #True ; would not be set to true otherwise
;           bResult = #True
;         EndIf
;       EndIf
;       
;       pVMRConf\Release()
;     EndIf
;   EndIf
;   If bResult = #False And bNoWarnings = #False
;     __MediaDebug("Warn: Cannot set rendering mode for VMR7")
;   EndIf
;   ProcedureReturn bResult
; EndProcedure
; 
; Procedure __SetRenderingModeVMR9(pVideoRender.IBaseFilter, hWndParent.i, iMode.i, bNoWarnings.i = #False, *oldRenderingMode.long = #Null, bJustEnableMixing = #False)
;   Protected pFltrConf, pWndCtrl, iOldMode
;   Protected pVMRConf.IVMRFilterConfig9, pWc.IVMRWindowlessControl9
;   Protected bResult.i = #False, iResultSetNumberOfStreams.i
;   
;   pFltrConf = @IID_IVMRFilterConfig9
;   pWndCtrl = @IID_IVMRWindowlessControl9
;   
;   If pVideoRender
;     If pVideoRender\QueryInterface(pFltrConf, @pVMRConf) = #S_OK
;       
;      If  bJustEnableMixing = #False
;        If *oldRenderingMode
;          pVMRConf\GetRenderingMode(@iOldMode)
;          __MediaDebug("old rendering mode for VMR9 is " + Str(iOldMode))
;          *oldRenderingMode\l = iOldMode
;        EndIf 
;        If pVMRConf\SetRenderingMode(iMode) = #S_OK         
;          Select iMode
;           Case #VMRMODE_RENDERLESS
;             bResult = #True              
;           Case #VMRMODE_WINDOWED
;           ; do nothing  
;           bResult = #True
;           Case #VMRMODE_WINDOWLESS
;              ;pVMRConf\SetRenderingPrefs(1) ; do not render borders
;             If pVideoRender\QueryInterface(pWndCtrl, @pWc) = #S_OK 
;               If hWndParent                     
;                 ;With this windowless is not working correctly...    
;                 pWc\SetVideoClippingWindow(hWndParent)
;               EndIf
;               pWc\Release()
;               bResult = #True       
;             EndIf
;           EndSelect
;         EndIf
;       EndIf
;                  
;       ;2010-08-04 Not necesarry for VMR9 (In the VMR-9, the mixer is always present )
;       ; This seems to done only for windowless, so we must do it anyway....
;       If iMode <> #VMRMODE_RENDERLESS
;         iResultSetNumberOfStreams = pVMRConf\SetNumberOfStreams(1)
;         If iResultSetNumberOfStreams <> #S_OK
;           __MediaError("Error SetNumberOfStreams(1) failed with errorcode "+Hex(iResultSetNumberOfStreams))
;         EndIf  
;         
;         If bJustEnableMixing = #True ; would not be set to true otherwise
;           bResult = #True
;         EndIf
;       EndIf
; 
;       pVMRConf\Release()
;     EndIf 
;   EndIf
;   If bResult = #False And bNoWarnings = #False
;     __MediaDebug("Warn: Cannot set rendering mode for VMR9")
;   EndIf
;   ProcedureReturn bResult
; EndProcedure
;  

Procedure __SetRenderingModeVMR7(pVideoRender.IBaseFilter, hWndParent.i, iMode.i, bForceOverlay.i, bNoWarnings.i = #False, *oldRenderingMode.long = #Null)
  Protected pFltrConf, pWndCtrl, iOldMode
  Protected pVMRConf.IVMRFilterConfig, pWc.IVMRWindowlessControl
  Protected bResult.i = #False, iResultSetNumberOfStreams.i, iResultPrefs.i
  
  pFltrConf = @IID_IVMRFilterConfig
  pWndCtrl = @IID_IVMRWindowlessControl
  
  If pVideoRender
    If pVideoRender\QueryInterface(pFltrConf, @pVMRConf) = #S_OK
      
      If *oldRenderingMode
        pVMRConf\GetRenderingMode(@iOldMode)
        __MediaDebug("old rendering mode for VMR7 is " + Str(iOldMode))
        *oldRenderingMode\l = iOldMode
      EndIf        
      
      If pVMRConf\SetRenderingMode(iMode) = #S_OK          
        Select iMode
          Case #VMRMODE_WINDOWED
            ; do nothing  
            bResult = #True
          Case #VMRMODE_WINDOWLESS
            ;pVMRConf\SetRenderingPrefs(1) ; do not render borders
            If pVideoRender\QueryInterface(pWndCtrl, @pWc) = #S_OK 
              If hWndParent      
                ;With this windowless is not working correctly...                 
                pWc\SetVideoClippingWindow(hWndParent)
              EndIf
              pWc\Release()
              bResult = #True       
            EndIf
        EndSelect
      EndIf
      
      ;2010-08-04 Necessary for SetAlphaBitmap
      If iMode <> #VMRMODE_RENDERLESS
        If bForceOverlay = #False ; 2011-04-08 new
          iResultSetNumberOfStreams = pVMRConf\SetNumberOfStreams(1)
          If iResultSetNumberOfStreams <> #S_OK
            __MediaError("Error SetNumberOfStreams(1) failed with errorcode "+Hex(iResultSetNumberOfStreams))
          EndIf
        Else
          __MediaDebug("Do not call SetNumberOfStreams(1) because ForceOverlay") ; 2011-07-28 Es scheint probleme bei Nvidia Grafikkarten zu geben, wenn SetNumberOfStreams(1) aufgerufen wird 
        EndIf
      EndIf
      
      If bForceOverlay ; 2011-04-08 new         
        iResultPrefs = pVMRConf\SetRenderingPrefs(#RenderPrefs_ForceOverlays) 
        If iResultPrefs <> #S_OK And bNoWarnings = #False
          __MediaError("VMR7 SetRenderingPrefs(RenderPrefs_ForceOverlays) failed with error " + Str(iResultPrefs))
        EndIf  
      EndIf       
      
      pVMRConf\Release()
    EndIf
  EndIf
  If bResult = #False And bNoWarnings = #False
    __MediaDebug("Warn: Cannot set rendering mode for VMR7")
  EndIf
  ProcedureReturn bResult
EndProcedure

Procedure __SetRenderingModeVMR9(pVideoRender.IBaseFilter, hWndParent.i, iMode.i, bNoWarnings.i = #False, *oldRenderingMode.long = #Null)
  Protected pFltrConf, pWndCtrl, iOldMode
  Protected pVMRConf.IVMRFilterConfig9, pWc.IVMRWindowlessControl9
  Protected bResult.i = #False, iResultSetNumberOfStreams.i
  
  pFltrConf = @IID_IVMRFilterConfig9
  pWndCtrl = @IID_IVMRWindowlessControl9
  
  If pVideoRender
    If pVideoRender\QueryInterface(pFltrConf, @pVMRConf) = #S_OK
      
      If *oldRenderingMode
        pVMRConf\GetRenderingMode(@iOldMode)
        __MediaDebug("old rendering mode for VMR9 is " + Str(iOldMode))
        *oldRenderingMode\l = iOldMode
      EndIf 
      If pVMRConf\SetRenderingMode(iMode) = #S_OK         
        Select iMode
          Case #VMRMODE_RENDERLESS
            bResult = #True              
          Case #VMRMODE_WINDOWED
            ; do nothing  
            bResult = #True
          Case #VMRMODE_WINDOWLESS
            ;pVMRConf\SetRenderingPrefs(1) ; do not render borders
            If pVideoRender\QueryInterface(pWndCtrl, @pWc) = #S_OK 
              If hWndParent                     
                ;With this windowless is not working correctly...    
                pWc\SetVideoClippingWindow(hWndParent)
              EndIf
              pWc\Release()
              bResult = #True       
            EndIf
        EndSelect
      EndIf
      
      ;2010-08-04 Not neccessary for VMR9 (In the VMR-9, the mixer is always present )
      ; This seems to done only for windowless, so we must do it anyway....
      If iMode <> #VMRMODE_RENDERLESS And iMode <> #VMRMODE_WINDOWLESS ; Windowless would fail for VMR9
        iResultSetNumberOfStreams = pVMRConf\SetNumberOfStreams(1)
        If iResultSetNumberOfStreams <> #S_OK
          __MediaError("Error SetNumberOfStreams(1) failed with errorcode "+Hex(iResultSetNumberOfStreams))
        EndIf  
      EndIf
      
      pVMRConf\Release()
    EndIf 
  EndIf
  If bResult = #False And bNoWarnings = #False
    __MediaDebug("Warn: Cannot set rendering mode for VMR9")
  EndIf
  ProcedureReturn bResult
EndProcedure

Procedure __SetAspectRatioModeVMR9(pVideoRender.IBaseFilter, iMode.i, bNoWarnings.i = #False)
  Protected pARC.IVMRAspectRatioControl9 
  Protected bResult.i = #False
  Protected pARCInterfaceIID.i
  
  pARCInterfaceIID = @IID_IVMRAspectRatioControl9
  If pVideoRender
    If pVideoRender\QueryInterface(pARCInterfaceIID, @pARC) = #S_OK
      pARC\SetAspectRatioMode(iMode)
      pARC\Release()
      bResult = #True
    EndIf
  EndIf
  If bResult = #False And bNoWarnings = #False
    __MediaDebug("Warn: Cannot set aspect ratio mode for VMR9")
  EndIf
  ProcedureReturn bResult
EndProcedure 

Procedure __SetAspectRatioModeVMR7(pVideoRender.IBaseFilter, iMode.i, bNoWarnings.i = #False)
  Protected pARC.IVMRAspectRatioControl
  Protected bResult.i = #False
  Protected pARCInterfaceIID.i
  
  pARCInterfaceIID = @IID_IVMRAspectRatioControl
  If pVideoRender
    If pVideoRender\QueryInterface(pARCInterfaceIID, @pARC) = #S_OK
      pARC\SetAspectRatioMode(iMode)
      pARC\Release()
      bResult = #True
    EndIf
  EndIf
  If bResult = #False And bNoWarnings = #False
    __MediaDebug("Warn: Cannot set aspect ratio mode for VMR7")
  EndIf
  ProcedureReturn bResult
EndProcedure 

Procedure __SetAspectRatioModeOverlay(pVideoRender.IBaseFilter, iMode.i, bNoWarnings.i = #False)
  Protected pMixerPinConf.IMixerPinConfig, pObj.IPin
  Protected bResult.i = #False, *temp
  
  *temp = AllocateMemory(#MAX_PATH * 2)  
  If *temp
    If pVideoRender
      pVideoRender\FindPin(L(*temp,"Input0"), @pObj)
      If pObj
        If pObj\QueryInterface(@IID_IMixerPinConfig, @pMixerPinConf) = #S_OK
          pMixerPinConf\SetAspectRatioMode(iMode)
          pMixerPinConf\Release()
          bResult = #True
        EndIf
        pObj\Release()
      EndIf
    EndIf
    FreeMemory(*temp)
  EndIf
  If bResult = #False And bNoWarnings = #False
    __MediaDebug("Warn: Cannot set aspect ratio mode for Overlay")
  EndIf
  ProcedureReturn bResult
EndProcedure 

Procedure __WndProc(hWnd.i,Msg.i,wParam.i,lParam.i)
  Protected *CB, *obj.DSHOW_MEDIABASE,DC, pt.POINT , iWidth.i, iHeight.i, paint.PAINTSTRUCT
  
  *obj = GetProp_(hWnd,"DSObj")
  *CB = GetProp_(hWnd, "NoEraseCB")
  
  If *obj      
    ; Die letzte bedingung ist dafr da um einen redraw bug unter vista zu verhindern
    ; Etweder Present muss aufgerufen worden sein, oder es wird kein VMR9 Renderless verwendet!
    If *obj\bBackgroundErased And *obj\bAllowEraseBackground And (*obj\bRenderlessVMR9PresentCalled Or *obj\bIsRenderlessVMR9 = #False)
      If Msg = #WM_ERASEBKGND
        ProcedureReturn 0
      EndIf
    EndIf
    
    If Msg = #WM_MOVE
      If *obj\pWindow
        *obj\pWindow\NotifyOwnerMessage(hWnd,Msg,wParam,lParam)
      EndIf
    EndIf
    
    ; Fix redraw problem of overlay mixer (Windows 7 without DWM)
    If Msg = #WM_TIMER And wParam = 'redr'
      
      If *obj\iVideoRenderer = #RENDERER_OVERLAYMIXER
        If *obj\pVideo\get_DestinationWidth(@iWidth) = #S_OK
          *obj\pVideo\put_DestinationWidth(iWidth)
        EndIf
        If *obj\pVideo\get_DestinationHeight(@iHeight) = #S_OK
          *obj\pVideo\put_DestinationHeight(iHeight)
        EndIf
        If *obj\pWindow\get_Width(@iWidth) = #S_OK
          *obj\pWindow\put_Width(iWidth)
        EndIf           
        If *obj\pWindow\get_Height(@iHeight) = #S_OK
          *obj\pWindow\put_Height(iHeight)
        EndIf      
      EndIf
      ProcedureReturn #False
    EndIf
    
    If (Msg = #WM_PAINT And *obj\bWindowless) And *obj\bIsRenderlessVMR9 = #False  
      ;If *CB
      ;  CallWindowProc_(*CB, hWnd,Msg,wParam,lParam)
      ;Else
      ;  DefWindowProc_(hWnd,Msg,wParam,lParam)
      ;EndIf 
      If *obj\pVMR7Window
        BeginPaint_(hWnd,paint)
        *obj\pVMR7Window\RepaintVideo(hWnd, paint\hdc)
        EndPaint_(hWnd,paint)
      ElseIf *obj\pVMR9Window
        BeginPaint_(hWnd,paint)
        *obj\pVMR9Window\RepaintVideo(hWnd, paint\hdc)
        EndPaint_(hWnd,paint)
      EndIf     
      ProcedureReturn 0
    EndIf
    
    If (Msg = #WM_PAINT) And *obj\bRenderlessVMR9DrawBorder And *obj\bBackgroundErased = #False; only if we are not playing...
      If *obj\bIsRenderlessVMR9 And *obj\pAllocator\m_UseFlipEx = #False   
        
        If *obj\pAllocator\m_hMutex
          LockMutex(*obj\pAllocator\m_hMutex)
        EndIf 
        
        BeginPaint_(hWnd, paint)  ; without this the message seems not to be correctly handled (endless WM_PAINT messages)      
        If *obj\pAllocator\m_D3DDev
          If *obj\bRenderlessVMR9DrawBorder
            *obj\pAllocator\m_D3DDev\Present(#Null, #Null, #Null, #Null)      
          Else
            *obj\pAllocator\m_D3DDev\Present(#Null,*obj\dst,#Null,#Null)   
          EndIf  
        EndIf       
        EndPaint_(hWnd, paint)  
        If *obj\pAllocator\m_hMutex
          UnlockMutex(*obj\pAllocator\m_hMutex)
        EndIf 
        ProcedureReturn 0        
      EndIf    
    EndIf
     
    ;     If Msg = #WM_ERASEBKGND And *obj\bWindowless   
    ;       If *CB
    ;         CallWindowProc_(*CB, hWnd,Msg,wParam,lParam)
    ;       Else
    ;         DefWindowProc_(hWnd,Msg,wParam,lParam)
    ;       EndIf 
    ;       If *obj\pVMR7Window
    ;         DC = GetWindowDC_(hWnd)
    ;         *obj\pVMR7Window\RepaintVideo(hWnd, DC)
    ;         ReleaseDC_(hWnd, DC)
    ;       ElseIf *obj\pVMR9Window
    ;         DC = GetWindowDC_(hWnd)
    ;         *obj\pVMR9Window\RepaintVideo(hWnd, DC)
    ;         ReleaseDC_(hWnd, DC)
    ;       EndIf
    ;       ProcedureReturn #True
    ;     EndIf   
    
    If Msg = #WM_DISPLAYCHANGE And *obj\bWindowless    
      If *obj\pVMR7Window
        *obj\pVMR7Window\DisplayModeChanged()
      ElseIf *obj\pVMR9Window
        *obj\pVMR9Window\DisplayModeChanged()
      EndIf           
    EndIf 
    
    If *obj\pDVDControl
      ;       If Msg = #WM_MOUSEMOVE              
      ;           DShow_DVDMouseControl(*obj, lParam & $FFFF, (lParam >> 16) & $FFFF, #False)
      ;       EndIf
      ;       If Msg = #WM_LBUTTONUP                 
      ;           DShow_DVDMouseControl(*obj, lParam & $FFFF, (lParam >> 16) & $FFFF, #True)
      ;       EndIf    
      ;       
      If *obj\bAutoDVDControl
        If Msg = #WM_KEYUP
          Select wParam
            Case #VK_RETURN
              DShow_DVDKeyControl(*obj, #DVDCONTROL_ACTIVATE)
            Case #VK_SPACE
              DShow_DVDKeyControl(*obj, #DVDCONTROL_ACTIVATE)
            Case #VK_LEFT
              DShow_DVDKeyControl(*obj, #DVDCONTROL_LEFT)
            Case #VK_RIGHT
              DShow_DVDKeyControl(*obj, #DVDCONTROL_RIGHT)
            Case #VK_UP
              DShow_DVDKeyControl(*obj, #DVDCONTROL_UP)
            Case #VK_DOWN
              DShow_DVDKeyControl(*obj, #DVDCONTROL_DOWN)
          EndSelect
        EndIf  
      EndIf       
    EndIf                          
    
  EndIf
  
  If *CB
    ProcedureReturn CallWindowProc_(*CB, hWnd,Msg,wParam,lParam)
  Else
    ProcedureReturn DefWindowProc_(hWnd,Msg,wParam,lParam)
  EndIf
EndProcedure

Procedure __AddBkgndEraseFromWindow(*obj.DSHOW_MEDIABASE, hWnd)
  Protected *OldProc
  If hWnd
    If GetProp_(hWnd, "NoEraseCB") = #Null
      *OldProc = SetWindowLongPtr_(hWnd, #GWLP_WNDPROC, @__WndProc())
      SetProp_(hWnd, "NoEraseCB", *OldProc) 
      SetProp_(hWnd, "DSObj", *obj)       
      SetTimer_(hWnd, 'redr', 50, #Null)  
    EndIf
  EndIf
EndProcedure

Procedure __RemoveBkgndEraseFromWindow(*obj.DSHOW_MEDIABASE, hWnd)
  Protected *OldProc
  If hWnd
    *OldProc = GetProp_(hWnd, "NoEraseCB")
    If *OldProc
      SetWindowLongPtr_(hWnd, #GWLP_WNDPROC, *OldProc)
      SetProp_(hWnd, "NoEraseCB", #Null)
      SetProp_(hWnd, "DSObj", #Null)
      RemoveProp_(hWnd, "NoEraseCB")
      RemoveProp_(hWnd, "DSObj")
      KillTimer_(hWnd, 'redr')
    EndIf
  EndIf
EndProcedure

Procedure __CreateIndividualAudioRenderer(*obj.DSHOW_MEDIABASE, iAudioRenderer)
  Protected pAudioRender.IBaseFilter
  Protected pIndividualRenderer, sRendName.s
  Protected bResult.i = #False, *temp
  
  If iAudioRenderer = #RENDERER_WAVEOUT Or iAudioRenderer = #RENDERER_DSOUND
    *temp = AllocateMemory(#MAX_PATH * 2)
    If *temp
      
      If iAudioRenderer = #RENDERER_WAVEOUT
        pIndividualRenderer = @CLSID_AudioRender
        sRendName = "AudioWaveOut Renderer"    
      EndIf
      
      If iAudioRenderer = #RENDERER_DSOUND
        pIndividualRenderer = @CLSID_DSoundRender
        sRendName = "DSound Renderer" 
      EndIf      
      
      __MediaDebug("try creating renderer "+Chr(34)+ sRendName+ Chr(34))  
      If CoCreateInstance_(pIndividualRenderer, #Null, #CLSCTX_INPROC, @IID_IBaseFilter, @pAudioRender) = #S_OK      
        *obj\pAudioRender = pAudioRender     
        If *obj\pGraphBuilder\AddFilter(pAudioRender, L(*temp, sRendName)) = #S_OK
          bResult = #True
          __MediaDebug("renderer "+Chr(34)+ sRendName+ Chr(34) + " created")  
        Else
          __MediaDebug("Warn: failed to add individual audio render filter")
        EndIf
      Else
        __MediaDebug("Warn: failed to create individual audio render filter")
      EndIf
      
      FreeMemory(*temp)  
    EndIf 
  EndIf
  ProcedureReturn bResult
EndProcedure

Procedure __CreateIndividualVideoRenderer(*obj.DSHOW_MEDIABASE, hWndParent.i, iVidRenderer, bWindowless.i, bOwnVMR9Allocator.i, bForceVMR7Overlay.i)
  Protected pVideoRender.IBaseFilter
  Protected pIndividualRenderer, sRendName.s
  Protected bResult.i = #False, *temp, bFail = #False
  
  If iVidRenderer <> #RENDERER_DEFAULT
    *temp = AllocateMemory(#MAX_PATH * 2)
    If *temp
      
      Select iVidRenderer
        Case #RENDERER_VMR9
          pIndividualRenderer = @CLSID_VideoMixingRenderer9
          sRendName = "Video Mixing Renderer 9"
        Case #RENDERER_VMR7
          pIndividualRenderer = @CLSID_VideoMixingRenderer
          sRendName = "Video Mixing Renderer"
        Case #RENDERER_OVERLAYMIXER
          pIndividualRenderer = @CLSID_OverlayMixer
          sRendName = "Overlay Mixer"
        Case #RENDERER_OLDVIDEO
          pIndividualRenderer = @CLSID_VideoRenderer
          sRendName = "Old Video Renderer"         
        Default
          ;better use VMR7 instead of VMR9 because of strange memory leak
          pIndividualRenderer = @CLSID_VideoMixingRenderer
          sRendName = "Video Mixing Renderer"
          ;pIndividualRenderer = @CLSID_VideoMixingRenderer9
          ;sRendName = "Video Mixing Renderer 9"
      EndSelect
      
      __MediaDebug("try creating renderer "+Chr(34)+ sRendName+ Chr(34))    
      If CoCreateInstance_(pIndividualRenderer, #Null, #CLSCTX_INPROC, @IID_IBaseFilter, @pVideoRender) = #S_OK
        *obj\pVideoRender = pVideoRender
        
        If *obj\pGraphBuilder\AddFilter(pVideoRender, L(*temp, sRendName)) = #S_OK
          
          If iVidRenderer = #RENDERER_VMR7
            
            ;2010-07-23 added             
            *obj\pVMR7Mixer = #Null
            
            If bForceVMR7Overlay = #False
              If *obj\pVideoRender
                *obj\pVideoRender\QueryInterface(@IID_IVMRMixerBitmap, @*obj\pVMR7Mixer.IVMRMixerBitmap) 
              EndIf
              If *obj\pVMR7Mixer = #Null
                __MediaDebug("WARN: Cannot get VMR7 mixer")  
              EndIf              
            Else
              __MediaDebug("WARN: Do not privide VMR7 mixer (ForceOverlay)") ; Nvidia macht probleme...
            EndIf
            
            
            If bWindowless
              __SetRenderingModeVMR7(*obj\pVideoRender, hWndParent, #VMRMODE_WINDOWLESS, bForceVMR7Overlay)
            Else
              __SetRenderingModeVMR7(*obj\pVideoRender, hWndParent, #VMRMODE_WINDOWED, bForceVMR7Overlay)              
            EndIf
            ;Must be called later after the media was loaded
            ;__SetAspectRatioModeVMR7(*obj\pVideoRender, 0)
            If bWindowless
              pVideoRender\QueryInterface(@IID_IVMRWindowlessControl, @*obj\pVMR7Window)      
            EndIf     
          EndIf
          
          If iVidRenderer = #RENDERER_VMR9
            
            If bOwnVMR9Allocator            
              __MediaDebug("do not query for mixer... (not useable)") ;2010-07-23 added
              
              __SetRenderingModeVMR9(*obj\pVideoRender, hWndParent, #VMRMODE_RENDERLESS) 
              *obj\bIsRenderlessVMR9 = #True
              If __SetAllocatorPresenter( *obj\pVideoRender,hWndParent, *obj, *obj\iUserId) <> #S_OK 
                __MediaDebug("__SetAllocatorPresenter() failed, removing renderless filter...")
                *obj\pGraphBuilder\RemoveFilter(*obj\pVideoRender)
                *obj\pVideoRender\Release()
                __SVMRSurfaceAllocator9_Release(*obj\pAllocator) ; 2012-08-10
                __SVMRImagePresenter9_Release(*obj\pImagePresenter); 2012-08-10
                *obj\bIsRenderlessVMR9 = #False
                *obj\pVideoRender = #Null ;2010-08-06                  
                bFail = #True
              EndIf
            Else
              
              ;2010-07-23 added
              *obj\pVMR9Mixer = #Null
              If *obj\pVideoRender
                *obj\pVideoRender\QueryInterface(@IID_IVMRMixerBitmap9, @*obj\pVMR9Mixer.IVMRMixerBitmap9)
              EndIf
              If *obj\pVMR9Mixer = #Null
                __MediaDebug("WARN: Cannot get VMR9 mixer")  
              EndIf
              
              If bWindowless
                __SetRenderingModeVMR9(*obj\pVideoRender, hWndParent, #VMRMODE_WINDOWLESS)
              Else
                __SetRenderingModeVMR9(*obj\pVideoRender, hWndParent, #VMRMODE_WINDOWED)              
              EndIf
              ;Must be called later after the media was loaded
              ;__SetAspectRatioModeVMR9(*obj\pVideoRender, 0)
              If bWindowless
                pVideoRender\QueryInterface(@IID_IVMRWindowlessControl9, @*obj\pVMR9Window)
              EndIf  
            EndIf
            
          EndIf    
          
          ;Must be called later after the media was loaded            
          ;If iVidRenderer = #RENDERER_OVERLAYMIXER
          ;  __SetAspectRatioModeOverlay(*obj\pVideoRender, 0)
          ;EndIf   
          If bFail = #False
            bResult = #True
          EndIf  
          __MediaDebug("renderer "+Chr(34)+ sRendName+ Chr(34) + " created")         
        Else
          __MediaDebug("Warn: failed to add individual video render filter")
        EndIf 
        
      Else
        __MediaDebug("Warn: failed to create individual video render filter")
      EndIf
      FreeMemory(*temp) 
    EndIf
  EndIf
  ProcedureReturn bResult
EndProcedure
; 
; Procedure __GetUnconnectedPin(pFilter.IBaseFilter,PinDir.i)
;     Protected pEnum.IEnumPins = 0
;     Protected pPin.IPin= 0
;     Protected ThisPinDir.i, hr.i, pTmp.IPin 
; 
;     If pFilter
;       hr = pFilter\EnumPins(@pEnum);
;       If hr <> #S_OK
;           ProcedureReturn #Null
;       EndIf
;   
;       ; Look For the first unconnected pin
;       While (pEnum\Next(1, @pPin, #Null) = #S_OK)
;           pPin\QueryDirection(@ThisPinDir)
;           If (ThisPinDir = PinDir)
;               pTmp.IPin = 0;
;   
;               hr = pPin\ConnectedTo(@pTmp);
;               If hr = #S_OK  ; Already connected, Not the pin we want.
;                   pTmp\Release();
;               Else  ; Unconnected, this is the pin we want.
;                   pEnum\Release();
;                   ProcedureReturn  pPin
;               EndIf
;           EndIf
;           pPin\Release();
;       Wend
;       pEnum\Release();
;     EndIf
;     ; Did Not find a matching pin
;     ProcedureReturn #Null
; EndProcedure
; 
; Procedure __RenderFile(*obj.DSHOW_MEDIABASE, sFile.s)
;   Protected pSource.IBaseFilter, pOutputPin.IPin, pFG.IFilterGraph2, iResult.i = #E_FAIL, *temp
;   
;  
;   *temp = AllocateMemory(32767 * 2)
; ;   CoCreateInstance_(@CLSID_WMAsfReader, #Null, #CLSCTX_INPROC, @IID_IBaseFilter, @pp) 
; ;   *obj\pGraphBuilder\AddFilter(pp, L(*temp,"WM ASF Reader Filter"));
; 
;   If *temp   
;     *obj\pGraphBuilder\AddSourceFilter(sFile, "SOURCE", @pSource)
;     If pSource
;       iResult = *obj\pGraphBuilder\RenderFile(L(*temp, sFile),0)
;       ;pOutputPin.IPin = __GetUnconnectedPin(pSource, #PINDIR_OUTPUT)  
;       ;If pOutputPin
;       ;  If *obj\pGraphBuilder\QueryInterface(@IID_IFilterGraph2, @pFG.IFilterGraph2) = #S_OK 
;       ;    iResult = pFG\RenderFile(L(*temp, sFile),0)
;       ;    ;iResult = pFG\RenderEx(pOutputPin, #AM_RENDEREX_RENDERTOEXISTINGRENDERERS, #Null)
;       ;    pFG\Release()
;       ;  EndIf
;       ;  pOutputPin\Release()
;       ;EndIf
;       pSource\Release()
;     EndIf
;   EndIf
;   ProcedureReturn iResult
; EndProcedure

Procedure __CreateSampleGrabber(*obj.DSHOW_MEDIABASE)
  Protected *temp, med.MediaType, pBase.IBaseFilter, iResult = #E_FAIL
  
  *temp = AllocateMemory(#MAX_PATH * 2)
  If *temp
    If CoCreateInstance_(@CLSID_SampleGrabber, #Null, #CLSCTX_INPROC, @IID_IBaseFilter, @pBase) = #S_OK
      __MediaDebug("sample filter created")
      pBase\QueryInterface(@IID_ISampleGrabber, @*Obj\pSample)
      If *Obj\pSample
        CopyMemory(@MEDIATYPE_Audio,med\majortype, SizeOf(GUID))
        CopyMemory(@MEDIASUBTYPE_PCM,med\subtype, SizeOf(GUID))
        ; CopyMemory(@FORMAT_WaveFormatEx,med\formattype, SizeOf(GUID))
        ; 
        ;  Protected wave.WAVEFORMATEX
        ;    wave\cbSize = SizeOf(WAVEFORMATEX)
        ;    wave\wFormatTag= #WAVE_FORMAT_PCM
        ;    wave\nSamplesPerSec = 22050
        ;    wave\wBitsPerSample = 16
        ;    wave\nChannels = 1
        ;    wave\nBlockAlign =wave\wBitsPerSample / 8 * wave\nChannels
        ;    wave\nAvgBytesPerSec =wave\nSamplesPerSec * wave\nBlockAlign
        ; med\pbFormat = wave
        ; med\cbFormat = SizeOf(WAVEFORMATEX)
        
        If *Obj\pSample\SetMediaType(med) = #S_OK 
          If *obj\pGraphBuilder\AddFilter(pBase, L(*temp, "Sample Grabber Filter")) = #S_OK    
            __MediaDebug("sample filter added")
            iResult = #S_OK
          Else
            __MediaDebug("Warn: Cannot add sample filter")
            *Obj\pSample\Release()
            *Obj\pSample = #Null
          EndIf
        Else
          *Obj\pSample\Release()
          *Obj\pSample = #Null        
        EndIf
        
      EndIf
      pBase\Release()
    EndIf
    FreeMemory(*temp)
  EndIf
  ProcedureReturn iResult
EndProcedure

Procedure __InitSample(*obj.DSHOW_MEDIABASE)
  Protected med.MediaType, *wave.WAVEFORMATEX
  If *obj
    
    If *obj\AudioSampleBuffer = #Null
      *obj\AudioSampleBuffer = AllocateMemory(1024 * 1024)
      *obj\iAudioSampleLength = 1024 * 1024
    EndIf
    
    If *obj\iAudioSampleBitsPerSample = 0
      If *obj\pSample
        
        *obj\pSample\GetConnectedMediaType(med)
        
        *wave =  med\pbFormat
        If *wave
          *obj\iAudioSampleBitsPerSample = *wave\wBitsPerSample
          *obj\iAudioSampleChannels = *wave\nChannels
          *obj\iAudioSampleSamplesPerSec = *wave\nSamplesPerSec
          CoTaskMemFree_(*wave)
        EndIf
        
        *obj\pSample\SetBufferSamples(#True)   
      EndIf
    EndIf
  EndIf
  If *obj\iAudioSampleBitsPerSample
    ProcedureReturn #S_OK
  Else
    ProcedureReturn #E_FAIL
  EndIf
EndProcedure

Procedure __ReadSample(*obj.DSHOW_MEDIABASE)
  Protected sz, *tmp, rest.i, iResult = #E_FAIL, bOk = #True
  If *obj
    *obj\iAudioSampleLastLength = 0
    If *obj\pSample
      If __InitSample(*obj) = #S_OK
        If *obj\AudioSampleBuffer
          *obj\pSample\GetCurrentBuffer( @sz,#Null)
          If sz > 0 And sz < (50 * 1024 * 1024) ; Nicht mehr als 50 MB
            If *obj\iAudioSampleLength < sz
              *tmp = ReAllocateMemory(*obj\AudioSampleBuffer, sz)
              If *tmp
                *obj\AudioSampleBuffer = *tmp
                *obj\iAudioSampleLength = sz 
              Else
                bOk = #False 
              EndIf
            EndIf
            If bOk
              ;rest = *obj\iAudioSampleLength - sz
              ;MoveMemory(*obj\AudioSampleBuffer, *obj\AudioSampleBuffer + sz, rest)
              *obj\iAudioSampleLastLength = sz          
              iResult = *obj\pSample\GetCurrentBuffer(@sz, *obj\AudioSampleBuffer)
            EndIf
          EndIf
        EndIf
      EndIf
    EndIf
  EndIf
  ProcedureReturn iResult
EndProcedure

Procedure __RenderURLFile(*obj.DSHOW_MEDIABASE, sURL.s)
  Protected pAsfSource.IFileSourceFilter , pp.IBaseFilter, pSource.IFileSourceFilter, pOutputPin.IPin, pFG.IFilterGraph2, iResult.i = #E_FAIL, *temp
  Protected pEnum.IEnumPins = 0
  Protected pPin.IPin= 0
  Protected ThisPinDir.i, hr.i, pTmp.IPin, res, bPartly = #False
  __MediaDebug("calling RenderURLFile for " + sURL)
  
  *temp = AllocateMemory(32767 * 2)
  If *temp
    CoCreateInstance_(@CLSID_WMAsfReader, #Null, #CLSCTX_INPROC, @IID_IBaseFilter, @pp) 
    If pp
      If *obj\pGraphBuilder\AddFilter(pp, L(*temp,"WM ASF Reader Filter")) = #S_OK         
        pp\QueryInterface(@IID_IFileSourceFilter, @pAsfSource)
        If pAsfSource        
          pAsfSource\Load(L(*temp, sURL), #Null)
          pp\EnumPins(@pEnum)
          If pEnum
            While (pEnum\Next(1, @pPin, #Null) = #S_OK)
            res =  *obj\pGraphBuilder\Render(pPin)
            __MediaDebug("Render returing " + Hex(res))
            
            If res = #VFW_S_DUPLICATE_NAME:bPartly=#True:res = #S_OK:EndIf
            If res = #VFW_S_AUDIO_NOT_RENDERED:bPartly=#True:res = #S_OK:EndIf          
            If res = #VFW_S_VIDEO_NOT_RENDERED:bPartly=#True:res = #S_OK:EndIf          
            If res = #VFW_S_PARTIAL_RENDER:bPartly=#True:res = #S_OK:EndIf   
            
            If bPartly=#True
              __MediaDebug("Render was only partly sucessful")  
            EndIf
            
            If res = #S_OK  
              iResult = #S_OK
            EndIf
            pPin\Release()
          Wend
          pEnum\Release()
        EndIf        
        pAsfSource\Release()
      EndIf
    EndIf
    pp\Release()
  EndIf
  FreeMemory(*temp)
EndIf

ProcedureReturn iResult
EndProcedure

Procedure.s __RendererToString(iRenderer)
  Select iRenderer
    Case #RENDERER_DEFAULT
      ProcedureReturn "RENDERER_DEFAULT"
    Case #RENDERER_DSHOWDEFAULT
      ProcedureReturn "RENDERER_DSHOWDEFAULT"
    Case #RENDERER_DSOUND
      ProcedureReturn "RENDERER_DSOUND"
    Case #RENDERER_OLDVIDEO
      ProcedureReturn "RENDERER_OLDVIDEO"
    Case #RENDERER_OVERLAYMIXER
      ProcedureReturn "RENDERER_OVERLAYMIXER"      
    Case #RENDERER_VMR7
      ProcedureReturn "RENDERER_VMR7"
    Case #RENDERER_VMR9
      ProcedureReturn "RENDERER_VMR9"   
    Case #RENDERER_WAVEOUT
      ProcedureReturn "RENDERER_WAVEOUT"    
  EndSelect
EndProcedure


Procedure.s __BuildLoadMediaInfoString(sFilename.s, hWndParent, VideoRenderer, bWindowless, AudioRenderer, bEraseBackground.i, bFromURL.i, bSampleGrabber.i, bOwnVMR9Allocator.i, bForceVMR7Overlay)
  __MediaDebug("=======================")
  __MediaDebug("LoadMedia " + sFilename)
  __MediaDebug("VideoRenderer:" + __RendererToString(VideoRenderer))
  __MediaDebug("AudioRenderer:" + __RendererToString(AudioRenderer))  
  __MediaDebug("Windowless " + Str(bWindowless))
  __MediaDebug("EraseBkGnd " + Str(bEraseBackground))  
  __MediaDebug("FromURL " + Str(bFromURL)) 
  __MediaDebug("SampleGrabber " + Str(bSampleGrabber))    
  __MediaDebug("OwnVMR9Allocator " + Str(bOwnVMR9Allocator))  
  __MediaDebug("ForceVMR7Overlay " + Str(bForceVMR7Overlay))   
  __MediaDebug("=======================")  
EndProcedure


; bForceVMR7Overlay does not work at the moment!
Procedure __LoadMedia(*obj.DSHOW_MEDIABASE, sFilename.s, hWndParent, VideoRenderer, bWindowless, AudioRenderer, bEraseBackground.i, bFromURL.i, bSampleGrabber.i, bOwnVMR9Allocator.i, bForceVMR7Overlay.i)
  Protected pFilter.IBaseFilter, pEnum.IEnumFilters, bPartly = #False
  Protected iWidth,i, iHeight.i, cFetched, res.i = #E_ABORT
  Protected bIndividualVideoRenderer.i = #False, bIndividualAudioRenderer.i = #False, *temp, bResult.i = #False
  Protected *usedRenderer.IBaseFilter, IsOverlaySubType.i, iCheckWidth.i ; used for ForrceVRM7Ovelray 
  Protected iStyle.i
  DSHOW_OVERLAY_FAILED = #False
  
  If *obj
    
    __BuildLoadMediaInfoString(sFilename.s, hWndParent, VideoRenderer, bWindowless, AudioRenderer, bEraseBackground, bFromURL, bSampleGrabber, bOwnVMR9Allocator, bForceVMR7Overlay)
    
    ;If bFromURL
    ;  DeleteUrlCacheEntry_(sFilename) 
    ;EndIf
    
    ;2012-08-18 Avoids ugly redraw bug with vista (without DWM)
    If IsWindow_(hWndParent)
      iStyle = GetWindowLong_(hWndParent, #GWL_STYLE)
      If iStyle & #WS_CLIPCHILDREN = 0
        SetWindowLong_(hWndParent, #GWL_STYLE, GetWindowLong_(hWndParent, #GWL_STYLE) | #WS_CLIPCHILDREN)
        UpdateWindow_(hWndParent)
      EndIf        
    EndIf  
    
    *obj\bForceVMR7Overlay = bForceVMR7Overlay ;2011-05-07
    
    *temp = AllocateMemory(32767 * 2)
    If *temp    
      
      If VideoRenderer <> #RENDERER_DSHOWDEFAULT
        
        ;Define audio renderer
        If AudioRenderer <> #RENDERER_DEFAULT
          bIndividualAudioRenderer = __CreateIndividualAudioRenderer(*obj, AudioRenderer)  
        EndIf
        
        If bIndividualAudioRenderer = #False
          bIndividualAudioRenderer = __CreateIndividualAudioRenderer(*obj, #RENDERER_DSOUND)
          If bIndividualAudioRenderer
            AudioRenderer = #RENDERER_DSOUND
          EndIf
        EndIf
        
        If bIndividualAudioRenderer = #False
          bIndividualAudioRenderer = __CreateIndividualAudioRenderer(*obj, #RENDERER_WAVEOUT)
          If bIndividualAudioRenderer
            AudioRenderer = #RENDERER_WAVEOUT
          EndIf
        EndIf                
               
        If bForceVMR7Overlay = #False
          ;Define video renderer
          If VideoRenderer <> #RENDERER_DEFAULT
            bIndividualVideoRenderer = __CreateIndividualVideoRenderer(*obj, hWndParent, VideoRenderer, bWindowless, bOwnVMR9Allocator, bForceVMR7Overlay)      
            __MediaDebug("create video renderer result:"+Str(bIndividualVideoRenderer))  
          EndIf
          
          ;If __DWM_IsEnabled() ; redraw bug, seems to be a problem of the  mirror/layered  window used by greenforce player 
          If bIndividualVideoRenderer = #False
            bIndividualVideoRenderer = __CreateIndividualVideoRenderer(*obj, hWndParent, #RENDERER_VMR9, bWindowless, bOwnVMR9Allocator, bForceVMR7Overlay)
            __MediaDebug("create video renderer result:"+Str(bIndividualVideoRenderer))  
            If bIndividualVideoRenderer   
              VideoRenderer = #RENDERER_VMR9
            EndIf  
          EndIf
          
          ;2010-10-09 hinzugefgt
          If bIndividualVideoRenderer = #False
            If bOwnVMR9Allocator
              bOwnVMR9Allocator = #False  
            Else
              bOwnVMR9Allocator = #True
            EndIf
            __MediaDebug("Change ownAllocator flag to "+Str(bOwnVMR9Allocator))
            bIndividualVideoRenderer = __CreateIndividualVideoRenderer(*obj, hWndParent, #RENDERER_VMR9, bWindowless, bOwnVMR9Allocator, bForceVMR7Overlay)
            __MediaDebug("create video renderer result:"+Str(bIndividualVideoRenderer))  
            If bIndividualVideoRenderer   
              VideoRenderer = #RENDERER_VMR9
            EndIf  
          EndIf
          
          If bIndividualVideoRenderer = #False
            bIndividualVideoRenderer = __CreateIndividualVideoRenderer(*obj, hWndParent, #RENDERER_VMR7, bWindowless, bOwnVMR9Allocator, bForceVMR7Overlay)
            __MediaDebug("create video renderer result:"+Str(bIndividualVideoRenderer))  
            If bIndividualVideoRenderer   
              VideoRenderer = #RENDERER_VMR7
            EndIf  
          EndIf
          
          If bIndividualVideoRenderer = #False
            bIndividualVideoRenderer = __CreateIndividualVideoRenderer(*obj, hWndParent, #RENDERER_OVERLAYMIXER, bWindowless, bOwnVMR9Allocator, bForceVMR7Overlay)
            __MediaDebug("create video renderer result:"+Str(bIndividualVideoRenderer))  
            If bIndividualVideoRenderer   
              VideoRenderer = #RENDERER_OVERLAYMIXER
            EndIf  
          EndIf 
          
          If bIndividualVideoRenderer = #False
            bIndividualVideoRenderer = __CreateIndividualVideoRenderer(*obj, hWndParent, #RENDERER_OLDVIDEO, bWindowless, bOwnVMR9Allocator, bForceVMR7Overlay)
            __MediaDebug("create video renderer result:"+Str(bIndividualVideoRenderer))  
            If bIndividualVideoRenderer   
              VideoRenderer = #RENDERER_OLDVIDEO
            EndIf  
          EndIf 
          
        Else
          ;Force VMR7 with overlay
          bIndividualVideoRenderer = __CreateIndividualVideoRenderer(*obj, hWndParent, #RENDERER_VMR7, bWindowless, bOwnVMR9Allocator, bForceVMR7Overlay)
          __MediaDebug("create video renderer result:"+Str(bIndividualVideoRenderer))  
          If bIndividualVideoRenderer   
            VideoRenderer = #RENDERER_VMR7
          EndIf          
        EndIf
        
      EndIf
      
      
      *obj\bRenderlessVMR9PresentCalled = #False ;2012-08-18
      *obj\bAutoDVDControl = #True
      *obj\bAllowEraseBackground = bEraseBackground
      *obj\bBackgroundErased = #False ;TEST
      
      If bIndividualVideoRenderer = #False:bWindowless = #False:EndIf
      If VideoRenderer <> #RENDERER_VMR9 And VideoRenderer <> #RENDERER_VMR7:bWindowless = #False:EndIf
      *obj\bWindowless = bWindowless ; 2010-08-02 MUSS UNTERHALB BELIBEN!!!
      *obj\iAudioRenderer = AudioRenderer
      *obj\iVideoRenderer = VideoRenderer
      
      If bSampleGrabber
        __CreateSampleGrabber(*obj)
      EndIf
      
      ;-Strange bug with individual
      ;There seems to be a memory leak if a individual video renderer is used with pGraphBuilder\RenderFile() (create 200 media object..)  --> Seems bug with Windows 7 sample videos see wildlife.wmv aka natur.wmv
      ;So we will skin VMR9 if no audio renderer could be found
      ;If VideoRenderer <> #RENDERER_DSHOWDEFAULT
      ;  If bIndividualVideoRenderer And bIndividualAudioRenderer
      ;    res = __RenderFile(*obj, sFilename)
      ;  EndIf
      ;Else
      
      ;EndIf
      
      If bFromURL        
        res = __RenderURLFile(*obj, sFilename)
        
        If res <> #S_OK
          res = *obj\pGraphBuilder\RenderFile(L(*temp, sFilename), #Null) 
          __MediaDebug("RenderFile returing " + Hex(res))
          ; Auch wenn nur teilweise geladen durchlassen
          If res = #VFW_S_DUPLICATE_NAME:bPartly = #True:res = #S_OK:EndIf
          If res = #VFW_S_AUDIO_NOT_RENDERED:bPartly = #True:res = #S_OK:EndIf          
          If res = #VFW_S_VIDEO_NOT_RENDERED:bPartly = #True:res = #S_OK:EndIf          
          If res = #VFW_S_PARTIAL_RENDER:bPartly = #True:res = #S_OK:EndIf   
          
          If bPartly = #True
            __MediaDebug("RenderFile was only partly sucessful")  
          EndIf               
        EndIf
      Else
        res = *obj\pGraphBuilder\RenderFile(L(*temp, sFilename), #Null) 
        __MediaDebug("RenderFile returing " + Hex(res))
        ; Auch wenn nur teilweise geladen durchlassen
        If res = #VFW_S_DUPLICATE_NAME:bPartly=#True:res = #S_OK:EndIf
        If res = #VFW_S_AUDIO_NOT_RENDERED:bPartly=#True:res = #S_OK:EndIf          
        If res = #VFW_S_VIDEO_NOT_RENDERED:bPartly=#True:res = #S_OK:EndIf          
        If res = #VFW_S_PARTIAL_RENDER:bPartly=#True:res = #S_OK:EndIf   
        
        If bPartly = #True
          __MediaDebug("RenderFile was only partly sucessful")  
        EndIf
        
        If res <> #S_OK
          __MediaDebug("Warn: RenderFile failed for " + sFilename + ", try RenderURLFile")
          res = __RenderURLFile(*obj, sFilename)   ; wird z.B. fr manche mp3 Dateien bentigt (knnen sonst nicht geladen werden)       
        EndIf
      EndIf
      
      
      
      ;2011-07-28 ugly test for overlay mixer
      ;       If DSHOW_ENABLE_RENDERER_TESTING And res = #S_OK
      ;         DSHOW_IS_RENDERER_EQUAL = #False
      ;         __MediaDebug("testing renderer")
      ;         *usedRenderer = FindVideoRenderer(*Obj\pGraphBuilder, @IsOverlaySubType)
      ;         If *obj\pVideoRender = *usedRenderer And *usedRenderer <> #Null And IsOverlaySubType = #True
      ;           DSHOW_IS_RENDERER_EQUAL = #True
      ;           res = #E_FAIL  ;Fail
      ;           __MediaError("Testing renderer failed!")  
      ;         Else
      ;           __MediaDebug("Testing renderer: ok")         
      ;         EndIf
      ;         If *usedRenderer
      ;           *usedRenderer\Release()
      ;           *usedRenderer = #Null
      ;         EndIf         
      ;       EndIf
      
      
      ;Check if all ok, if VMR7 with Overlay is forced!
      If bForceVMR7Overlay And res = #S_OK  ;2012-03-30 Only check if file can be played back!!!
        
        If bIndividualVideoRenderer = #False
          __MediaError("VMR7 Overlay failed (no individual renderer)")
          res = #E_FAIL
          DSHOW_OVERLAY_FAILED = #True ; 2012-03-30
        EndIf  
        
        *usedRenderer = FindVideoRenderer(*Obj\pGraphBuilder)
        
        If *usedRenderer = #Null 
          ;Overlay is only needed if video is played back (not for audio), For audio the thet would fail   
          __MediaDebug("VMR7 Overlay: no video found, expecting audio only... (no overlay protection needed)")
          ;__MediaError("VMR7 Overlay failed (determining used renderer failed)")           
          ;res = #E_FAIL
          ;DSHOW_OVERLAY_FAILED = #True ; 2012-03-30         
          
        Else
          If *obj\pVideoRender <> *usedRenderer
            __MediaError("VMR7 Overlay failed (not the correct renderer used!)")           
            res = #E_FAIL
            DSHOW_OVERLAY_FAILED = #True ; 2012-03-30
          Else
            __MediaDebug("VMR7 Overlay correctly set")
          EndIf            
          
        EndIf  
        
        If *usedRenderer
          *usedRenderer\Release()
          *usedRenderer = #Null
        EndIf  
        
      EndIf  
      
      If res = #S_OK
        *obj\hWnd = #Null
        If hWndParent
          *obj\hWnd = hWndParent
          If bWindowless = #False
            *obj\pVideo\get_SourceWidth(@iWidth)
            *obj\pWindow\put_width(iWidth) 
            *obj\pVideo\get_SourceHeight(@iHeight)
            *obj\pWindow\put_Height(iWidth) 
            *obj\pWindow\put_Left(0)
            *obj\pWindow\put_Top(0)
            *obj\pWindow\put_Owner(hWndParent)
            *obj\pWindow\put_WindowStyle(#WS_CHILD| #WS_CLIPSIBLINGS)
            *obj\pWindow\put_Visible(#OATRUE)
          EndIf
        EndIf
        
        If *obj\pEvent\SetNotifyWindow(hWndParent, #WM_GRAPHNOTIFY, *obj) = #S_OK  ; 2012-08-18
          If *obj\pEvent\SetNotifyFlags(0) <> #S_OK
          EndIf
        Else
          __MediaDebug("Warn: failed to set notification callback")
        EndIf 
        
        If bIndividualVideoRenderer = #False
          If *obj\pGraphBuilder\EnumFilters(@pEnum) = #S_OK
            While pEnum\Next(1, @pFilter, @cFetched) = #S_OK 
            
            If pFilter  
              
              ;Would have no effect
              ;If bWindowless
              ;  __SetRenderingModeVMR7(pFilter, hWndParent, #VMRMODE_WINDOWLESS, #False)
              ;  __SetRenderingModeVMR9(pFilter, hWndParent, #VMRMODE_WINDOWLESS, #False)
              ;Else
              ;  __SetRenderingModeVMR7(pFilter, hWndParent, #VMRMODE_WINDOWED, #False)
              ;  __SetRenderingModeVMR9(pFilter, hWndParent, #VMRMODE_WINDOWED, #False)
              ;EndIf
              
              
              ;Now needed to enable mixing...
              ;Also deos not work here (after render file seems to be too late...) 
              ;__SetRenderingModeVMR7(pFilter, hWndParent, #VMRMODE_WINDOWED, #False, #Null, #False)
              ;__SetRenderingModeVMR9(pFilter, hWndParent, #VMRMODE_WINDOWED, #False, #Null, #False)
              
              
              If __SetAspectRatioModeOverlay(pFilter, 0, #True)
                ;pFilter\AddRef()
                ;*obj\pVideoRender = pFilter
                *obj\iVideoRenderer = #RENDERER_OVERLAYMIXER 
                __MediaDebug("Detected Overlay Mixer")
              EndIf
              If __SetAspectRatioModeVMR7(pFilter, 0, #True)
                ;pFilter\AddRef()
                ;*obj\pVideoRender = pFilter
                *obj\iVideoRenderer = #RENDERER_VMR7                   
                __MediaDebug("Detected VMR7")   
                
                ;2010-08-02 moved
                If bForceVMR7Overlay = #False
                  *obj\pVMR7Mixer = #Null
                  If pFilter
                    pFilter\QueryInterface(@IID_IVMRMixerBitmap, @*obj\pVMR7Mixer.IVMRMixerBitmap)
                  EndIf
                  If *obj\pVMR7Mixer = #Null
                    __MediaDebug("WARN: Cannot get VMR7 mixer")  
                  EndIf
                Else
                  __MediaDebug("WARN: Do not provide VMR7 mixer (ForceOverlay)") ; probleme mit Nvidia
                EndIf
                
              EndIf                   
              If __SetAspectRatioModeVMR9(pFilter, 0, #True)
                ;pFilter\AddRef()
                ;*obj\pVideoRender = pFilter                  
                *obj\iVideoRenderer = #RENDERER_VMR9                
                __MediaDebug("Detected VMR9")
                
                ;2010-08-02 moved
                *obj\pVMR9Mixer = #Null
                If pFilter
                  pFilter\QueryInterface(@IID_IVMRMixerBitmap9, @*obj\pVMR9Mixer.IVMRMixerBitmap9)
                EndIf
                If *obj\pVMR9Mixer = #Null
                  __MediaDebug("WARN: Cannot get VMR9 mixer")  
                EndIf                  
              EndIf
              
              ;We do not need the name...   
              ;pFilter\QueryFilterInfo(@FilterInfo)   
              ;__MediaDebug(PeekS(@FilterInfo\achName, #MAX_FILTER_NAME, #PB_Unicode))
              ;If FilterInfo\pGraph <> #Null     
              ;  FilterInfo\pGraph\Release()
              ;EndIf 
              pFilter\Release()
            EndIf;
          Wend
          pEnum\Release()
        Else
          __MediaDebug("Warn: cannot enum filters")
        EndIf    
        
      Else        
        If VideoRenderer = #RENDERER_VMR7
          __SetAspectRatioModeVMR7(*obj\pVideoRender, 0)
          
          ;2010-08-02 MOVED (BUG!)
          ;2010-07-23 added             
          ;             *obj\pVMR7Mixer = #Null
          ;             If *obj\pVideoRender
          ;               *obj\pVideoRender\QueryInterface(@IID_IVMRMixerBitmap, @*obj\pVMR7Mixer.IVMRMixerBitmap)
          ;             EndIf
          ;             If *obj\pVMR7Mixer = #Null
          ;               __MediaDebug("WARN: Cannot get VMR7 mixer")  
          ;             EndIf
        EndIf
        
        If VideoRenderer = #RENDERER_VMR9
          __SetAspectRatioModeVMR9(*obj\pVideoRender, 0)
          
          ;2010-08-02 MOVED (BUG!)
          ;2010-07-23 added             
          ;             *obj\pVMR9Mixer = #Null
          ;             If *obj\pVideoRender
          ;               *obj\pVideoRender\QueryInterface(@IID_IVMRMixerBitmap9, @*obj\pVMR9Mixer.IVMRMixerBitmap9)
          ;             EndIf
          ;             If *obj\pVMR9Mixer = #Null
          ;               __MediaDebug("WARN: Cannot get VMR9 mixer")  
          ;             EndIf
          
        EndIf
        If VideoRenderer = #RENDERER_OVERLAYMIXER
          __SetAspectRatioModeOverlay(*obj\pVideoRender, 0)
        EndIf 
        
      EndIf
      
      ; Video and audio renderer must be released
      ;2010-08-17 do not free it here now...
      ;         If *obj\pVideoRender
      ;           *obj\pVideoRender\Release()
      ;           *obj\pVideoRender = #Null
      ;         EndIf
      ;         If *obj\pAudioRender
      ;           *obj\pAudioRender\Release()
      ;           *obj\pAudioRender = #Null
      ;         EndIf
      
      __AddBkgndEraseFromWindow(*obj, *obj\hWnd)
      *obj\pSeeking\SetTimeFormat(@TIME_FORMAT_MEDIA_TIME) 
      
      *obj\iDestWidth = DShow_GetMediaWidth(*obj)
      *obj\iDestHeight = DShow_GetMediaHeight(*obj) 
      *obj\iSourceWidth = DShow_GetMediaWidth(*obj)
      *obj\iSourceHeight = DShow_GetMediaHeight(*obj) 
      *obj\src\left = 0
      *obj\src\top = 0
      *obj\dst\left = 0
      *obj\dst\top = 0        
      *obj\src\right = DShow_GetMediaWidth(*obj)
      *obj\src\bottom = DShow_GetMediaHeight(*obj)        
      *obj\dst\right = DShow_GetMediaWidth(*obj)
      *obj\dst\bottom = DShow_GetMediaHeight(*obj)        
      
      If *obj\bWindowless    
        If *obj\pVMR7Window
          *obj\pVMR7Window\SetVideoPosition(*obj\src, *obj\dst)
        ElseIf *obj\pVMR9Window
          *obj\pVMR9Window\SetVideoPosition(*obj\src, *obj\dst)
        EndIf
      EndIf
      
      bResult = #True
    Else
      __MediaError("Error: cannot render file!")
    EndIf 
    
    FreeMemory(*temp)
  Else
    __MediaError("Error: cannot allocate memory")      
  EndIf
Else 
  __MediaError("Error: media object not initialized")
EndIf
ProcedureReturn bResult
EndProcedure

Procedure __LoadDVDMedia(*obj.DSHOW_MEDIABASE, sVolume.s, hWndParent.i, bEraseBackground.i)
  Protected pFilter.IBaseFilter, pEnum.IEnumFilters, Status.AM_DVD_RENDERSTATUS
  Protected iWidth,i, iHeight.i, cFetched, *Pointer, ch.i, sTemp.s
  Protected *temp, bResult.i = #False, iSuccess.i = #E_FAIL
  If *obj
    
    *temp = AllocateMemory(#MAX_PATH * 2)
    If *temp
      
      *obj\bForceVMR7Overlay= #False ;2011-05-06
      
      *obj\bAutoDVDControl = #True
      *obj\bAllowEraseBackground = bEraseBackground
      *obj\bBackgroundErased = #False   
      *obj\bWindowless = #False
      *obj\iVideoRenderer = #RENDERER_DEFAULT
      *obj\iAudioRenderer = #RENDERER_DEFAULT
      *obj\bAutoDVDControl = #True
      ;*obj\sVolume = Left(sVolume, 1)
      
      If Trim(sVolume) = ""
        *Pointer = #Null
      Else    
        For ch = 'A' To 'Z'
          sTemp.s = Trim(UCase(sVolume)) 
          If sTemp = Chr(ch) Or sTemp = Chr(ch) + ":" Or sTemp = Chr(ch) + ":\"
            sVolume = Chr(ch) + ":\VIDEO_TS"
          EndIf
        Next
        *Pointer = L(*temp, sVolume)
      EndIf
      ;
      ;If __DWM_IsEnabled() ; redraw bug, seems to be a problem of the mirror/layered window used by greenforce player         
      ;First try VMR9
      iSuccess = *obj\pDVDGraphBuilder\RenderDvdVideoVolume(*Pointer, #AM_DVD_VMR9_ONLY, Status)
      ;Else
      ;  __MediaDebug("Do not use VMR9 as DWM is not active...")        
      ;EndIf     
      If iSuccess <> #S_OK
        iSuccess = *obj\pDVDGraphBuilder\RenderDvdVideoVolume(*Pointer, 0, Status)
      EndIf
      
      If iSuccess = #S_OK
        *obj\hWnd = #Null
        If hWndParent
          *obj\hWnd = hWndParent
          *obj\pVideo\get_SourceWidth(@iWidth)
          *obj\pWindow\put_width(iWidth) 
          *obj\pVideo\get_SourceHeight(@iHeight)
          *obj\pWindow\put_Height(iWidth) 
          *obj\pWindow\put_Left(0)
          *obj\pWindow\put_Top(0)
          *obj\pWindow\put_Owner(hWndParent)
          *obj\pWindow\put_WindowStyle(#WS_CHILD| #WS_CLIPSIBLINGS)
          *obj\pWindow\put_Visible(#OATRUE)
        EndIf
        If *obj\pEvent\SetNotifyWindow(GetForegroundWindow_(), #WM_GRAPHNOTIFY, *obj) = #S_OK 
          If *obj\pEvent\SetNotifyFlags(0) <> #S_OK
          EndIf
        Else
          __MediaDebug("Warn: failed to set notification callback")
        EndIf 
        
        If *obj\pDVDGraphBuilder\GetDvdInterface(@IID_IDvdControl2, @*obj\pDVDControl) = #S_OK
          If *obj\pDVDGraphBuilder\GetDvdInterface(@IID_IDvdInfo2, @*obj\pDVDInfo) = #S_OK
            
            If *obj\pGraphBuilder\EnumFilters(@pEnum) = #S_OK
              While pEnum\Next(1, @pFilter, @cFetched) = #S_OK 
              
              If pFilter  
                ;Would have no effect
                ;                     If bWindowless
                ;                       __SetRenderingModeVMR7(pFilter, hWndParent, #VMRMODE_WINDOWLESS, #True)
                ;                       __SetRenderingModeVMR9(pFilter, hWndParent, #VMRMODE_WINDOWLESS, #True)
                ;                     Else
                ;                       __SetRenderingModeVMR7(pFilter, hWndParent, #VMRMODE_WINDOWED, #True)
                ;                       __SetRenderingModeVMR9(pFilter, hWndParent, #VMRMODE_WINDOWED, #True)
                ;                     EndIf
                
                If __SetAspectRatioModeOverlay(pFilter, 0, #True)
                  ;pFilter\AddRef()
                  ;*obj\pVideoRender = pFilter
                  *obj\iVideoRenderer = #RENDERER_OVERLAYMIXER 
                  __MediaDebug("Detected Overlay Mixer")
                EndIf
                If __SetAspectRatioModeVMR7(pFilter, 0, #True)
                  ;pFilter\AddRef()
                  ;*obj\pVideoRender = pFilter
                  *obj\iVideoRenderer = #RENDERER_VMR7                   
                  __MediaDebug("Detected VMR7")      
                  ;We could query for VRMMixer here...
                EndIf                   
                If __SetAspectRatioModeVMR9(pFilter, 0, #True)
                  ;pFilter\AddRef()
                  ;*obj\pVideoRender = pFilter                  
                  *obj\iVideoRenderer = #RENDERER_VMR9                
                  __MediaDebug("Detected VMR9")
                  ;We could query for VRMMixer here...
                EndIf                  
                
                ;If __SetAspectRatioModeOverlay(pFilter, 0, #True):*obj\iVideoRenderer = #RENDERER_OVERLAYMIXER:__MediaDebug("Detected Overlay Mixer"):EndIf
                ;If __SetAspectRatioModeVMR7(pFilter, 0, #True):*obj\iVideoRenderer = #RENDERER_VMR7:__MediaDebug("Detected VMR7"):EndIf
                ;If __SetAspectRatioModeVMR9(pFilter, 0, #True):*obj\iVideoRenderer = #RENDERER_VMR9:__MediaDebug("Detected VMR9"):EndIf                  
                
                ;We do not need the name...   
                ;pFilter\QueryFilterInfo(@FilterInfo)   
                ;__MediaDebug(PeekS(@FilterInfo\achName, #MAX_FILTER_NAME, #PB_Unicode))
                ;If FilterInfo\pGraph <> #Null     
                ;  FilterInfo\pGraph\Release()
                ;EndIf 
                pFilter\Release()
              EndIf;
            Wend
            pEnum\Release()
          Else
            __MediaDebug("Warn: cannot enum filters")
          EndIf                  
          
          __AddBkgndEraseFromWindow(*obj, *obj\hWnd)
          *obj\pSeeking\SetTimeFormat(@TIME_FORMAT_MEDIA_TIME) 
          bResult = #True
        Else
          __MediaError("Error: cannot get DvdInfo2 interface")            
        EndIf
      Else
        __MediaError("Error: cannot get DvdControl2 interface")     
      EndIf
      
    Else
      __MediaError("Error: cannot render dvd!")
    EndIf 
    
    FreeMemory(*temp)
  Else
    __MediaError("Error: cannot allocate memory")      
  EndIf
Else 
  __MediaError("Error: media object not initialized")
EndIf
ProcedureReturn bResult
EndProcedure

Procedure.i __DShow_GetMediaWidth(*obj.DSHOW_MEDIABASE)
  Protected iWidth.i, iHeight.i
  If *obj 
    *obj\pVideo\GetVideoSize(@iWidth, @iHeight)
    ProcedureReturn iWidth
  EndIf
EndProcedure

Procedure.i __DShow_GetMediaHeight(*obj.DSHOW_MEDIABASE)
  Protected iWidth.i, iHeight.i
  If *obj 
    *obj\pVideo\GetVideoSize(@iWidth, @iHeight)
    ProcedureReturn iHeight
  EndIf
EndProcedure

Procedure.i __DShowVMR9_GetMediaWidth(*obj.DSHOW_MEDIABASE)
  Protected iWidth.i, iHeight.i,iAspectX.i,iAspectY.i
  If *obj 
    *obj\pVMR9Window\GetNativeVideoSize(@iWidth, @iHeight, @iAspectX, @iAspectY)
    ProcedureReturn iWidth
  EndIf
EndProcedure

Procedure.i __DShowVMR9_GetMediaHeight(*obj.DSHOW_MEDIABASE)
  Protected iWidth.i, iHeight.i,iAspectX.i,iAspectY.i
  If *obj 
    *obj\pVMR9Window\GetNativeVideoSize(@iWidth, @iHeight, @iAspectX, @iAspectY)
    ProcedureReturn iHeight
  EndIf
EndProcedure

Procedure.i __DShowVMR7_GetMediaWidth(*obj.DSHOW_MEDIABASE)
  Protected iWidth.i, iHeight.i,iAspectX.i,iAspectY.i
  If *obj 
    *obj\pVMR7Window\GetNativeVideoSize(@iWidth, @iHeight, @iAspectX, @iAspectY)
    ProcedureReturn iWidth
  EndIf
EndProcedure

Procedure.i __DShowVMR7_GetMediaHeight(*obj.DSHOW_MEDIABASE)
  Protected iWidth.i, iHeight.i,iAspectX.i,iAspectY.i
  If *obj 
    *obj\pVMR7Window\GetNativeVideoSize(@iWidth, @iHeight, @iAspectX, @iAspectY)
    ProcedureReturn iHeight
  EndIf
EndProcedure

Procedure.i DShow_GetMediaWidth(*obj.DSHOW_MEDIABASE)
  If *obj 
    If *obj\bIsRenderlessVMR9
      ProcedureReturn *obj\m_AllocatorImageWidth  
    Else
      If *obj\bWindowless    
        If *obj\pVMR7Window
          ProcedureReturn __DShowVMR7_GetMediaWidth(*obj)    
        ElseIf *obj\pVMR9Window
          ProcedureReturn __DShowVMR9_GetMediaWidth(*obj)
        EndIf
      Else
        ProcedureReturn __DShow_GetMediaWidth(*obj)
      EndIf
    EndIf
  EndIf
EndProcedure

Procedure.i DShow_GetMediaHeight(*obj.DSHOW_MEDIABASE)
  If *obj 
    
    If *obj\bIsRenderlessVMR9
      ProcedureReturn *obj\m_AllocatorImageHeight
    Else
      If *obj\bWindowless    
        If *obj\pVMR7Window
          ProcedureReturn __DShowVMR7_GetMediaHeight(*obj)    
        ElseIf *obj\pVMR9Window
          ProcedureReturn __DShowVMR9_GetMediaHeight(*obj)
        EndIf
      Else
        ProcedureReturn __DShow_GetMediaHeight(*obj)
      EndIf
    EndIf
  EndIf
EndProcedure

Procedure.i DShow_GetActiveVideoRenderer(*obj.DSHOW_MEDIABASE)
  If *obj 
    ProcedureReturn *obj\iVideoRenderer
  EndIf
EndProcedure

Procedure.i DShow_IsWindowlessRenderer(*obj.DSHOW_MEDIABASE)
  If *obj 
    ProcedureReturn *obj\bWindowless
  EndIf
EndProcedure


Procedure.i DShow_IsRenderlessVMR9(*obj.DSHOW_MEDIABASE)
  If *obj 
    ProcedureReturn *obj\bIsRenderlessVMR9
  EndIf
EndProcedure

Procedure.i DShow_GetOwnVMR9Direct3DDevice9(*obj.DSHOW_MEDIABASE)
  If *obj 
    If *obj\bIsRenderlessVMR9
      If *obj\pAllocator
        ProcedureReturn *obj\pAllocator\m_D3DDev
      EndIf 
    EndIf  
  EndIf
  ProcedureReturn #Null
EndProcedure


Procedure DShow_FreeMedia(*obj.DSHOW_MEDIABASE)
  Protected iState.i, bAbortFreeing.i, hMutex
  bAbortFreeing = #False
  If *obj
    
    __MediaDebug("Free media object")
    *obj\bBackgroundErased = #False
    __RemoveBkgndEraseFromWindow(*obj, *obj\hWnd)  
    
    If *obj\pEvent
      *obj\pEvent\SetNotifyWindow(#Null, #Null, #Null);
    EndIf
    
    ;Makes sure all events are processed (otherwise it would crash!!!)
    DShow_ProcessMediaEvent(*obj) 
    ;Remove it from the list of valid handles
    __FreeMediaObject(*obj) 
    If *obj\pControl
      *obj\pControl\GetState(16, @iState)
      If iState <> #STATE_STOPPED
        *obj\pControl\Stop()
      EndIf
    EndIf
    
    If *obj\AudioSampleBuffer
      FreeMemory(*obj\AudioSampleBuffer)
    EndIf
    
    ;If *obj\bIsRenderlessVMR9
    ;...
    ;nach unten verschoben, da erst dort alle referenzen entfernt sind (ansonsten bleibt das Objekt im Speicher)
    
    ;2010-07-23 added
    If *obj\pVMR7Mixer
      *obj\pVMR7Mixer\Release()
      *obj\pVMR7Mixer = #Null
    EndIf
    
    If *obj\pVMR9Mixer
      *obj\pVMR9Mixer\Release()
      *obj\pVMR9Mixer = #Null
    EndIf    
    
    If *obj\pWindow
      *obj\pWindow\put_Visible(#OAFALSE)
      *obj\pWindow\put_Owner(#Null)
    EndIf
    If *obj\pAudio
      *obj\pAudio\put_Volume(0)
      ;Free Audio later! see below!
    EndIf
    
    If *obj\pDVDInfo
      *obj\pDVDInfo\Release()
      *obj\pDVDInfo = #Null
    EndIf 
    
    If *obj\pDVDControl
      *obj\pDVDControl\Release()
      *obj\pDVDControl = #Null
    EndIf 
    
    If *obj\pVMR7Window
      *obj\pVMR7Window\Release()
      *obj\pVMR7Window = #Null
    EndIf
    
    If *obj\pVMR9Window
      *obj\pVMR9Window\Release()
      *obj\pVMR9Window = #Null
    EndIf 
    
    If *obj\pSample
      *obj\pSample\Release()
      *obj\pSample = #Null
    EndIf
    
    
    ;     If *obj\pAudioRender And *obj\pGraphBuilder 
    ;       ;*obj\pGraphBuilder\RemoveFilter(*obj\pAudioRender) 
    ;     EndIf
    ;     If *obj\pAudioRender
    ;       ;*obj\pAudioRender\Release()
    ;     EndIf  
    ;     If *obj\pVideoRender And *obj\pGraphBuilder 
    ;      ; *obj\pGraphBuilder\RemoveFilter(*obj\pVideoRender)   
    ;     EndIf     
    ;     If *obj\pVideoRender
    ;      ; *obj\pVideoRender\Release()
    ;     EndIf 
    
    
    If *obj\pSeeking
      *obj\pSeeking\Release()
      *obj\pSeeking = #Null
    EndIf
    
    If *obj\pVideo
      *obj\pVideo\Release()
      *obj\pVideo = #Null
    EndIf
    
    If *obj\pAudio
      *obj\pAudio\Release()
      *obj\pAudio = #Null
    EndIf
    
    If *obj\pWindow
      *obj\pWindow\Release()
      *obj\pWindow = #Null
    EndIf
    
    If *obj\pControl
      *obj\pControl\Release()
      *obj\pControl = #Null
    EndIf
    
    If *obj\pEvent
      *obj\pEvent\Release()
      *obj\pEvent = #Null
    EndIf    
    
    If *obj\pGraphBuilder    
      *obj\pGraphBuilder\Release() 
      *obj\pGraphBuilder = #Null
    EndIf 
    
    If *obj\pDVDGraphBuilder
      *obj\pDVDGraphBuilder\Release()
      *obj\pDVDGraphBuilder = #Null
    EndIf
    
    
    If *obj\bIsRenderlessVMR9
      __SVMRSurfaceAllocator9_Release(*obj\pAllocator)
      __SVMRImagePresenter9_Release(*obj\pImagePresenter)
      
      ;       If *obj\pAllocator
      ;         If *obj\pAllocator\m_RefCount > 0 ; 2010-08-02 > 0 ?
      ;           bAbortFreeing = #True
      ;         EndIf
      ;       EndIf
      ;       If *obj\pImagePresenter
      ;         If *obj\pImagePresenter\m_RefCount > 0 ; 2010-08-02 > 0 ?
      ;           bAbortFreeing = #True
      ;         EndIf
      ;       EndIf          
      ;       ;*obj\pAllocator = #Null
      ;       ;*obj\pImagePresenter = #Null
    EndIf      
    
    
    ;     If bAbortFreeing = #True
    ;       ; At least free the direct3d objects (don't know if this is a good idea!!!)
    ;       If *obj\hMutex
    ;         LockMutex(*obj\hMutex)
    ;         __FreeD3D9_SVMRSurfaceAllocator9(*obj\pAllocator) ;DOES NOT LOCK MUTEX ITSELF!!!
    ;         UnlockMutex(*obj\hMutex)  
    ;       EndIf     
    ;     EndIf  
    
    ;2010-08-17 must be released now and after releasing IVMRSurfaceAllocatorNotify9 object
    ;2010-08-02 both objects should be already released (just to be sure that they are really released)
    If *obj\pVideoRender
      *obj\pVideoRender\Release()
      *obj\pVideoRender = #Null
    EndIf
    If *obj\pAudioRender
      *obj\pAudioRender\Release()
      *obj\pAudioRender = #Null
    EndIf    
    
    
    If *obj\bIsRenderlessVMR9
      If *obj\pAllocator
        If *obj\pAllocator\m_RefCount > 0 ; 2010-08-02 > 0 ???
          bAbortFreeing = #True
        EndIf
      EndIf
      If *obj\pImagePresenter
        If *obj\pImagePresenter\m_RefCount > 0 ; 2010-08-02 > 0 ???
          bAbortFreeing = #True
        EndIf
      EndIf          
    EndIf       
    
    If *obj\hMutex
      If TryLockMutex(*obj\hMutex)
        hMutex = *obj\hMutex
        *obj\hMutex = #Null
        *obj\pAllocator\m_hMutex = #Null
        *obj\pImagePresenter\m_hMutex = #Null
        UnlockMutex(hMutex)
        FreeMutex(hMutex)
      Else
        __MediaError("Cannot free mutex of media object!") 
        bAbortFreeing = #True
      EndIf
    EndIf
    
    If bAbortFreeing = #False
      FreeMemory(*obj)
    Else    
      __MediaError("Leaving media object in memory, because own renderer is not released properly!!!")
      __MediaError("ImagePresenter:RefCount "+ Str(*obj\pImagePresenter\m_RefCount))
      __MediaError("Allocator:RefCount "+ Str(*obj\pAllocator\m_RefCount))      
    EndIf  
    
    ProcedureReturn #True
  EndIf 
EndProcedure

Procedure.i DShow_LoadMediaEx(sFilename.s, hWndParent.i = #Null, VideoRenderer.i = #RENDERER_DEFAULT, bWindowless = #True, AudioRenderer.i = #RENDERER_DEFAULT, bEraseBackground = #False, bSampleGrabber = #True, bOwnVMR9Allocator = #False, bForceVMR7Overlay = #False)
  Protected *obj
  *obj = __CreateMediaObject(#False)
  If *obj
    If __LoadMedia(*obj, sFilename, hWndParent, VideoRenderer, bWindowless, AudioRenderer, bEraseBackground, #False, bSampleGrabber, bOwnVMR9Allocator, bForceVMR7Overlay)
      ProcedureReturn *obj
    Else
      DShow_FreeMedia(*obj)
    EndIf
  EndIf
  ProcedureReturn #Null
EndProcedure

Procedure.i DShow_LoadMediaURLEx(sFilename.s, hWndParent.i = #Null, VideoRenderer.i = #RENDERER_DEFAULT, bWindowless = #True, AudioRenderer.i = #RENDERER_DEFAULT, bEraseBackground = #False, bSampleGrabber = #True, bOwnVMR9Allocator = #False, bForceVMR7Overlay = #False)
  Protected *obj
  *obj = __CreateMediaObject(#False)
  If *obj
    If __LoadMedia(*obj, sFilename, hWndParent, VideoRenderer, bWindowless, AudioRenderer, bEraseBackground, #True, bSampleGrabber, bOwnVMR9Allocator, bForceVMR7Overlay)
      ProcedureReturn *obj
    Else
      DShow_FreeMedia(*obj)
    EndIf
  EndIf
  ProcedureReturn #Null
EndProcedure

Procedure.i DShow_LoadDVDMediaEx(sVolume.s, hWndParent.i = #Null, bEraseBackground.i = #False)
  Protected *obj
  *obj = __CreateMediaObject(#True)
  If *obj
    If __LoadDVDMedia(*obj, sVolume, hWndParent, bEraseBackground)
      ProcedureReturn *obj
    Else
      DShow_FreeMedia(*obj)
    EndIf
  EndIf
  ProcedureReturn #Null
EndProcedure

Procedure.i DShow_LoadMedia(sFilename.s, hWndParent.i = #Null, VideoRenderer.i = #RENDERER_DEFAULT, AudioRenderer.i = #RENDERER_DEFAULT)
  ;2010-04-04 Nun ist windowless standard! Bei Windowed gibt es Probleme mit dem Window bei Layered windows(Bild abgeschnitten)
  ProcedureReturn DShow_LoadMediaEx(sFilename, hWndParent, VideoRenderer, #True, AudioRenderer, #False, #True, #False)
EndProcedure

Procedure.i DShow_LoadMediaURL(sFilename.s, hWndParent.i = #Null, VideoRenderer.i = #RENDERER_DEFAULT, AudioRenderer.i = #RENDERER_DEFAULT)
  ProcedureReturn DShow_LoadMediaURLEx(sFilename, hWndParent, VideoRenderer, #True, AudioRenderer, #False, #True,#False)
EndProcedure

Procedure.i DShow_LoadDVDMedia(sVolume.s, hWndParent.i = #Null)
  ProcedureReturn DShow_LoadDVDMediaEx(sVolume, hWndParent)
EndProcedure

Procedure DShow_GetMediaLength(*obj.DSHOW_MEDIABASE)
  Protected qDuration.q
  If *obj
    *obj\pSeeking\GetDuration(@qDuration)
    ProcedureReturn qDuration / 10000 ; the default time format is REFERENCE_TIME units (100 nanoseconds)
  EndIf
EndProcedure


; Procedure DShow_PlayMedia(*obj.DSHOW_MEDIABASE)
;   Protected iResult.i, iState.i
;   If *obj
;     
;     iResult = *obj\pControl\Run(); = #S_OK
;     If iResult = #S_FALSE
;       iResult = *obj\pControl\GetState(500, @iState)
;       
;       If iState = #STATE_RUNNING
;         ;It seems we must set the position to 0 (.mp4 problem)
;         DShow_MediaSeek(*obj,0)
;       EndIf
;       
;       If iResult <> #S_OK    
;         If iState = #STATE_RUNNING
;           iResult = #S_OK
;         Else
;           ;Function failed, so make sure everything is stopped
;           *obj\pControl\Stop()
;         EndIf
;       EndIf          
;     EndIf
;     
;     If iResult = #S_OK
;       If DShow_GetMediaWidth(*obj) > 0 And DShow_GetMediaHeight(*obj) > 0
;         *obj\bBackgroundErased = #True
;       EndIf
;       ProcedureReturn #True
;     Else
;       ProcedureReturn #False
;     EndIf
;   EndIf
;   ProcedureReturn #False
; EndProcedure


Procedure DShow_PlayMedia(*obj.DSHOW_MEDIABASE)
  Protected iResult.i, iState.i
  If *obj
    
    iResult = *obj\pControl\Run(); = #S_OK
    If iResult = #S_FALSE     
      __MediaDebug("Warn: some filters have not completed the transition to a running state")
      
      iResult = *obj\pControl\GetState(500, @iState)
      __MediaDebug("GetState result is "+Str(iResult)+" state is "+Str(iState))      
      
      
      If iResult = #VFW_S_STATE_INTERMEDIATE
        If iState = #STATE_RUNNING      
          
          ;Both commands needed only for special file 09_storymaker.wmv    
          __MediaDebug("Setting position to " + Str(DShow_GetMediaLength(*obj)))
          DShow_MediaSeek(*obj,DShow_GetMediaLength(*obj))   ; Fhrt zu flackern bei .mp4 (wre aber nicht ntig!)
          iResult = *obj\pControl\GetState(250, @iState)    
          __MediaDebug("GetState result is "+Str(iResult)+" state is "+Str(iState))  
          
          
          ;It seems we must set the position to 0 (.mp4 problem)
          __MediaDebug("Setting position to 0")
          DShow_MediaSeek(*obj,0)
          iResult = *obj\pControl\GetState(250, @iState)            
          __MediaDebug("GetState result is "+Str(iResult)+" state is "+Str(iState))  
        EndIf
      EndIf
      
      If iResult <> #S_OK    
        If iState = #STATE_RUNNING
          __MediaDebug("continue anyway with result " +Str(iResult))
          iResult = #S_OK
        Else
          ;Function failed, so make sure everything is stopped
          __MediaDebug("Playback failed, calling stop")
          *obj\pControl\Stop()
        EndIf
      EndIf
      
    EndIf
    
    If iResult = #S_OK
      If DShow_GetMediaWidth(*obj) > 0 And DShow_GetMediaHeight(*obj) > 0
        *obj\bBackgroundErased = #True
      EndIf
      ProcedureReturn #True
    Else
      ProcedureReturn #False
    EndIf
  EndIf
  ProcedureReturn #False
EndProcedure

Procedure DShow_ResumeMedia(*obj.DSHOW_MEDIABASE)
  Protected iResult.i, iState.i
  If *obj
    
    iResult = *obj\pControl\Run(); = #S_OK
    If iResult = #S_FALSE
      iResult = *obj\pControl\GetState(500, @iState)     
      
      If iResult <> #S_OK    
        If iState = #STATE_RUNNING
          iResult = #S_OK
        Else
          ;Function failed, so make sure everything is stopped
          *obj\pControl\Stop()
        EndIf
      EndIf          
    EndIf
    
    If iResult = #S_OK
      If DShow_GetMediaWidth(*obj) > 0 And DShow_GetMediaHeight(*obj) > 0
        *obj\bBackgroundErased = #True
      EndIf
      ProcedureReturn #True
    Else
      ProcedureReturn #False
    EndIf
  EndIf
  ProcedureReturn #False
EndProcedure

Procedure DShow_PauseMedia(*obj.DSHOW_MEDIABASE)
  If *obj
    *obj\bBackgroundErased = #False
    If *obj\pControl\Pause() = #S_OK
      ProcedureReturn #True
    EndIf
  EndIf
  ProcedureReturn #False
EndProcedure

Procedure DShow_MediaStop(*obj.DSHOW_MEDIABASE)
  If *obj
    *obj\bBackgroundErased = #False
    ProcedureReturn *obj\pControl\Stop()
  EndIf
EndProcedure


Procedure DShow_MediaSeek(*obj.DSHOW_MEDIABASE, qPosition.q)
  Protected qDuration.q
  If *obj
    qPosition * 10000 ; the default time format is REFERENCE_TIME units (100 nanoseconds)
    *obj\pSeeking\GetDuration(@qDuration) 
    
    
    ;->!!! Hangs if I scroll in a few mp3 files, and the directsound output is selected!!! (ursache mp3 codec: mp3lib)
    If *obj\pSeeking\SetPositions(@qPosition, #AM_SEEKING_ABSOLUTEPOSITIONING, @qDuration, #AM_SEEKING_NOPOSITIONING)
      ProcedureReturn #True
    EndIf
    
  EndIf
  ProcedureReturn#False
EndProcedure

Procedure __Thread_DShow_MediaSeek(*obj.DSHOW_MEDIABASE)
  Protected qDuration.q
  If *obj   
    LockMutex(*obj\hThreadSeekMutex)
    *obj\qThreadSeekPosition * 10000 ; the default time format is REFERENCE_TIME units (100 nanoseconds)
    *obj\pSeeking\GetDuration(@qDuration)   
    
    ;->!!! Hangs if I scroll in a few mp3 files, and the directsound output is selected!!! (ursache mp3 codec: mp3lib)
    If *obj\pSeeking\SetPositions(@*obj\qThreadSeekPosition, #AM_SEEKING_ABSOLUTEPOSITIONING, @qDuration, #AM_SEEKING_NOPOSITIONING)
      *obj\iThreadSeekResult = #True
    Else
      *obj\iThreadSeekResult = #False
    EndIf
    UnlockMutex(*obj\hThreadSeekMutex)    
  EndIf
  *obj\iThreadSeekResult = #False
EndProcedure

Procedure DShow_MediaSeekAsync(*obj.DSHOW_MEDIABASE, qPosition.q, WaitCallBack.ThreadedSeekCallBack)
  Protected bDone = #False
  If *obj   
    *obj\hThreadSeekMutex = CreateMutex()
    If *obj\hThreadSeekMutex
      *obj\qThreadSeekPosition = qPosition
      *obj\iThreadSeekResult = -1
      CreateThread(@__Thread_DShow_MediaSeek(), *obj)
      Repeat
        If TryLockMutex(*obj\hThreadSeekMutex)
          If *obj\iThreadSeekResult <> -1
            bDone = #True
          EndIf
          UnlockMutex(*obj\hThreadSeekMutex)
        EndIf
        If WaitCallBack
          WaitCallBack()
        EndIf  
      Until bDone = #True  
      FreeMutex(*obj\hThreadSeekMutex)
    EndIf
    ProcedureReturn *obj\iThreadSeekResult
  EndIf
  ProcedureReturn #False 
EndProcedure


Procedure DShow_GetMediaPosition(*obj.DSHOW_MEDIABASE)
  Protected pos.q
  If *obj : *obj\pSeeking\GetCurrentPosition(@pos)
    ProcedureReturn pos / 10000 ; result in ms
  EndIf
EndProcedure

Procedure DShow_GetMediaState(*obj.DSHOW_MEDIABASE)
  Protected iState.i
  If *obj
    *obj\pControl\GetState(16, @iState)
    ProcedureReturn iState
  EndIf
EndProcedure

Procedure.d DShow_GetMediaFPS(*obj.DSHOW_MEDIABASE)
  Protected dAvgTimePerFrame.d
  If *obj
    *obj\pVideo\get_AvgTimePerFrame(@dAvgTimePerFrame)
    If dAvgTimePerFrame > 0.0
      ProcedureReturn 1.0 / dAvgTimePerFrame
    Else
      ProcedureReturn 0.0
    EndIf 
  EndIf
EndProcedure

Procedure __DibPaletteSize(*BmpInf.BITMAPINFOHEADER)
  If *BmpInf\biBitCount <= 8
    If *BmpInf\biClrUsed = 0
      ProcedureReturn (1 << *BmpInf\biBitCount ) * SizeOf(RGBQUAD)
    Else
      ProcedureReturn *BmpInf\biClrUsed * SizeOf(RGBQUAD)
    EndIf
  EndIf
EndProcedure

Procedure __CreateBitmapHeader(*pImage.BITMAPFILEHEADER, *BmpInf.BITMAPINFOHEADER, iSize)
  *pImage\bfType = 19778;'MB'
  *pImage\bfSize = iSize + SizeOf(BITMAPFILEHEADER) ;+ SizeOf(BITMAPINFOHEADER)
  *pImage\bfOffBits = SizeOf(BITMAPFILEHEADER) + *BmpInf\biSize + __DibPaletteSize(*BmpInf)
EndProcedure

Procedure __AllocNewBitmapHeader(*BmpInf.BITMAPINFOHEADER)
  Protected *pImage.BITMAPFILEHEADER
  If *BmpInf
    If *BmpInf\biSizeImage > 0
      *pImage = AllocateMemory(SizeOf(BITMAPFILEHEADER) + *BmpInf\biSize + *BmpInf\biSizeImage)
      If *pImage
        CopyMemory(*BmpInf, *pImage + SizeOf(BITMAPFILEHEADER), *BmpInf\biSize + *BmpInf\biSizeImage)
        __CreateBitmapHeader(*pImage, *BmpInf, *BmpInf\biSizeImage + *BmpInf\biSize)
      EndIf
    EndIf
  EndIf
  ProcedureReturn *pImage
EndProcedure

Procedure __DShowVMR7_CaptureImage(*obj.DSHOW_MEDIABASE)
  Protected iSize.i, *pImage.BITMAPFILEHEADER, *BmpInf.BITMAPINFOHEADER, iResult.i, iRes.i
  
  If *obj : iResult = #Null 
    If *obj\pVMR7Window\GetCurrentImage(@*BmpInf) = #S_OK
      If *BmpInf
        *pImage = __AllocNewBitmapHeader(*BmpInf)
        CoTaskMemFree_(*BmpInf)
        If *pImage
          iResult = CatchImage(#PB_Any, *pImage)
          If iResult = #Null
            __MediaError("Error: Cannot create image")
          EndIf
          FreeMemory(*pImage)
        Else
          __MediaError("Error: Cannot allocate memory")
        EndIf
      Else
        __MediaError("Error: cannot allocate buffer")
      EndIf
    Else
      __MediaError("Error: cannot get image")
    EndIf
  EndIf 
  ProcedureReturn iResult
EndProcedure

Procedure __DShowVMR9_CaptureImage(*obj.DSHOW_MEDIABASE)
  Protected iSize.i, *pImage.BITMAPFILEHEADER, *BmpInf.BITMAPINFOHEADER, iResult.i, iRes.i
  
  If *obj : iResult = #Null 
    If *obj\pVMR9Window\GetCurrentImage(@*BmpInf) = #S_OK
      If *BmpInf
        *pImage = __AllocNewBitmapHeader(*BmpInf)
        CoTaskMemFree_(*BmpInf)
        If *pImage
          iResult = CatchImage(#PB_Any, *pImage)
          If iResult = #Null
            __MediaError("Error: Cannot create image")
          EndIf
          FreeMemory(*pImage)
        Else
          __MediaError("Error: Cannot allocate memory")
        EndIf
      Else
        __MediaError("Error: cannot allocate buffer")
      EndIf
    Else
      __MediaError("Error: cannot get image")
    EndIf
  EndIf 
  ProcedureReturn iResult
EndProcedure

Procedure __DShow_CaptureImage(*obj.DSHOW_MEDIABASE)
  Protected iSize.i, *pImage.BITMAPFILEHEADER, iResult.i, iRes.i
  If *obj : iResult = #Null
    If *obj\pVideo\GetCurrentImage(@iSize, #Null) = #S_OK
      *pImage = AllocateMemory(iSize + SizeOf(BITMAPFILEHEADER))
      If *pImage
        If *obj\pVideo\GetCurrentImage(@iSize, *pImage + SizeOf(BITMAPFILEHEADER)) = #S_OK       
          __CreateBitmapHeader(*pImage,*pImage + SizeOf(BITMAPFILEHEADER), iSize)
          iResult = CatchImage(#PB_Any, *pImage)
          If iResult = #Null
            __MediaDebug("Error: Cannot create image")
          EndIf                                     
        Else
          __MediaDebug("Error: capture image failed")
        EndIf          
        FreeMemory(*pImage)
      Else
        __MediaDebug("Error: cannot allocate buffer")
      EndIf
    Else
      __MediaDebug("Error: cannot get necessary size for image buffer")
    EndIf
  EndIf 
  ProcedureReturn iResult
EndProcedure

Procedure __DShowOwnVMR9_CaptureImage(*obj.DSHOW_MEDIABASE)
  Protected *BackBuffer.IDirect3DSurface9 = #Null, desc.D3DSURFACE_DESC,image = #Null,DestDC = #Null,SrcDC = #Null,surf.IDirect3DSurface9 = #Null
  Protected *dev.IDirect3DDevice9  = #Null, mutex = #Null
  
  If *obj
    If *obj\bIsRenderlessVMR9
      
      If *obj\pAllocator
        *dev = *obj\pAllocator\m_D3DDev
        mutex = *obj\pAllocator\m_hMutex
        If *dev
          If mutex
            
            LockMutex(mutex)          
            *dev\GetBackBuffer(0,0,#D3DBACKBUFFER_TYPE_MONO,@*BackBuffer.IDirect3DSurface9)
            If *BackBuffer
              
              *BackBuffer\GetDesc(desc.D3DSURFACE_DESC)                 
              *dev\CreateOffscreenPlainSurface(desc\Width,desc\Height, desc\Format, #D3DPOOL_SYSTEMMEM , @surf, #Null) ; Should work because only GDI compatible formats are used...
              If surf
                
                
                If *dev\GetRenderTargetData(*BackBuffer, surf) = #S_OK
                  surf\GetDC(@SrcDC)
                  If SrcDC                  
                    image = CreateImage(#PB_Any, desc\Width, desc\Height)
                    
                    If image
                      DestDC = StartDrawing(ImageOutput(image))
                      BitBlt_(DestDC, 0, 0, desc\Width, desc\Height, SrcDC, 0, 0, #SRCCOPY)
                      StopDrawing()
                      
                      If DShow_GetMediaWidth(*obj) > 0 And DShow_GetMediaHeight(*obj) > 0
                        ResizeImage(image, DShow_GetMediaWidth(*obj), DShow_GetMediaHeight(*obj), #PB_Image_Smooth)
                      EndIf
                    EndIf
                    surf\ReleaseDC(SrcDC)
                  EndIf 
                EndIf
                surf\Release()
              EndIf                      
              *BackBuffer\Release()               
            EndIf
            UnlockMutex(mutex)   
          EndIf
        EndIf
      EndIf
    EndIf
  EndIf
  ProcedureReturn image
EndProcedure  

Procedure DShow_CaptureImage(*obj.DSHOW_MEDIABASE)
  If *obj
    
    If *obj\bIsRenderlessVMR9
      ProcedureReturn __DShowOwnVMR9_CaptureImage(*obj) ; 2011-04-06 added
    Else    
      If *obj\bWindowless   
        If *obj\pVMR7Window
          ProcedureReturn __DShowVMR7_CaptureImage(*obj)       
        ElseIf *obj\pVMR9Window
          ProcedureReturn __DShowVMR9_CaptureImage(*obj) 
        EndIf
      Else
        ProcedureReturn __DShow_CaptureImage(*obj)       
      EndIf  
    EndIf
  EndIf 
  ProcedureReturn #Null
EndProcedure

Procedure DShow_ProcessMediaEvent(*obj.DSHOW_MEDIABASE)
  Protected iEventCode.l, iParam1.l, iParam2.l, bResult = #False, iResult.i, hMonitor.i
  Protected pres.D3DPresent_Parameters
  
  If *obj
    If __IsValidMediaObject(*obj)
      
      If *obj\bIsRenderlessVMR9
        
        If *obj\pAllocator
          If *obj\pAllocator\m_D3DDev
            iResult = *obj\pAllocator\m_D3DDev\TestCooperativeLevel()
            
            If iResult = #S_OK
              ; Everything is ok...
              
            ElseIf iResult=#D3DERR_DEVICELOST ;Remove Device
              __DeleteSurfaces_SVMRSurfaceAllocator9(*obj\pAllocator)
              
            ElseIf iResult=#D3DERR_DEVICENOTRESET ;Restore Device
              ; the device must be recreated, when state is not reset...       
              
              __DeleteSurfaces_SVMRSurfaceAllocator9(*obj\pAllocator)
              __FreeD3D9_SVMRSurfaceAllocator9(*obj\pAllocator)
              If __InitD3D9_SVMRSurfaceAllocator9(*obj\pAllocator,*obj\pAllocator\m_hwnd)
                hMonitor = *obj\pAllocator\m_D3D\GetAdapterMonitor(#D3DADAPTER_DEFAULT )
                If hMonitor
                  If *obj\pAllocator\m_lpIVMRSurfAllocNotify
                    iResult = *obj\pAllocator\m_lpIVMRSurfAllocNotify\ChangeD3DDevice(*obj\pAllocator\m_D3DDev, hMonitor)             
                    If iResult = #S_OK
                      ; Ok  
                    Else
                      __MediaError("Error: ChangeD3DDevice failed with error "+Hex(iResult))
                    EndIf
                  Else
                    __MediaError("Error: m_lpIVMRSurfAllocNotify is null!")
                  EndIf
                Else
                  __MediaError("Error: hMonitor is null!")
                EndIf
              Else
                __MediaError("Error: __InitD3D9_SVMRSurfaceAllocator9 failed!")
              EndIf
              
            Else
              ; No direct3d device there....
            EndIf  
            
          Else
            __MediaError("Error: No D3D Device")                  
          EndIf
        Else
          __MediaError("Error: Allocator is null")     
        EndIf
      EndIf
      
      If *obj\pEvent
        While *obj\pEvent\GetEvent(@iEventCode, @iParam1, @iParam2, 16) <> #E_ABORT ; 16ms time out
          Select iEventCode
            Case #EC_COMPLETE
              *obj\bBackgroundErased = #False
              *obj\pControl\Stop() ; If #EC_COMPLETE notify event occurs we change the media state to stopped
              __MediaDebug("end of media reached")
          EndSelect
          
          If *obj\pDVDControl
            
            Select iEventCode
              Case #EC_DVD_NO_FP_PGC
                *obj\pDVDControl\PlayTitle(1, #DVD_CMD_FLAG_None, #Null)
            EndSelect
            
          EndIf
          
          *obj\pEvent\FreeEventParams(iEventCode, iParam1, iParam2)
        Wend
        bResult = #True
      EndIf
    Else
      __MediaDebug("Warn: Illegal or already freed media object used " + Str(*obj))
    EndIf
  EndIf 
  ProcedureReturn bResult
EndProcedure

Procedure.s DShow_FormatTimeToString(iTime.i)
  Protected iSec.i, iMin.i, iHour.i
  iSec = (iTime / 1000) % 60
  iMin = (iTime / (60 * 1000)) % 60
  iHour = (iTime / (60 * 60 *1000))
  ProcedureReturn RSet(Str(iHour), 2, "0") + ":" + RSet(Str(iMin), 2, "0") + ":" + RSet(Str(iSec), 2, "0")
EndProcedure

Procedure DShow_MediaGetVolume(*obj.DSHOW_MEDIABASE) ; from 0db to 100db
  Protected iDB.i, dDB.d 
  If *obj
    *obj\pAudio\get_Volume(@iDB)
    dDB = iDB
    dDB = dDB *1023 / 10000
    dDB - 1
    dDB = -dDB
    dDB = Log(dDB)/Log(2)
    dDB * -10  
    dDB + 100
    If dDB > 100.0:dDB = 100:EndIf
    If dDB < 0:dDB = 0:EndIf
    ProcedureReturn Int(dDB)
  EndIf
  ProcedureReturn 0 
EndProcedure

Procedure DShow_MediaSetVolume(*obj.DSHOW_MEDIABASE, iVolume.i) ; from 0db to 100db
  If *obj  
    iVolume - 100
    If iVolume > 0:iVolume = 0:EndIf
    If iVolume < -100:iVolume = -100:EndIf
    iVolume = Round((-Pow(2,(-iVolume/10))+1)/1023 * 10000,0)
    If iVolume > 0:iVolume = 0:EndIf
    If iVolume < -10000:iVolume = -10000:EndIf
    If *obj\pAudio\put_Volume(iVolume) = #S_OK
      ProcedureReturn #True
    EndIf
  EndIf 
  ProcedureReturn #False
EndProcedure

Procedure.i DShow_MediaSetBalance(*obj.DSHOW_MEDIABASE, iBalance.l) ; -100 to +100
  If *obj
    If iBalance > 100:iBalance = 100:EndIf
    If iBalance < -100:iBalance = -100:EndIf    
    If *obj\pAudio\put_balance(iBalance * 100) = #S_OK
      ProcedureReturn #True
    EndIf
  EndIf
  ProcedureReturn #False
EndProcedure

Procedure.i DShow_MediaGetBalance(*obj.DSHOW_MEDIABASE) ; from -100 to +100
  Protected iBalance.i
  If *obj
    If *obj\pAudio\get_Balance(@iBalance) = #S_OK
      ProcedureReturn iBalance / 100
    EndIf
  EndIf
  ProcedureReturn 0 
EndProcedure

Procedure.f __DShow_DVDGetAspectRatio(*obj.DSHOW_MEDIABASE)
  Protected iResult = #E_FAIL, attr.DVD_VideoAttributes
  If *obj
    If *obj\pDVDInfo
      iResult = *obj\pDVDInfo\GetCurrentVideoAttributes(attr)
    EndIf
  EndIf
  If *obj\bAspectCalculated = #False
    __MediaDebug("DVD aspect ration is "+Str(attr\ulAspectX) + ":" + Str(attr\ulAspectY))  
  EndIf
  If iResult = #S_OK
    ProcedureReturn attr\ulAspectX / attr\ulAspectY
  Else
    If *obj\bAspectCalculated = #False
      __MediaDebug("WARN: to determine DVD apect ration CORRECTLY the PlayMedia command should be called first!")
    EndIf
    ProcedureReturn 0.0
  EndIf
EndProcedure   

Procedure.f __DShow_MediaGetAspectRatio_Old(*obj.DSHOW_MEDIABASE,x.i,y.i,org_width,org_height)
  Protected aspect.f, aspect_org.f
  If *obj
    
    If *obj\pDVDGraphBuilder ; If DVD    
      *obj\fAspect = __DShow_DVDGetAspectRatio(*obj)
      If *obj\fAspect = 0.0
        If *obj\bAspectCalculated = #False
          __MediaDebug("correct DVD aspect ration to 16:9")  
        EndIf  
        *obj\fAspect = 16.0/9.0   
      EndIf
      
    Else   
      __MediaDebug("aspect ration is "+Str(x) +":" +Str(y))    
      If x = 0 Or y = 0 Or org_width = 0 Or org_height = 0
        If *obj\bAspectCalculated = #False
          __MediaDebug("correct aspect ration to 4:3") 
        EndIf   
        *obj\fAspect = 4.0/3.0     
      EndIf
      
      aspect = x/y
      aspect_org = org_width / org_height
      
      If (aspect = aspect_org) And (x > 100 Or y > 100)
        If *obj\bAspectCalculated = #False
          __MediaDebug("correct aspect ration to 4:3")
        EndIf    
        *obj\fAspect = 4.0/3.0     
      Else
        *obj\fAspect = aspect
      EndIf    
    EndIf   
    
    *obj\bAspectCalculated = #True
  EndIf 
EndProcedure 

Procedure.f __DShow_MediaGetAspectRatio_Old_TryNo2(*obj.DSHOW_MEDIABASE,x.i,y.i,org_width,org_height)
  Protected aspect.f, aspect_org.f, bDone = #False, k , xf.f, yf.f, w.f, h.f
  If *obj
    
    If *obj\pDVDGraphBuilder ; If DVD    
      *obj\fAspect = __DShow_DVDGetAspectRatio(*obj)
      If *obj\fAspect = 0.0
        If *obj\bAspectCalculated = #False
          __MediaDebug("correct DVD aspect ration to 16:9")  
        EndIf  
        *obj\fAspect = 16.0/9.0   
      EndIf
      
    Else   
      __MediaDebug("aspect ration is "+Str(x) +":" +Str(y))    
      
      xf.f = x
      yf.f = y 
      w = org_width
      h = org_height
      
      For k=1 To 10
        If x = 16*k And y = 9*k
          *obj\fAspect = 16.0/9.0          
          bDone = #True
          Break
        EndIf
        
        If x = 4*k And y = 3*k
          *obj\fAspect = 4.0/3.0          
          bDone = #True
          Break
        EndIf      
        
        If x = 1*k And y = 1*k
          *obj\fAspect = 1.0/1.0          
          bDone = #True
          Break
        EndIf
        
        If x = 21*k And y = 9*k
          *obj\fAspect = 21.0/9.0          
          bDone = #True
          Break
        EndIf
      Next
      
      If bDone = #False
        aspect = xf/yf
        aspect_org = w / h 
        
        *obj\fAspect = aspect
        If x > 1000 And y > 1000
          If org_height > 0 And org_width > 0
            *obj\fAspect = aspect_org  
            If aspect_org < 1.0
              If *obj\bAspectCalculated = #False
                __MediaDebug("correct aspect ration to 4:3") 
              EndIf
              *obj\fAspect = 4.0/3.0          
            EndIf            
          Else
            If *obj\bAspectCalculated = #False
              __MediaDebug("correct aspect ration to 4:3") 
            EndIf
            *obj\fAspect = 4.0/3.0  
          EndIf
        EndIf
      EndIf
      
    EndIf   
    
    *obj\bAspectCalculated = #True
  EndIf 
EndProcedure 


Procedure.f __DShow_MediaGetAspectRatio(*obj.DSHOW_MEDIABASE,x.i,y.i,org_width,org_height)
  Protected aspect.f, aspect_org.f, bCorrected = #False, k , xf.f, yf.f, w.f, h.f
  If *obj
    
    If *obj\pDVDGraphBuilder ; If DVD    
      *obj\fAspect = __DShow_DVDGetAspectRatio(*obj)
      If *obj\fAspect = 0.0
        ;If *obj\bAspectCalculated = #False
        __MediaDebug("correct DVD aspect ration to 16:9")  
        ;EndIf  
        *obj\fAspect = 16.0/9.0   
      EndIf
      
    Else   
      __MediaDebug("original aspect ration is "+Str(x) +":" +Str(y))    
      __MediaDebug("original size is " +Str(org_width) + ":" + Str(org_height))      
      
      
      If org_width <=0 Or org_height <=0
        org_width = 4
        org_height = 3
        bCorrected = #True
      EndIf  
      
      If x<= 0 Or y <=0
        x = org_width
        y = org_height 
        bCorrected = #True
      EndIf  
      
      If y > x
        x = org_width
        y = org_height
        bCorrected = #True
      EndIf
      
      If y > x
        x = 4
        y = 3
        bCorrected = #True
      EndIf
      
      If x > 10 * y ; mehr als 1:10 kann wirklich nicht sein
        x = 4
        y = 3
        bCorrected = #True       
      EndIf   
      
      If bCorrected
        __MediaDebug("Warn: corrected aspect ration to "+Str(x) +":" +Str(y))   
      EndIf
      
      xf.f = x
      yf.f = y
      
      *obj\fAspect = xf / yf
    EndIf
  EndIf 
EndProcedure 

Procedure.f DShow_MediaGetAspectRatio(*obj.DSHOW_MEDIABASE)
  Protected x.i,y.i,org_width,org_height
  If *obj
    ;If *obj\bAspectCalculated = #False  ; Not used at the moment
    
    If *obj\bIsRenderlessVMR9
      x = *obj\m_AllocatorAspectX
      y = *obj\m_AllocatorAspectY
      org_width = *obj\m_AllocatorImageWidth
      org_height = *obj\m_AllocatorImageHeight
      
      ;There is a small chaance that the render is not what it seems. Then it seems that a default renderer is created
      If *obj\bRenderlessVMR9PresentCalled = #False And x = 0 And y = 0
        *obj\pVideo\GetPreferredAspectRatio(@x,@y) 
      EndIf  
      
    Else
      If *obj\bWindowless    
        If *obj\pVMR7Window
          *obj\pVMR7Window\GetNativeVideoSize(@org_width, @org_height, @x, @y)       
        ElseIf *obj\pVMR9Window
          *obj\pVMR9Window\GetNativeVideoSize(@org_width, @org_height, @x, @y)
        EndIf
      Else
        *obj\pVideo\GetVideoSize(@org_width, @org_height)
        *obj\pVideo\GetPreferredAspectRatio(@x,@y)        
      EndIf
      
    EndIf  
    __DShow_MediaGetAspectRatio(*obj, x ,y ,org_width ,org_height)
    
    ;EndIf
    ProcedureReturn *obj\fAspect
  Else
    ProcedureReturn 0.0
  EndIf 
EndProcedure

Procedure __DShow_SetDestination(*obj.DSHOW_MEDIABASE, *x.Long, *y.Long, *width.Long, *height.Long)
  Protected iResult.i = #E_FAIL
  If *obj
    If *x
      *obj\dst\left = *x\l
      *obj\dst\right = *obj\dst\left + *obj\iDestWidth
    EndIf
    If *y
      *obj\dst\top = *y\l
      *obj\dst\bottom = *obj\dst\top + *obj\iDestHeight
    EndIf
    If *width
      *obj\iDestWidth = *width\l
      *obj\dst\right = *obj\dst\left + *width\l
    EndIf
    If *height
      *obj\iDestHeight = *height\l
      *obj\dst\bottom = *obj\dst\top + *height\l
    EndIf
    
    If *obj\bWindowless    
      If *obj\pVMR7Window
        iResult = *obj\pVMR7Window\SetVideoPosition(#Null, *obj\dst)
      ElseIf *obj\pVMR9Window
        iResult = *obj\pVMR9Window\SetVideoPosition(#Null, *obj\dst)
      EndIf
    Else
      If *x
        iResult = *obj\pVideo\put_DestinationLeft(*x\l)
      EndIf
      If *y
        iResult = *obj\pVideo\put_DestinationTop(*y\l)
      EndIf
      If *width
        iResult = *obj\pVideo\put_DestinationWidth(*width\l)
      EndIf
      If *height
        iResult = *obj\pVideo\put_DestinationHeight(*height\l)  
      EndIf
    EndIf
  EndIf
  
  If iResult = #S_OK
    ProcedureReturn #True
  Else
    ProcedureReturn #False
  EndIf
EndProcedure

Procedure __DShow_SetSource(*obj.DSHOW_MEDIABASE, *x.Long, *y.Long, *width.Long, *height.Long)
  Protected iResult.i = #E_FAIL, hDC.i
  If *obj
    If *x
      *obj\src\left = *x\l
      *obj\src\right = *obj\src\left + *obj\iSourceWidth
    EndIf
    If *y
      *obj\src\top = *y\l
      *obj\src\bottom = *obj\src\top + *obj\iSourceHeight
    EndIf
    If *width
      *obj\iSourceWidth = *width\l
      *obj\src\right = *obj\src\left + *width\l
    EndIf
    If *height
      *obj\iSourceHeight = *height\l
      *obj\src\bottom = *obj\src\top + *height\l
    EndIf
    
    
    If *obj\bWindowless    
      If *obj\pVMR7Window
        iResult = *obj\pVMR7Window\SetVideoPosition(*obj\src, #Null)
        hDC = GetDC_(*obj\hWnd)
        *obj\pVMR7Window\RepaintVideo(*obj\hWnd, hDC)
        ReleaseDC_(*obj\hWnd, hDC)
        ;*obj\pVMR7Window\SetVideoClippingWindow(*obj\hWnd)
      ElseIf *obj\pVMR9Window
        iResult = *obj\pVMR9Window\SetVideoPosition(*obj\src, #Null)
        hDC = GetDC_(*obj\hWnd)
        *obj\pVMR7Window\RepaintVideo(*obj\hWnd, hDC)
        ReleaseDC_(*obj\hWnd, hDC)
        ;*obj\pVMR9Window\SetVideoClippingWindow(*obj\hWnd)
      EndIf
    Else
      If *x
        iResult = *obj\pVideo\put_SourceLeft(*x\l)
      EndIf
      If *y
        iResult = *obj\pVideo\put_SourceTop(*y\l)
      EndIf
      If *width
        iResult = *obj\pVideo\put_SourceWidth(*width\l)
      EndIf
      If *height
        iResult = *obj\pVideo\put_SourceHeight(*height\l)  
      EndIf
    EndIf
  EndIf
  If iResult = #S_OK
    ProcedureReturn #True
  Else
    ProcedureReturn #False
  EndIf
EndProcedure

Procedure DShow_MediaSetDestX(*obj.DSHOW_MEDIABASE, x.l)
  ProcedureReturn __DShow_SetDestination(*obj,@x,#Null,#Null,#Null)
EndProcedure

Procedure DShow_MediaSetDestY(*obj.DSHOW_MEDIABASE, y.l)
  ProcedureReturn  __DShow_SetDestination(*obj,#Null,@y,#Null,#Null)
EndProcedure

Procedure DShow_MediaSetDestWidth(*obj.DSHOW_MEDIABASE, width.l)
  ProcedureReturn __DShow_SetDestination(*obj,#Null,#Null,@width,#Null)
EndProcedure

Procedure DShow_MediaSetDestHeight(*obj.DSHOW_MEDIABASE, height.l)
  ProcedureReturn __DShow_SetDestination(*obj,#Null,#Null,#Null,@height)
EndProcedure

Procedure DShow_MediaSetSrcX(*obj.DSHOW_MEDIABASE, x.l)
  ProcedureReturn __DShow_SetSource(*obj,@x,#Null,#Null,#Null)
EndProcedure

Procedure DShow_MediaSetSrcY(*obj.DSHOW_MEDIABASE, y.l)
  ProcedureReturn  __DShow_SetSource(*obj,#Null,@y,#Null,#Null)
EndProcedure

Procedure DShow_MediaSetSrcWidth(*obj.DSHOW_MEDIABASE, width.l)
  ProcedureReturn __DShow_SetSource(*obj,#Null,#Null,@width,#Null)
EndProcedure

Procedure DShow_MediaSetSrcHeight(*obj.DSHOW_MEDIABASE, height.l)
  ProcedureReturn __DShow_SetSource(*obj,#Null,#Null,#Null,@height)
EndProcedure

Procedure DShow_MediaSetWindowX(*obj.DSHOW_MEDIABASE, x.i)
  If *obj
    If *obj\pWindow\put_Left(x) = #S_OK
      ProcedureReturn #True
    EndIf   
  EndIf 
  ProcedureReturn #False
EndProcedure

Procedure DShow_MediaSetWindowY(*obj.DSHOW_MEDIABASE, y.i)
  If *obj
    If *obj\pWindow\put_Top(y) = #S_OK
      ProcedureReturn #True
    EndIf
  EndIf 
  ProcedureReturn #False
EndProcedure

Procedure DShow_MediaSetWindowWidth(*obj.DSHOW_MEDIABASE, iWidth.i)
  If *obj
    If *obj\pWindow\put_Width(iWidth)
      ProcedureReturn #True 
    EndIf
  EndIf 
  ProcedureReturn #False
EndProcedure

Procedure DShow_MediaSetWindowHeight(*obj.DSHOW_MEDIABASE, iHeight.i)
  If *obj
    If *obj\pWindow\put_Height(iHeight)
      ProcedureReturn #True
    EndIf
  EndIf 
  ProcedureReturn #False
EndProcedure

Procedure.i DShow_MediaSetSpeed(*obj.DSHOW_MEDIABASE, dRate.d) ; Default is 1.0, does not always work
  If *obj
    If *obj\pSeeking\SetRate(dRate) = #S_OK
      ProcedureReturn #True
    EndIf
  EndIf
  ProcedureReturn #False   
EndProcedure

Procedure.d DShow_MediaGetSpeed(*obj.DSHOW_MEDIABASE) ; Default is 1.0, does not always work
  Protected dRate.d
  If *obj
    If *obj\pSeeking\GetRate(@dRate) = #S_OK
      ProcedureReturn dRate
    EndIf
  EndIf
  ProcedureReturn 0.0
EndProcedure

Procedure.i DShow_MediaHideCursor(*obj.DSHOW_MEDIABASE, bHide.i)
  If *obj
    If *obj\pWindow\HideCursor(bHide) = #S_OK
      ProcedureReturn  #True
    EndIf
  EndIf 
  ProcedureReturn  #False   
EndProcedure

Procedure.i DShow_MediaSetFullscreenMode(*obj.DSHOW_MEDIABASE, bFullscreen.i)
  If *obj
    If *obj\pWindow\put_FullScreenMode(bFullscreen) = #S_OK
      ProcedureReturn  #True
    EndIf
  EndIf
  ProcedureReturn  #False    
EndProcedure

Procedure.i DShow_MediaIsCursorHidden(*obj.DSHOW_MEDIABASE)
  Protected bHide.i
  If *obj
    If *obj\pWindow\IsCursorHidden(@bHide) = #S_OK 
      ProcedureReturn bHide
    EndIf
  EndIf 
  ProcedureReturn  #False   
EndProcedure

Procedure.i DShow_UpdateSampleGrabber(*obj.DSHOW_MEDIABASE)
  If *obj
    If __ReadSample(*obj) = #S_OK
      ProcedureReturn *obj\AudioSampleBuffer
    EndIf
  EndIf
  ProcedureReturn #Null
EndProcedure


Procedure.i DShow_GetSampleGrabberSize(*obj.DSHOW_MEDIABASE)
  If *obj
    ProcedureReturn *obj\iAudioSampleLastLength;iAudioSampleLength
  Else
    ProcedureReturn 0
  EndIf
EndProcedure

Procedure.i DShow_GetSampleGrabberChannels(*obj.DSHOW_MEDIABASE)
  If *obj
    ProcedureReturn *obj\iAudioSampleChannels
  Else
    ProcedureReturn 0
  EndIf
EndProcedure

Procedure.i DShow_GetSampleGrabberBitsPerSample(*obj.DSHOW_MEDIABASE)
  If *obj
    ProcedureReturn *obj\iAudioSampleBitsPerSample
  Else
    ProcedureReturn 0
  EndIf
EndProcedure


Procedure.i DShow_GetSampleGrabberBitsSamplesPerSec(*obj.DSHOW_MEDIABASE)
  If *obj
    ProcedureReturn *obj\iAudioSampleSamplesPerSec 
  Else
    ProcedureReturn 0
  EndIf
EndProcedure

Procedure.d DShow_ReadSample(*obj.DSHOW_MEDIABASE, iPosition.i)
  Protected qBytePos.q, iBytesPerSample.i, dSample.d
  If *obj
    If *obj\pSample
      If *obj\AudioSampleBuffer
        If *obj\iAudioSampleBitsPerSample >= 8
          iBytesPerSample = *obj\iAudioSampleBitsPerSample / 8
          qBytePos = iPosition 
          qBytePos = (qBytePos * *obj\iAudioSampleSamplesPerSec) / 44100
          qBytePos = qBytePos * iBytesPerSample * *obj\iAudioSampleChannels  
          
          If (qBytePos < *obj\iAudioSampleLength - iBytesPerSample) And (qBytePos >=0)
            Select iBytesPerSample
              Case 1
                dSample = PeekB(*obj\AudioSampleBuffer + qBytePos)
                dSample / ($FF / 2)
              Case 2
                dSample = PeekW(*obj\AudioSampleBuffer + qBytePos)
                dSample / ($FFFF / 2)
            EndSelect
            ProcedureReturn dSample
          EndIf 
        EndIf
      EndIf
    EndIf
  EndIf
  ProcedureReturn 0.0
EndProcedure

Procedure.q DShow_GetSampleCount(*obj.DSHOW_MEDIABASE)
  Protected iBytesPerSample.i, qCount.q
  If *obj
    If *obj\pSample
      If *obj\AudioSampleBuffer   
        If *obj\iAudioSampleBitsPerSample >= 8 And *obj\iAudioSampleChannels > 0 And *obj\iAudioSampleSamplesPerSec > 0 And *obj\iAudioSampleLastLength > 0
          iBytesPerSample = *obj\iAudioSampleBitsPerSample / 8  
          qCount = *obj\iAudioSampleLastLength ;iAudioSampleLength
          qCount / iBytesPerSample
          qCount / *obj\iAudioSampleChannels
          qCount * 44100
          qCount / *obj\iAudioSampleSamplesPerSec
          ProcedureReturn qCount
        EndIf
      EndIf
    EndIf
  EndIf
  ProcedureReturn 0
EndProcedure

Procedure.i DShow_DVDEnableAutoControl(*obj.DSHOW_MEDIABASE, bEnable.i)
  If *obj
    *obj\bAutoDVDControl = bEnable
    ProcedureReturn #True
  EndIf
  ProcedureReturn #False
EndProcedure

Procedure.i DShow_DVDKeyControl(*obj.DSHOW_MEDIABASE, iContorl.i)
  Protected iResult = #E_FAIL
  If *obj
    If *obj\pDVDControl   
      Select iContorl
        Case #DVDCONTROL_ACTIVATE
          iResult = *obj\pDVDControl\ActivateButton()
        Case #DVDCONTROL_LEFT
          iResult = *obj\pDVDControl\SelectRelativeButton(#DVD_Relative_Left)
        Case #DVDCONTROL_RIGHT
          iResult = *obj\pDVDControl\SelectRelativeButton(#DVD_Relative_Right)
        Case #DVDCONTROL_UP
          iResult = *obj\pDVDControl\SelectRelativeButton(#DVD_Relative_Upper)    
        Case #DVDCONTROL_DOWN
          iResult = *obj\pDVDControl\SelectRelativeButton(#DVD_Relative_Lower)
      EndSelect      
    EndIf
  EndIf
  If iResult = #S_OK
    ProcedureReturn #True
  Else
    ProcedureReturn #False
  EndIf
EndProcedure

Procedure.i DShow_DVDMouseControl(*obj.DSHOW_MEDIABASE, x.i, y.i, bActive.i)
  Protected iResult = #E_FAIL, pt.POINT
  If *obj
    If *obj\pDVDControl   
      pt.POINT
      pt\x = x
      pt\y = y
      ;Dirty code...
      If bActive
        iResult = *obj\pDVDControl\ActivateAtPosition(PeekQ(@pt))    
      Else   
        iResult = *obj\pDVDControl\SelectAtPosition(PeekQ(@pt))
      EndIf
    EndIf
  EndIf
  If iResult = #S_OK
    ProcedureReturn #True
  Else
    ProcedureReturn #False
  EndIf
EndProcedure  

Procedure.i DShow_DVDSelectAudio(*obj.DSHOW_MEDIABASE, iChannel.i)
  Protected iResult = #E_FAIL
  If *obj
    If *obj\pDVDControl   
      iResult = *obj\pDVDControl\SelectAudioStream(iChannel,0,#Null)      
    EndIf
  EndIf
  If iResult = #S_OK
    ProcedureReturn #True
  Else
    ProcedureReturn #False
  EndIf
EndProcedure 

Procedure.s DShow_DVDGetUniqueID(*obj.DSHOW_MEDIABASE) ;  "unique" ID based on file sizes, dates, and other information
  Protected iResult = #E_FAIL, qID.q
  If *obj
    If *obj\pDVDInfo   
      iResult = *obj\pDVDInfo\GetDiscID(#Null, @qID)    
    EndIf
  EndIf
  If iResult = #S_OK
    ProcedureReturn LSet(Hex(qID), 16 ,"0")
  Else
    ProcedureReturn ""
  EndIf
EndProcedure 

Procedure.i DShow_DVDGetAudioLanguage(*obj.DSHOW_MEDIABASE, iChannel.i)
  Protected iResult = #E_FAIL, iLanguage.i
  If *obj
    If *obj\pDVDInfo   
      iResult = *obj\pDVDInfo\GetAudioLanguage(iChannel, @iLanguage)    
    EndIf
  EndIf
  If iResult = #S_OK
    ProcedureReturn iLanguage
  Else
    ProcedureReturn 0
  EndIf
EndProcedure 

Procedure.s DShow_DVDGetAudioLanguageAsString(*obj.DSHOW_MEDIABASE, iChannel.i) ;Channel 0-7
  Protected iLanguage.i, sLanguage.s
  iLanguage = DShow_DVDGetAudioLanguage(*obj, iChannel)
  If iLanguage
    sLanguage.s = Space(1024)
    GetLocaleInfo_(iLanguage, #LOCALE_SENGLANGUAGE, @sLanguage, 1023)
    ProcedureReturn Trim(sLanguage)
  Else
    ProcedureReturn ""
  EndIf
EndProcedure 

Procedure.i DShow_DVDIsAudioChannelEnabled(*obj.DSHOW_MEDIABASE, iChannel.i) ;Channel 0-7
  Protected iResult = #E_FAIL, bEnabled.i
  If *obj
    If *obj\pDVDInfo   
      iResult = *obj\pDVDInfo\IsAudioStreamEnabled(iChannel, @bEnabled)    
    EndIf
  EndIf
  If iResult = #S_OK
    ProcedureReturn bEnabled
  Else
    ProcedureReturn #False
  EndIf
EndProcedure 
Procedure.i DShow_DVDShowMenu(*obj.DSHOW_MEDIABASE, iMenu.i)
  Protected iResult = #E_FAIL
  If *obj
    If *obj\pDVDControl   
      iResult = *obj\pDVDControl\ShowMenu(iMenu,0,#Null)      
    EndIf
  EndIf
  If iResult = #S_OK
    ProcedureReturn #True
  Else
    ProcedureReturn #False
  EndIf
EndProcedure     

Procedure.s __DVDGetTextInfo(*obj.DSHOW_MEDIABASE, iLangID, iSearchType.i)
  Protected iResult = #E_FAIL,sResult.s = "", iNumLang, ulNumStrings.i, LangCode.i, CharSet.i, i.i, k.i, iActualSize.i, sTemp.s, iType.i
  sTemp.s = Space(2048)
  If *obj
    If *obj\pDVDInfo      
      *obj\pDVDInfo\GetDVDTextNumberOfLanguages(@iNumLang)
      For i = 0 To iNumLang - 1
        *obj\pDVDInfo\GetDVDTextLanguageInfo(i, @ulNumStrings, @LangCode, @CharSet) 
        If LangCode = iLangID Or i = 0
          For k=0 To ulNumStrings - 1
            *obj\pDVDInfo\GetDVDTextStringAsUnicode(i, k, @sTemp.s, 1023, @iActualSize, @iType)
            If iSearchType = iType
              sResult = Trim(PeekS(@sTemp, 1023, #PB_Unicode))
            EndIf
          Next
        EndIf
      Next     
    EndIf
  EndIf
  ProcedureReturn sResult
EndProcedure


Procedure.s DShow_GetDVDDrive(*obj.DSHOW_MEDIABASE)
  Protected Temp.s = Space(#MAX_PATH*2), sz.i, sResult.s = ""
  If *obj
    If *obj\pDVDInfo
      If *obj\pDVDInfo\GetDVDDirectory(@Temp,#MAX_PATH - 1,@sz) = #S_OK
        sResult = Left(PeekS(@Temp,sz,#PB_Unicode), 1) + ":\"
      EndIf
    EndIf
  EndIf
  ProcedureReturn sResult
EndProcedure

Procedure.s DShow_DVDGetTitle(*obj.DSHOW_MEDIABASE)
  Protected sResult.s, sTemp.s, sTempFS.s, sVol.s, iActualSize.i
  sResult = __DVDGetTextInfo(*obj, GetUserDefaultLangID_(), #DVD_Struct_Title)
  If sResult = "":sResult = __DVDGetTextInfo(*obj, GetUserDefaultLangID_(), #DVD_Title_Movie):EndIf
  If sResult = "" And *obj
    sTemp.s   = Space(#MAX_PATH+1)
    sTempFS.s = Space(#MAX_PATH+1)
    sVol.s = DShow_GetDVDDrive(*obj)
    GetVolumeInformation_(sVol, @sTemp.s,#MAX_PATH,#Null,#Null,#Null,@sTempFS,#MAX_PATH)
    sResult = Trim(ReplaceString(sTemp,"_", " "))
  EndIf
  ProcedureReturn sResult
EndProcedure

Procedure.i DShow_DVDGetLength(*obj.DSHOW_MEDIABASE)
  Protected iResult = #E_FAIL, time.DVD_HMSF_TIMECODE
  If *obj
    If *obj\pDVDInfo      
      iResult = *obj\pDVDInfo\GetTotalTitleTime(@time, #Null)      
    EndIf
  EndIf
  If iResult = #S_OK
    ProcedureReturn time\bHours* 60*60 + time\bMinutes*60 + time\bSeconds
  Else
    ProcedureReturn 0
  EndIf
EndProcedure

Procedure.i DShow_DVDNextChapter(*obj.DSHOW_MEDIABASE)
  Protected iResult = #E_FAIL
  If *obj
    If *obj\pDVDControl   
      iResult = *obj\pDVDControl\PlayNextChapter(0, #Null)
    EndIf
  EndIf
  If iResult = #S_OK
    ProcedureReturn #True
  Else
    ProcedureReturn #False
  EndIf
EndProcedure     

Procedure.i DShow_DVDPrevChapter(*obj.DSHOW_MEDIABASE)
  Protected iResult = #E_FAIL
  If *obj
    If *obj\pDVDControl   
      iResult = *obj\pDVDControl\PlayPrevChapter(0, #Null)
    EndIf
  EndIf
  If iResult = #S_OK
    ProcedureReturn #True
  Else
    ProcedureReturn #False
  EndIf
EndProcedure  

Procedure.i DShow_DVDPlayChapter(*obj.DSHOW_MEDIABASE, iChapter.i)
  Protected iResult = #E_FAIL
  If *obj
    If *obj\pDVDControl   
      iResult = *obj\pDVDControl\PlayChapter(iChapter, 0, #Null)
    EndIf
  EndIf
  If iResult = #S_OK
    ProcedureReturn #True
  Else
    ProcedureReturn #False
  EndIf
EndProcedure  

Procedure.i DShow_DVDPlayAtTime(*obj.DSHOW_MEDIABASE, iTime.i)
  Protected iResult = #E_FAIL,TimeCode.DVD_HMSF_TIMECODE
  If *obj
    If *obj\pDVDControl   
      TimeCode\bHours = iTime / (60 * 60)
      TimeCode\bMinutes = (iTime / 60) % 60
      TimeCode\bSeconds = (iTime) % 60
      iResult = *obj\pDVDControl\PlayAtTime(@TimeCode, 0, #Null)
    EndIf
  EndIf
  If iResult = #S_OK
    ProcedureReturn #True
  Else
    ProcedureReturn #False
  EndIf
EndProcedure  

Procedure.i DShow_DVDGetPosition(*obj.DSHOW_MEDIABASE)
  Protected iResult = #E_FAIL, loc.DVD_PLAYBACK_LOCATION2
  If *obj
    If *obj\pDVDInfo      
      iResult = *obj\pDVDInfo\GetCurrentLocation(@loc)      
    EndIf
  EndIf
  If iResult = #S_OK
    ProcedureReturn loc\TimeCode\bHours* 60*60 + loc\TimeCode\bMinutes*60 + loc\TimeCode\bSeconds
  Else
    ProcedureReturn -1
  EndIf
EndProcedure

Procedure.i DShow_DVDGetCurrentChapter(*obj.DSHOW_MEDIABASE)
  Protected iResult = #E_FAIL, loc.DVD_PLAYBACK_LOCATION2
  If *obj
    If *obj\pDVDInfo      
      iResult = *obj\pDVDInfo\GetCurrentLocation(@loc)      
    EndIf
  EndIf
  If iResult = #S_OK
    ProcedureReturn loc\ChapterNum
  Else
    ProcedureReturn -1
  EndIf
EndProcedure

Procedure.i DShow_DVDGetCurrentTitle(*obj.DSHOW_MEDIABASE)
  Protected iResult = #E_FAIL, loc.DVD_PLAYBACK_LOCATION2
  If *obj
    If *obj\pDVDInfo      
      iResult = *obj\pDVDInfo\GetCurrentLocation(@loc)      
    EndIf
  EndIf
  If iResult = #S_OK
    ProcedureReturn loc\TitleNum
  Else
    ProcedureReturn -1
  EndIf
EndProcedure

Procedure.i DShow_DVDGetChapterCount(*obj.DSHOW_MEDIABASE, iTitle.i)
  Protected iResult = #E_FAIL, lNum.l
  If *obj
    If *obj\pDVDInfo      
      iResult = *obj\pDVDInfo\GetNumberOfChapters(iTitle, @lNum)    
    EndIf
  EndIf
  If iResult = #S_OK
    ProcedureReturn lNum
  Else
    ProcedureReturn -1
  EndIf
EndProcedure

Procedure.i DShow_DVDPlayForwards(*obj.DSHOW_MEDIABASE, dSpeed.d)
  Protected iResult = #E_FAIL
  If *obj
    If *obj\pDVDControl   
      iResult = *obj\pDVDControl\PlayForwards(dSpeed, 0, #Null)
    EndIf
  EndIf
  If iResult = #S_OK
    ProcedureReturn #True
  Else
    ProcedureReturn #False
  EndIf
EndProcedure        

Procedure.i DShow_DVDPlayBackwards(*obj.DSHOW_MEDIABASE, dSpeed.d)
  Protected iResult = #E_FAIL
  If *obj
    If *obj\pDVDControl   
      iResult = *obj\pDVDControl\PlayBackwards(dSpeed, 0, #Null)
    EndIf
  EndIf
  If iResult = #S_OK
    ProcedureReturn #True
  Else
    ProcedureReturn #False
  EndIf
EndProcedure        


;Not supported by DSOW_DEFAULT!!!
Procedure DShow_SetVMRImage(*obj.DSHOW_MEDIABASE, Image, fDestX.f = 0.0, fDestY.f = 0.0, fDestWidth.f = 1.0, fDestHeight = 1.0, iSrcX = 0, iSrcY = 0, iSrcWidth = -1, iSrcHeight = -1 ,IsColorKeyed = #False, ColorKey = 0, fAlpha.f = 1.0)
  Protected bResult.i = #False,bmp.BITMAP, vmr9ab.VMR9AlphaBitmap, vmr7ab.VMRALPHABITMAP, MemDC, oldObj
  
  If *obj
    If IsImage(Image)
      bmp.BITMAP
      GetObject_(ImageID(Image), SizeOf(BITMAP), bmp.BITMAP)
      
      If iSrcWidth < 0
        iSrcWidth = bmp\bmWidth
      EndIf
      
      If iSrcHeight < 0
        iSrcHeight = bmp\bmHeight
      EndIf  
      
      If iSrcX < 0 :iSrcX = 0:EndIf
      If iSrcY < 0 :iSrcY = 0:EndIf
      
      If iSrcWidth > bmp\bmWidth : iSrcWidth = bmp\bmWidth:EndIf
      If iSrcHeight > bmp\bmHeight : iSrcHeight = bmp\bmHeight:EndIf 
      
      
      If iSrcX + iSrcWidth > bmp\bmWidth :iSrcWidth = bmp\bmWidth - iSrcX: EndIf
      If iSrcY + iSrcHeight > bmp\bmHeight :iSrcHeight = bmp\bmHeight - iSrcY: EndIf  
      
      If *obj\bIsRenderlessVMR9
        
        If *obj\pImagePresenter
          If *obj\pImagePresenter\m_hMutex
            LockMutex(*obj\pImagePresenter\m_hMutex)
          EndIf  
        EndIf
        
        *obj\OverlayColorKey = ColorKey  
        *obj\OverlayUseColorKey = IsColorKeyed
        *obj\OverlayAlpha = fAlpha
        *obj\OverlaySrcRect\left = iSrcX
        *obj\OverlaySrcRect\left / ImageWidth(Image)
        
        *obj\OverlaySrcRect\right = iSrcX + iSrcWidth
        *obj\OverlaySrcRect\right / ImageWidth(Image)
        
        *obj\OverlaySrcRect\top = iSrcY
        *obj\OverlaySrcRect\top / ImageHeight(Image)
        
        *obj\OverlaySrcRect\bottom = iSrcY + iSrcHeight
        *obj\OverlaySrcRect\bottom / ImageHeight(Image)
        
        *obj\OverlayDstRect\left = fDestX
        *obj\OverlayDstRect\right = fDestX + fDestWidth
        *obj\OverlayDstRect\top = fDestY
        *obj\OverlayDstRect\bottom = fDestY + fDestHeight
        
        If *obj\OverlayImage
          FreeImage(*obj\OverlayImage)    
        EndIf
        *obj\OverlayImage =  #Null
        If *obj\OverlayTexture
          *obj\OverlayTexture\Release()
        EndIf  
        *obj\OverlayTexture = #Null        
        *obj\OverlayImage = ___CopyWith32Bits(image);___CopyAndResizeImageWith32Bits(Image, 1024,1024)
        *obj\OverlayCreated = #False
        bResult = #True
        
        If *obj\pImagePresenter
          If *obj\pImagePresenter\m_hMutex
            UnlockMutex(*obj\pImagePresenter\m_hMutex)
          EndIf  
        EndIf     
      Else
        
        vmr9ab.VMR9AlphaBitmap
        vmr9ab\dwFlags=#VMR9AlphaBitmap_hDC
        If IsColorKeyed
          vmr9ab\dwFlags | #VMR9AlphaBitmap_SrcColorKey
          vmr9ab\clrSrcKey = ColorKey
        EndIf
        
        vmr9ab\fAlpha = fAlpha
        vmr9ab\rDest\left = fDestX
        vmr9ab\rDest\top = fDestY
        vmr9ab\rDest\right = fDestX + fDestWidth
        vmr9ab\rDest\bottom = fDestY + fDestHeight
        
        vmr9ab\rSrc\left = iSrcX
        vmr9ab\rSrc\top = iSrcY
        vmr9ab\rSrc\right = iSrcWidth + iSrcX
        vmr9ab\rSrc\bottom = iSrcHeight + iSrcY 
        
        
        vmr7ab.VMRALPHABITMAP
        vmr7ab\dwFlags=#VMRBITMAP_HDC
        If IsColorKeyed
          vmr7ab\dwFlags | #VMRBITMAP_SRCCOLORKEY
          vmr7ab\clrSrcKey = ColorKey     
        EndIf
        
        vmr7ab\fAlpha = fAlpha   
        vmr7ab\rDest\left = fDestX
        vmr7ab\rDest\top = fDestY
        vmr7ab\rDest\right = fDestX + fDestWidth
        vmr7ab\rDest\bottom = fDestY + fDestHeight
        
        vmr7ab\rSrc\left = iSrcX
        vmr7ab\rSrc\top = iSrcY
        vmr7ab\rSrc\right = iSrcWidth + iSrcX
        vmr7ab\rSrc\bottom = iSrcHeight + iSrcY 
        
        MemDC=CreateCompatibleDC_(0)
        
        vmr7ab\hdc = MemDC
        vmr9ab\hdc = MemDC
        
        oldObj = SelectObject_(MemDC,ImageID(Image))
        
        If *obj\pVMR9Mixer
          If *obj\pVMR9Mixer\SetAlphaBitmap(vmr9ab) = #S_OK
            bResult = #True  
          EndIf         
        EndIf
        
        If *obj\pVMR7Mixer
          If *obj\pVMR7Mixer\SetAlphaBitmap(vmr7ab) = #S_OK
            bResult = #True
          EndIf
        EndIf    
        SelectObject_(MemDC, oldObj)
        DeleteDC_(MemDc)
      EndIf
    EndIf
  EndIf
  ProcedureReturn bResult
EndProcedure

Procedure DShow_RemoveVMRImage(*obj.DSHOW_MEDIABASE)
  Protected bResult = #False, vmr9ab.VMR9AlphaBitmap, vmr7ab.VMRALPHABITMAP
  
  If *obj
    
    If *obj\bIsRenderlessVMR9
      
      If *obj\pImagePresenter
        If *obj\pImagePresenter\m_hMutex
          LockMutex(*obj\pImagePresenter\m_hMutex)
        EndIf  
      EndIf      
      
      If *obj\OverlayImage
        FreeImage(*obj\OverlayImage)    
      EndIf
      *obj\OverlayImage =  #Null
      If *obj\OverlayTexture
        *obj\OverlayTexture\Release()
      EndIf  
      *obj\OverlayTexture = #Null        
      *obj\OverlayCreated = #False
      
      If *obj\pImagePresenter
        If *obj\pImagePresenter\m_hMutex
          UnlockMutex(*obj\pImagePresenter\m_hMutex)
        EndIf  
      EndIf     
      bResult = #True
    Else
      
      vmr9ab.VMR9AlphaBitmap
      vmr9ab\dwFlags=#VMR9AlphaBitmap_Disable 
      
      vmr7ab.VMRALPHABITMAP
      vmr7ab\dwFlags=#VMRBITMAP_DISABLE
      
      If *obj\pVMR9Mixer
        If *obj\pVMR9Mixer\SetAlphaBitmap(vmr9ab) = #S_OK
          bResult = #True  
        EndIf
      EndIf
      
      If *obj\pVMR7Mixer
        If *obj\pVMR7Mixer\SetAlphaBitmap(vmr7ab) = #S_OK
          bResult = #True
        EndIf
      EndIf    
    EndIf
  EndIf
  ProcedureReturn bResult  
EndProcedure

;Only works with own allocator!!!
Procedure DShow_EnableRenderlessVMR9Border(*obj.DSHOW_MEDIABASE, bEnableBorder, BorderColor)
  Protected bResult = #False
  If *obj  
    If *obj\bIsRenderlessVMR9
      
      If *obj\pImagePresenter
        If *obj\pImagePresenter\m_hMutex
          LockMutex(*obj\pImagePresenter\m_hMutex)
        EndIf  
      EndIf    
      
      *obj\bRenderlessVMR9DrawBorder = bEnableBorder
      *obj\iRenderlessVMR9BorderColor = RGB(Blue(BorderColor),Green(BorderColor),Red(BorderColor))
      bResult = #True
      
      If *obj\pImagePresenter
        If *obj\pImagePresenter\m_hMutex
          UnlockMutex(*obj\pImagePresenter\m_hMutex)
        EndIf  
      EndIf 
      
    EndIf
  EndIf  
  ProcedureReturn bResult
EndProcedure

;Only works with own allocator!!!
Procedure DShow_SetVMRImageAlphaForRenderlessVMR9(*obj.DSHOW_MEDIABASE, fAlpha.f = 1.0)
  Protected bResult = #False, vmr9ab.VMR9AlphaBitmap, vmr7ab.VMRALPHABITMAP
  
  If *obj
    
    If *obj\bIsRenderlessVMR9
      
      If *obj\pImagePresenter
        If *obj\pImagePresenter\m_hMutex
          LockMutex(*obj\pImagePresenter\m_hMutex)
        EndIf  
      EndIf      
      
      *obj\OverlayAlpha = fAlpha
      
      If *obj\pImagePresenter
        If *obj\pImagePresenter\m_hMutex
          UnlockMutex(*obj\pImagePresenter\m_hMutex)
        EndIf  
      EndIf     
      bResult = #True
    Else
      
      ;       vmr9ab.VMR9AlphaBitmap
      ;       vmr9ab\dwFlags=0
      ;       vmr9ab\fAlpha = fAlpha
      ;       
      ;       vmr7ab.VMRALPHABITMAP
      ;       vmr7ab\dwFlags=0
      ;       vmr7ab\dwFlags = fAlpha
      ; 
      ;       If *obj\pVMR9Mixer
      ;         If *obj\pVMR9Mixer\UpdateAlphaBitmapParameters(vmr9ab) = #S_OK
      ;           bResult = #True  
      ;         EndIf
      ;       EndIf
      ;       
      ;       If *obj\pVMR7Mixer
      ;         If *obj\pVMR7Mixer\UpdateAlphaBitmapParameters(vmr7ab) = #S_OK
      ;           bResult = #True
      ;         EndIf
      ;       EndIf  
    EndIf
  EndIf
  ProcedureReturn bResult  
EndProcedure


Procedure DShow_EnableEraseBackground(*obj.DSHOW_MEDIABASE, bEnable.i)
  Protected bResult = #False
  If *obj
    *obj\bAllowEraseBackground = bEnable
    __MediaDebug("setting AllowEraseBackground "+Str(bEnable))
    bResult = #True
  EndIf
  ProcedureReturn bResult
EndProcedure


Procedure DShow_VMR7OverlayChckFailed()
  ProcedureReturn DSHOW_OVERLAY_FAILED
EndProcedure

; Procedure DShow_GetForceVMR7OverlaySuccess(*obj.DSHOW_MEDIABASE) ; returns True if Overlay with VMR7 is used
;   If *obj
;     ProcedureReturn *obj\ForceVMR7OverlaySuccess
;   EndIf 
;   ProcedureReturn #False
; EndProcedure  




;Example:
; hwnd = OpenWindow(0,0,0,800,600, "video test", #PB_Window_ScreenCentered|#PB_Window_SystemMenu|#PB_Window_SizeGadget)   
; 
; DShow_InitMedia()
; 
; File.s = "D:\Testvideos\AVI-UNCOMPRESSED-RGB.avi"
; 
; hMedia = DShow_LoadMediaEx( File,GadgetID(1),#RENDERER_VMR7, #True, #RENDERER_DEFAULT, #False)  
; DShow_PlayMedia(hMedia)
; 
; Repeat
;   DShow_ProcessMediaEvent(hMedia)
;   ev = WindowEvent()
; Until ev = #PB_Event_CloseWindow  
; DShow_FreeMedia(hMedia)


; IDE Options = PureBasic 5.42 LTS (Windows - x86)
; CursorPosition = 8
; FirstLine = 3
; Folding = ---------------------------
; EnableXP
; EnableCompileCount = 705
; EnableBuildCount = 0
; EnableExeConstant